normal macro
local n1
; this macro normalizes dx:ax after a multiply
; we will use 4000h for 1
       add   ax,0080h
       jnc   n1
       inc   dx
n1:
       mov   al,ah
       mov   ah,dl
       rcr   dh,1
       rcr   ax,1
       clc
       rcr   dh,1
       rcr   ax,1
       clc
       rcr   dh,1
       rcr   ax,1
      endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
start: jmp  main
;
pmax   dw  00800h
pmin   dw  00280h
qmax   dw  00800h
qmin   dw  00100h
xloc   dw  0
yloc   dw  0
delx   dw  0
dely   dw  0
xlast  dw  0
ylast  dw  0
main      proc     near
; throw us into graphics mode
          mov    ah,0
          mov    al,6
          int    10h
; calc dx and dy
       mov  dx,0
       mov  cx,640
       mov  ax,pmax
       sub  ax,pmin
       div  cx
       mov  delx,ax
       mov  dx,0
       mov  cx,200
       mov  ax,qmax
       sub  ax,qmin
       div  cx
       mov  dely,ax
;
       mov  cx,640
       mov  xloc,0
xloop:
; this is the loop to go through the columns
       push  cx
       mov   yloc,0
       mov   cx,200
yloop:
; loop through the rows
       push  cx
;
       call  setpq   ; sets up the si and di registers for p and q
       mov   cx,255
mloop:
       push  cx
; this is the mandelbrot loop
       call  mandel
        pop cx
       jc    donem
        loop mloop
; here if we did not blow up
;
;       jmp  done_loop
; here if we blew up
; got our guy
;
donem:
        test  cx,1
        jne   done_loop
        call  do_dot
done_loop:
       call  test_key
; bump the y
       inc   yloc
       pop   cx
       loop  yloop
       inc   xloc
       pop   cx
       loop  xloop
;
wait_more:
          mov    ah,0
          int    16h
          cmp    al,27
          jne    wait_more
wait_more2:
          mov    ah,0
          mov    al,2
          int    10h
          int  20h
mandel:
; routine to do the mandle calcs
; calculate the x
       mov  ax,xlast
       imul  xlast
       normal
       mov  bx,ax
       mov  ax,ylast
       imul  ylast
       normal
; ax is subtracted which may make the new xlast negative
       add  bx,si
       sub  bx,ax
;      cmp  bx,0
;      jg   by_neg
;      neg  bx
;y_neg:
; calc the y
       mov  ax,xlast
       imul  ylast
       normal
       shl  ax,1
       add  ax,di
; save the x and y
       mov  xlast,bx
       mov  ylast,ax
; now  calc the modulus
       mov  ax,ylast
       imul  ylast
       normal
       mov  bx,ax
       mov  ax,xlast
       imul  xlast
       normal
       add  ax,bx
       test ah,80h
       jnz  donem1
       clc
       ret
donem1:
       stc
       ret
point  db  128,64,32,16,8,4,2,1
do_dot:
; converts xloc and yloc to a position and plots it
          mov   ax,xloc
          mov   cx,8
          mov   dx,0
          div   cx
          mov   di,ax
          mov   bx,dx
          mov   dx,0b800h
          mov   ax,yloc
          test  ax,1
          jz    no_interlace
          add   dx,200h
no_interlace:
          mov   es,dx
          mov   dx,0
          mov   cx,80
          shr   ax,1
          mul   cx
          add   di,ax
          mov   al,point[bx]
          or    byte ptr es:[di],al
          ret
setpq:
; set up registers
       mov  si,pmin ; si will have the current p
       mov  ax,xloc
       mul  delx
       add  si,ax
       mov  di,qmin ; di will have the current q
       mov  ax,yloc
       mul  dely
       add  di,ax
       mov   xlast,0
       mov   ylast,0
       mov   bp,0   ; bp is the color
       ret
test_key:
; test for a keystroke
       mov  ax,0100h
       int  16h
       jnc  no_key
       mov  ah,0
       int  16h
       cmp  al,27
       jne  no_key
       jmp  wait_more2
no_key:
       ret
main      endp
cseg      ends
          end      start
