if1
   include c:cmacros.asm
endif
cseg segment byte public 'CODE'
       assume  cs:cseg,ds:cseg,es:cseg
extrn  sound:byte,print1:word,print2:word
extrn int17scs:word,int17sip:word,int17cs:word
extrn int17ip:word,printint:near
extrn intcs:word,intip:word,keyboard:near
extrn int5cs:word,int5ip:word,pscreen:near
extrn baud:byte,databits:byte,parity:byte,comport:byte
extrn epsone1:byte,prtsc:byte
extrn rows:byte,cols:byte,windx:byte,windy:byte,color:byte
extrn hidey:byte,hidex:byte,wsaveh:byte
extrn getwind:near,retwind:near,window2:byte
;
;
; save the interrupts here
interrupts  dd 128 dup(0)
old_psp  db  5ch dup(0)
memloc  dw  0
memory   db   16  dup(0)  ; memory control block
rowsu  equ 9
colsu  equ 55
windxu equ 0
windyu equ 11
coloru equ 1fh
hidexu equ 0
hideyu equ 21
windowu db  'ͻ'
        db  ' CLASER now un-installed. All TSR programs installed '
        db  ' after CLASER are also uninstalled. Any program      '
        db  ' running during the un-install procedure has been    '
        db  ' aborted.                                            '
        db  ' Copyright 1987 by Keith P. Graham                   '
        db  '                  238 Germonds Rd.               Ŀ '
        db  '                  W. Nyack, NY 10994             Ľ'
        db  ';  '
public   unres
unres proc near
; undo all of the damage
       push  cs
       push  cs
       pop   ds
       mov   bx,memloc
       mov   es,bx
       mov   di,0
       lea   si,memory
       mov   cx,8
       cld
rep    movsw
       pop  ds
       mov   ax,0
       mov   es,ax
       mov   cx,256
       lea   si,interrupts
       mov   di,0
       cld
       cli
rep    movsw
       sti
       pop  es
; mov the old psp in
       mov  cx,5ch
       lea  si,old_psp
       mov  di,0
       cld
rep  movsb
; set the current psp
       mov  bx,cs
       mov  ah,50h
       mov  al,0
       int  21h
; shrink down all memory
       mov  ah,4ah
       mov  bx,0
       int  21h
; now clear the screen
       call  cls
        dowindow u
       mov  ah,4ch
       mov  al,-1
       int  21h
       int  20h
cls:
        mov  al,0
        mov  ah,7
        mov  cx,0
        mov  dx,184fh
        mov  bh,07h
        mov  bl,0
        int  10h
        ret
unres  endp
;
public setres
setres  proc  near
        call  cls
        mov  ah,2
        mov  bx,0
        mov  dx,0
        int  10h
        mov  ah,9
        lea  dx,version
        int  21h
; first check the printer interrupt by asking for a character
        mov  ah,99
        mov  al,0
        int  17h
        cmp  ax,0f9f9h
        jne  check_vers
        lea  dx,mess2
        mov  ah,9
        int  21h
        int  20h
check_vers:
        mov  ah,30h
        int  21h
        cmp  al,2
        jge  okinstall
        lea  dx,mess3
        mov  ah,9
        int  21h
        int  20h
okinstall:
; check the parse line
        mov  al,byte ptr ds:[5dh]
        cmp  al,' '
        jne  set_laser_p
emess1:
        lea  dx,error1
        mov  ah,9
        int  21h
        int  20h
set_laser_p:
        cmp  al,'1'
        je  set_com1
        cmp  al,'2'
        je  set_com2
        cmp  al,'n'
        je  set_none
        cmp  al,'N'
        je  set_none
        jmp emess1
set_com1:
        mov print1,0
        mov print2,0fffh
        mov  epsone1,1
        mov  comport,0
        mov  prtsc,1
        mov  al,parity
        or   al,baud
        or   al,databits
        mov  ah,0
        mov  dl,comport
        mov  dh,0
        int  14h
        jmp set_sound
set_com2:
        mov  comport,1
        mov print1,1
        mov print2,0fffh
        mov  epsone1,1
        mov  prtsc,1
        mov  al,parity
        or   al,baud
        or   al,databits
        mov  ah,0
        mov  dl,comport
        mov  dh,0
        int  14h
        jmp set_sound
set_none:
        mov print1,0fffh
        mov print2,0fffh
set_sound:
; is the sound on or off
        mov al,byte ptr ds:[6dh]
        cmp  al,'q'
        je  quiet
        cmp  al,'Q'
        jne  noisey
quiet:
        mov  sound,1
noisey:
; save all of the interrupts
        push  cs
        pop   es
        push  ds
        mov   si,0
        lea   di,interrupts
        cld
        mov   cx,256
        mov    ds,si
rep     movsw
        pop   ds
;
; now get the memory control block for this guy
;
        push  ds
        mov   bx,cs
        dec   bx
        mov   memloc,bx
        mov   ds,bx
        lea   di,memory
        mov   si,0
        mov   cx,8
        cld
rep     movsw
        pop   ds
; save the PSP
        lea di,old_psp
        mov  si,0
        mov  cx,5ch
rep   movsb
; get the keyboard interrupt
        mov   ax,3509h
        int   21h
        mov   intcs,es
        mov   intip,bx
        mov   ah,25h
        mov   al,9
        lea   dx,keyboard
        int   21h
; now set the printer port interrupt
        mov   ax,3517h
        int   21h
        mov   int17scs,es
        mov   int17sip,bx
        mov   int17cs,es
        mov   int17ip,bx
        mov   ah,25h
        mov   al,17h
        lea   dx,printint
        int   21h
; now set the prtsc interrupt (5)
        mov   ax,3505h
        int   21h
        mov   int5cs,es
        mov   int5ip,bx
        mov   ah,25h
        mov   al,5h
        lea   dx,pscreen
        int   21h
        mov   ax,cs
        mov   ds,ax
        mov   es,ax
        lea   si,window2+9
        lea   di,w1l2+24
        mov   cx,11
        cld
rep     movsb
        dowindow 1
        lea   dx,setres
        add   dx,15
        mov   cl,4
        shr   dx,cl
        mov   ah,31h
        mov   al,0
        int   21h
        int   20h
version db  'CLASER.COM version 2.3 Nov. 1, 1987',13,10,10,'$'
rows1  equ 12
cols1  equ 55
windx1 equ 0
windy1 equ 5
color1 equ 1fh
hidex1 equ 0
hidey1 equ 18
window1 db  'ͻ'
w1l2    db  ' CLASER now resident.               installed        '
        db  ' Version 2.3 November 1, 1987                        '
        db  ' Press ALT-LEFT SHIFT-L to control Laser-Jet printer '
        db  ' Press ALT-LEFT SHIFT-P for screen dump              '
        db  ' Copyright 1987 by Keith P. Graham                   '
        db  '  Continued use requires reqistration.               '
        db  '  Please send $35.00 to:                             '
        db  '                  Keith P. Graham                    '
        db  '                  238 Germonds Rd.               Ŀ '
        db  '                  W. Nyack, NY 10994             Ľ'
        db  ';  '
mess2   db  'LaserJet Control Program is Already Resident',13,10,'$'
mess3   db  'Wrong DOS version, Must be 2.0 or later',13,10
error1  db  13,10,'The proper form of the CLASER command is:',13,10
        db  'CLASER n q',13,10
        db  'where n = 1 for laser (LPT1:) attached to com1:',13,10
        db  '      n = 2 for laser (LPT1:) attached to com2:',13,10
        db  ' or   n = N for neither.',13,10
        db  ' If 1 or 2 is selected CLASER will set Epson FX',13,10
        db  ' emulation on and enable graphic screen dumps.',13,10
        db  ' If the second variable is Q then claser ',13,10
        db  ' runs in Quiet mode.',13,10,10,'$'
setres  endp
cseg    ends
        end
