passthru = 0  ; 1 is true which means MASM will create the passthroug
              ; version.
;
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
times   db  -2
stack   dw   256  dup(0)
stackl  dw   256  dup(0)
int20      dd  0
int20ip   equ word ptr int20
int20cs   equ word ptr int20 + 2
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
int24      dd  0
int24ip   equ word ptr int24
int24cs   equ word ptr int24 + 2
int27      dd  0
int27ip   equ word ptr int27
int27cs   equ word ptr int27 + 2
savesp   dw  0  ; used by the load program
savess   dw  0
savespl  dw  0  ; local used by int21 4b program
savessl  dw  0
semaphore db  0
cursor    dw  0
cursmode  dw  0
bhpage    db  0
reverse   db  30h
result    db  0
old_result db 0
mess1    db  "We're back",13,10,10,'$'
;
; these are critical error strings
;
; the type of error is first
; the erc is returned in ah, if it is < 128 then the disk error
; codes are listed below al has the drive letter
; add al to "A" to get the drive in question
;
erctype dw  erct0,erct1,erct2,erct3,erct4,erct5,erct6,erct7,erct8,erct9
        dw  7 dup(erct10)
erct0 db 'Error Reading DOS system files ',0
erct1 db 'Error Writing DOS system files ',0
erct2 db '   Error Reading FAT table  ',0
erct3 db '   Error Writing FAT table  ',0
erct4 db '  Error Reading Directory  ',0
erct5 db '  Error Writing Directory  ',0
erct6 db ' Error Reading Disk Data Area ',0
erct7 db ' Error Writing Disk Data Area ',0
erct8 db '   Corrupted Fat Table',0
erct9 db ' Character Device Error',0
erct10 db '  Unknown Device Error',0
;
; di has an error code which is used also
;
ercode  dw  erc0,erc1,erc2,erc3,erc4,erc5,erc6,erc7,erc8,erc9,erc10
        dw  7 dup(erc13)
erc0 db '    Write protect error ',0
erc1 db '   Unknown or Invalid Drive ',0
erc2 db '     Device not ready ',0
erc3 db '   Unknown command request ',0
erc4 db '       CRC error ',0
erc5 db ' Bad request structure length ',0
erc6 db '      Seek Error ',0
erc7 db '     Unknown Media ',0
erc8 db '   Sector not found ',0
erc9 db '  Printer reports out of paper ',0
erc10 db '     Write error ',0
erc11 db '     Read error ',0
erc12 db '  General nonspecific screw up ',0
erc13 db '    Unknown Error Code',0
entry_ax dw  0
entry_di dw  0
dhead    dd 0
dheadbp  equ word ptr dhead+2
dheadsi  equ word ptr dhead
;
;
; returns are: 0=ignore,1=retry,2=terminate,3=fail in al
;
; window data
;
upleft  equ  201
upright equ  187
loleft  equ  200
loright equ  188
horiz   equ  205
vert    equ  186
;
save    dw   9*72 dup(0)   ;window buffer
menu    db   8   ;height
        db   38   ;width
        db   5    ;x location
        db   2     ;y location
        db   07h  ; color
; menu text
        db   '      Critical Errror Handler',13,10
        db   ' Copyright 1988 by Keith P. Graham',13,10
        db   '   Device in error = '
pdev    db   '           ',13,10
perr1   db   '                                   ',13,10
perr2   db   '                                   ',13,10
        db   '  '
; returns are: 0=ignore,1=retry,2=terminate,3=fail in al
pignore db   'Ignore   '  ; 9 bytes for each
pretry  db   'Retry    '
pabort  db   'Abort    '
pfail   db   'Fail     '
        db   0  ; screens end with a zero
h       db  0
w       db  0
he      db  0
we      db  0
x       db  0
xe      db  0
y       db  0
ye      db  0
color   db  0
hide    dw  0
savesi  dw  0
t       dw  0
;
;
; this data is used by the passthru program only
;
if passthru
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
START        PROC        far
int_20:
        mov  cs:times,1
        jmp  cs:int20
int_27:
        mov  cs:times,1
        jmp  cs:int27
crit_err:
; this is the routine for processing the critial error
        push  ax
        and   ah,10000111b
        mov   cs:entry_ax,ax
        pop   ax
        mov   cs:entry_di,di
        mov   cs:dheadbp,bp
        mov   cs:dheadsi,si
        mov   cs:result,15
        call  cwindow
        cmp   cs:result,15
        je    old_24
        mov   al,cs:result
        cmp   al,2  ; abort
        jne   other_return
        mov   cs:times,-1
other_return:
        iret
old_24:
        jmp   cs:int24
dos_int:
; if the exec function is called we have to reset int 24h
      cmp   ah,4bh
      jne   try_0
      mov   cs:times,0
      jmp   cs:int21
try_0:
      cmp   ah,0
      jne   try_31
      mov   cs:times,0
      jmp   cs:int21
try_31:
      cmp   ah,31h ; exit with error code
      jne   try_4c
      mov   cs:times,0
      jmp   cs:int21
try_4c:
      cmp   ah,4ch ; exit and remain resident?
      jne   try_25
      mov   cs:times,0
      jmp   cs:int21
;
; whenever we execute a program we have to reset the count for reset
; of 2524h
try_25:
; this is a lookout for the crit err loader
      cmp   ax,2524h    ; check for set interrupt
      je    got_25h
go_normal:
      jmp   cs:int21
got_25h:
      inc   cs:times
      cmp   cs:times,3
      jge   go_normal
; have a new reset, dx has the ip and ds has the cs
;
; made it
        mov   cs:int24cs,ds
        mov   cs:int24ip,dx
      push  ax
      push  dx
      push  ds
      push  es
; set up int 24h
      mov   ax,cs
      mov   ds,ax
      mov   es,ax
;
        mov   ah,25h
        mov   al,24h
        lea   dx,crit_err
        pushf
        call  cs:int21
;
;
; now clean up the stack
        pop   es
        pop   ds
        pop   dx
        pop   ax
        iret
;
;
START        ENDP
windows  proc  near
cwindow:
; we got in - make window and get to work
; save all
          push   ax
          mov    cs:semaphore,1
          mov    cs:savessl,ss
          mov    cs:savespl,sp
          mov    ax,cs
          cli
          mov    ss,ax
          mov    sp,offset cs:stackl+510
          sti
; push em
          push   bx
          push   cx
          push   dx
          push   bp
          push   si
          push   di
          push   ds
          push   es
          mov    ax,cs
          mov    ds,ax
          mov    es,ax
          call   do_menu
exit_res:
; do the opposite of the save
          pop  es
          pop  ds
          pop  di
          pop  si
          pop  bp
          pop  dx
          pop  cx
          pop  bx
          cli
          mov  ss,cs:savessl
          mov  sp,cs:savespl
          sti
          mov     cs:semaphore,0
          pop  ax
          ret
;
; do menu
do_menu:
; set up the error codes
          lea    di,perr1
          mov    cx,35
          mov    al,' '
          cld
rep    stosb
          lea    di,perr2
          mov    cx,35
          mov    al,' '
          cld
rep    stosb
          lea    di,pdev
          mov    cx,11
          mov    al,' '
          cld
rep    stosb
; set up the device
; now the device name
          push ds
          lds  si,dhead
; ds:si points to the device head
; find out what kind of device it is.
          test word ptr ds:[si+4],8000h
          jnz  char_dev
          lea  di,pdev
          cld
          mov  ax,'ID'
          stosw
          mov  ax,'KS'
          stosw
          mov  ah,byte ptr es:entry_ax
          add  ah,'A'
          mov  al,' '
          stosw
          mov  al,':'
          stosb
; lastley check to see if it is a corrunpted fat problem
          test byte ptr es:entry_ax+1,80h ;is ah bit 1?
          jz   non_fat
; non disk error, but still a disk device = bad fat
          mov  byte ptr es:entry_ax+1,8
non_fat:
          jmp  pd_loope
char_dev:
          mov  byte ptr es:entry_ax+1,9
; here we move the device name into pdev
          lea   di,pdev
          add   si,10
          cld
pd_loop:
          lodsb
          cmp  al,0
          je   pd_loope
          stosb
          loop pd_loop
pd_loope:
          pop  ds
; get the error and put it into perr1
          mov    bx,entry_ax
          mov    bl,bh
          mov    bh,0
          shl    bx,1
          mov    si,erctype[bx]
          lea    di,perr1
          cld
pe_loop1:
          lodsb
          cmp   al,0
          je    pe_loope1
          stosb
          loop  pe_loop1
pe_loope1:
          mov    bx,entry_di
          mov    bh,0
          shl    bx,1
          mov    si,ercode[bx]
          lea    di,perr2
          cld
pe_loop2:
          lodsb
          cmp   al,0
          je    pe_loope2
          stosb
          loop  pe_loop2
pe_loope2:
;
;
;
         mov     al,old_result
         mov     result,al
;
;
          lea    si,menu
;
          call   save_si
          call   save_cursor
          call   save_window
          call   put_mess
          call   put_reverse
          call   hide_cursor
; clean out the keyboard interrupt
clear_kbd:
          mov    ah,1
          int    16h
          jz     get_key
          mov    ah,0
          int    16h
          jmp    clear_kbd
bad_key:
          call   blop
; wait for keystroke
get_key:
          mov     ah,0
          int     16h
          cmp     al,27
          je      proc_esc
          cmp     ah,1eh   ; A
          je      do_a
          cmp     ah,13h   ; R
          je      do_r
          cmp     ah,17h   ; I
          je      do_i
          cmp     ah,21h   ; F
          je      do_f
          cmp     ah,4bh   ; left arrow
          je      do_left
          cmp     ah,4dh   ;right arrow
          je      do_right
          cmp     ah,1ch   ; return
          jne     bad_key
          jmp     do_return
proc_esc:
; this processes escape, the normal 24 will be executed
          mov    result,15
          jmp    exit_W
; returns are: 0=ignore,1=retry,2=terminate,3=fail in al
do_a:
         mov     al,result
         mov     old_result,al
         mov     result,2
         call    put_reverse
         jmp     get_key
do_r:
         mov     al,result
         mov     old_result,al
         mov     result,1
         call    put_reverse
         jmp     get_key
do_i:
         mov     al,result
         mov     old_result,al
         mov     result,0
         call    put_reverse
         jmp     get_key
do_f:
         mov     al,result
         mov     old_result,al
         mov     result,3
         call    put_reverse
         jmp     get_key
do_left:
         mov     al,result
         mov     old_result,al
         dec  al
         cmp  al,0
         jge  ok_left
         mov  al,3
ok_left:
         mov     result,al
         call    put_reverse
         jmp     get_key
do_right:
         mov     al,result
         mov     old_result,al
         inc  al
         cmp  al,4
         jl   ok_right
         mov  al,0
ok_right:
         mov     result,al
         call    put_reverse
         jmp     get_key
do_return:
         mov     al,result
         mov     old_result,al
exit_w:
          call    restore_window
          call    restore_cursor
          ret
;
;
put_reverse:
; puts a a normal image on old_result and a reverse on result
;
;  calculate the location of the first message
          mov    dh,menu+3  ;y
          add    dh,6
          mov    dl,menu+2  ;x
          add    dl,3
          push   dx
          mov    al,old_result
          mov    cl,9
          mul    cl
; color normal the old_result line
          mov    cx,6
          add    dl,al
old_r_loop:
          push   cx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
; get stuff
          mov    ah,8
          mov    bx,0
          int    10h
; put stuff
          mov    bl,07
          mov    ah,9
          mov    bh,0
          mov    cx,1
          int    10h
          inc    dl
          pop    cx
          loop   old_r_loop
; now the same thing with new result location
          pop   dx
          mov    al,result
          mov    cl,9
          mul    cl
; color normal the old_result line
          mov    cx,6
          add    dl,al
          push  dx
r_loop:
          push   cx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
; get stuff
          mov    ah,8
          mov    bx,0
          int    10h
; put stuff
          mov    bl,reverse
          mov    ah,9
          mov    bh,0
          mov    cx,1
          int    10h
          inc    dl
          pop    cx
          loop   r_loop
; now the relocat the cursor
          pop   dx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
          ret
;
;
;
;
save_si:
;
          mov    savesi,si
          cld
          lodsb
      mov     h,al
      dec     al
      dec     al
      mov     he,al
          lodsb
      mov     w,al
      dec     al
      dec     al
      mov     we,al
          lodsb
      mov     x,al
          dec al
          add al,w
      mov     xe,al
          lodsb
      mov     y,al
          dec al
          add al,h
      mov     xe,al
          lodsb
      mov     color,al
      mov     t,si
      ret
put_mess:
; puts a message to the screen
          cld
          call   blip
          mov    si,t
          mov    dh,y
          mov    dl,x
          inc    dh
          inc    dl
          mov    cx,0     ; cl is column
mloop0:
          push   cx
          push   dx
mloop1:
          push   cx
          push   dx
          cmp    ch,he
          jge    end_put_mess
          lodsb
          cmp    al,0
          je     end_put_mess
          cmp    al,10
          je     ignore_char
          cmp    al,13
          je     new_line
          cmp    cl,we
          jge    ignore_char
; got the character put it on the screen
; locate the cursor
          push   ax
          mov    ah,2
          mov    bx,0
          int    10h
          pop    ax
          mov    ah,10
          mov    cx,1
          int    10h
          pop    dx
          pop    cx
          inc    dl
          inc    cl
          jmp    mloop1
new_line:
          pop    dx
          pop    cx
          pop    dx
          pop    cx
          inc    dh
          inc    ch
          jmp    mloop0
ignore_char:
          pop    dx
          pop    cx
          jmp    mloop1
end_put_mess:
          pop    dx
          pop    cx
          pop    dx
          pop    cx
          ret
restore_window:
; puts the old window back
;setup cursor at x,y
          mov    dh,y
          mov    dl,x
; set up save place
          lea    si,save
          cld
; the current cursor position is in dx
          mov    cl,h
          mov   ch,0
rloop1:
          push   cx
          push   dx
          mov    cl,w
          mov   ch,0
rloop2:
          push   cx
          push   dx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
          lodsw
; put stuff
          mov    bl,ah
          mov    ah,9
          mov    bh,0
          mov    cx,1
          int    10h
          pop    dx
          pop    cx
          inc    dl
          loop   rloop2
          pop    dx
          pop    cx
          inc    dh
          loop   rloop1
          ret
restore_cursor:
; restore cursor
          mov     dx,cursor
          mov     ah,2
          mov     bx,0
          int     10h
save_cursor:
; get and save current x,y position
          mov   ah,3
          mov   bx,0
          int   10h
          mov   cursor,dx
          ret
save_window:
;setup cursor at x,y
          mov    dh,y
          mov    dl,x
; set up save place
          lea    di,save
          cld
; the current cursor position is in dx
          mov    cl,h
          mov    ch,0
wloop1:
          push   cx
          push   dx
          mov    cl,w
          mov   ch,0
wloop2:
          push   cx
          push   dx
; locate
          mov    ah,2
          mov    bx,0
          int    10h
; get stuff
          mov    ah,8
          mov    bx,0
          int    10h
; ax has the attrib and byte
          stosw
; find out what to put in al
          push   dx
          mov    al,20h
          cmp    dh,y  ; row
          je     top_row
          inc    dh
          sub    dh,h
          cmp    dh,y
          je     bot_row
          cmp    dl,x
          je     left_col
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     right_col
          jmp    end_loop1
left_col:
right_col:
          mov    al,vert
          jmp    end_loop1
bot_row:
          mov    al,horiz
          cmp    dl,x
          je     bot_left
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     bot_right
          jmp    end_loop1
bot_right:
          mov    al,loright
          jmp    end_loop1
bot_left:
          mov    al,loleft
          jmp    end_loop1
top_row:
          mov    al,horiz
          cmp    dl,x
          je     top_left
          inc    dl
          sub    dl,w
          cmp    dl,x
          je     top_right
          jmp    end_loop1
top_right:
          mov    al,upright
          jmp    end_loop1
top_left:
          mov    al,upleft
;          jmp    end_loop1
end_loop1:
          pop    dx
; place the correct character and attribute at the position
          mov    ah,9
          mov    bl,color
          mov    cx,1
          mov    bh,0
          int    10h
          pop    dx
          pop    cx
          inc    dl
          loop   jmp_wloop2
          jmp    by_wloop2
jmp_wloop2:
          jmp    wloop2
by_wloop2:
          pop    dx
          pop    cx
          inc    dh
          loop   jmp_wloop1
          jmp    by_wloop1
jmp_wloop1:
          jmp    wloop1
by_wloop1:
; have to hid the cursor
          dec    dh
          dec    dh
          add    dl,w
          dec   dl
          dec    dl
          mov    hide,dx
          ret
hide_cursor:
          mov    dx,hide
          mov    ah,2
          mov    bx,0
          int    10h
          mov    bl,color
          and    bl,0f0h
          mov    al,bl
          mov    cl,4
          shr    al,cl
          or     bl,al
          mov    al,0
          mov    ah,9
          mov    cx,1
          mov    bh,0
          int    10h
          ret
windows  endp
getcurs   proc  near
; get video state
          mov  reverse,30h
          mov ah,15
          int 10h
          cmp al,7
          jne not_mono
          mov  reverse,78h
not_mono:
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
; the tone routines produce glisandos based on the value of si
blip    proc  near
        push  si
        mov   si,30
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
        push  si
        mov   si,-30
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp
setpass  proc  near
; set up a local stack
        lea  sp,stack+510
;
; redirect interrupts here
;
        push  es
        mov   ax,3520h
        int   21h
        mov   int20cs,es
        mov   int20ip,bx
        pop   es
        mov   ah,25h
        mov   al,20h
        lea   dx,int_20
        int   21h
;
        push  es
        mov   ax,3527h
        int   21h
        mov   int27cs,es
        mov   int27ip,bx
        pop   es
        mov   ah,25h
        mov   al,27h
        lea   dx,int_27
        int   21h
;
        push  es
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        pop   es
        mov   ah,25h
        mov   al,21h
        lea   dx,dos_int
        int   21h
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   pushf
   call  cs:int21
;  int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int21
        mov   ah,25h
        mov   al,21h
        int   21h
        pop   ds
        push  ds
        lds   dx,int20
        mov   ah,25h
        mov   al,20h
        int   21h
        pop   ds
        int   20h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        pushf
        call  cs:int27
endif
setpass  endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
