cSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; data areas
  db 'Laser Graphics. (c) Copyright 1985,1987 by Keith P. Graham'
  db ' 238 Germonds Road, West Nyack, NY 10994'
cursor   dw  0
cursmode dw  0
bhpage   db  0
ahmode   db  0
int5      dd  0
int5ip   equ word ptr int5
int5cs   equ word ptr int5 + 2
semaphore db  0
resol     db  '*t75R'
startrast db  '*r0A'
transrast db  '*b80W'
endrast   db  '*rB'
printer   dw  0
START        PROC        NEAR
pscreen:
        push ax
        push bx
        cmp  cs:semaphore,0
        jne  gotoint5
;determine if its a graphics screen
        mov  ah,15
        int  10h
; ah has mode
; al has coloumns
; bh has page
        cmp  al,4
        jl   gotoint5
        cmp  al,6
        jg   gotoint5
        jmp  gotac
gotoint5:
        pop  bx
        pop  ax
        cli
        jmp  cs:int5
gotac:
; save the world
        sti
        push cx
        push dx
        push si
        push di
        push ds
        push es
; get the p so others won't be messed up
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
        mov   semaphore,1
; first get the cursor location
        call getcurs
nochar:
        call blip
        call crlf
startdump:
; we have a dump, the page is bhpage and the mode is in ahmode
;
; send raster graphics mode command to printer
;
; set up start of color screen in es
; and length in cx
;
        mov  cx,100   ; number of graphics rows
        mov  bx,0     ; line number currently printing
        mov  ax,0b800h
        mov  es,ax
        mov  dx,printer
getrow:
        push cx
        call  pset
        mov  cx,80
        mov  bx,0
gr1:
        mov  al,byte ptr es:[bx]
        mov  ah,0
        int  17h
        inc  bx
        loop gr1
        call eset
        call pset
        mov  cx,80
        mov  bx,0
gr2:
        mov  al,byte ptr es:[bx]
        mov  ah,0
        int  17h
        inc  bx
        loop gr2
        call eset
        call pset
        mov  cx,80
        mov  bx,0
gr3:
        mov  al,byte ptr es:[bx+02000h]
        mov  ah,0
        int  17h
        inc  bx
        loop gr3
        call eset
        call pset
        mov  cx,80
        mov  bx,0
gr4:
        mov  al,byte ptr es:[bx+02000h]
        mov  ah,0
        int  17h
        inc  bx
        loop gr4
        call eset
        call xorit
        pop  cx
        mov  ax,es
        add  ax,5
        mov  es,ax
        loop getrow
        mov  cx,100   ; number of graphics rows
        mov  bx,0     ; line number currently printing
        mov  ax,0b800h
        mov  es,ax
unxor:
        push cx
        call xorit
        mov  ax,es
        add  ax,5
        mov  es,ax
        pop  cx
        loop unxor
exit_prog:
        call crlf
        call blop
        pop  es
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        mov   cs:semaphore,0
        iret
START        ENDP
xorit   proc  near
        mov  cx,80
        mov  bx,0
xr4:
        xor  byte ptr es:[bx],0ffh
        xor  byte ptr es:[bx+02000h],0ffh
        inc  bx
        loop xr4
       ret
xorit  endp
eset   proc  near
        mov  cx,4
        lea  si,endrast
        mov  dx,printer
eloop:
        lodsb
        mov  ah,0
        int  17h
        loop  eloop
        ret
eset    endp
pset    proc  near
        mov  cx,17
        lea  si,resol
        mov  dx,printer
tloop:
        lodsb
        mov  ah,0
        int  17h
        loop  tloop
        ret
pset    endp
crlf    proc  near
; print  13,10 to printer
        mov  dx,printer
        mov  al,13
        mov  ah,0
        int  17h
        mov  al,10
        mov  ah,0
        int  17h
        ret
crlf    endp
getcurs   proc  near
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ahmode,ah
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
blip    proc  near
        mov   bx,250  ; starting freq
        mov   cx,750  ; ending frequency
        mov   dx,3    ; tone rate
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    si,32
        cmp    bx,cx
        jle    i1
        neg    si
i1:
        mov    cx,bx
 ; set frequency
        push   dx
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
        pop    dx
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
; mov   cx,dx
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        jg     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blip    endp
blop    proc  near
        mov   bx,650  ; starting freq
        mov   cx,150  ; ending frequency
        mov   dx,3    ; tone rate
; turn on tone
o0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    si,32
        mov    cx,bx
 ; set frequency
        push   dx
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
        pop    dx
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
; mov   cx,dx
o2:     loop o2
        pop    bx
        pop    cx
        cmp    bx,cx
        jl     op3
        sub    bx,si
        jmp    o0
op3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        ret
blop    endp
setres  proc  near
; get the printer interrupt
startres:
; check to see if there is command line
        cld
        mov   cl,byte ptr ds:[80h]
        mov   ch,0
        cmp   cx,1
        jg    ok_command1
bad_command:
        lea   dx,err1
        mov   ah,9
        int   21h
        int  20h
ok_command1:
        mov   di,81h
        mov   printer,0
        mov   al,'1'
        push  cx
repne   scasb
        pop   cx
        je    printit
        mov   di,81h
        mov   printer,1
        mov   al,'2'
        push  cx
repne   scasb
        pop   cx
        je    printit
        mov   di,81h
        mov   printer,2
        mov   al,'3'
        push  cx
repne   scasb
        pop   cx
        je    printit
        jmp   bad_command
printit:
        mov   ax,3505h
        int   21h
        mov   int5cs,es
        mov   int5ip,bx
        mov   ah,25h
        mov   al,5h
        lea   dx,pscreen
        int   21h
        lea   dx,mess1
        mov   ah,9
        int   21h
        lea   dx,startres
        int 27h
mess1   db  'H-P Laser-Jet Graphics Screen dump',13,10
        db  'Copyright 1985,1987 by Keith P. Graham',13,10
        db  '$'
err1    db 'LG copyright 1987 by Keith P. Graham',13,10
        db 'Enter:',13,10
        db 'LG n',13,10
        db 'Where n is the printer number from 1 to 3',13,10,'$'
setres  endp
CSEG        ENDS
        END        ENTPT
