;Constants
clear		equ	256
eof		equ	257
first_free	equ	258
maxmax		equ	4096


;Hash table entry
hash_rec	struc
next	dw	?			; prefix code
char	db	?			; suffix char
hash_rec	ends


;Start coding
cseg	segment para public 'CODE'
	assume	cs:cseg,ds:cseg,ss:cseg,es:cseg
extrn   targ_buff:word,targ_buff_size:word
extrn   curr_buff:word,curr_buff_size:word,hash_seg:word
;
cur_code	dw	?
old_code	dw	?
in_code		dw	?
free_code	dw	first_free
stack_count	dw	0
nbits		dw	9
max_code	dw	512
fin_char	db	?
k		db	?

masks		dw	1ffh,3ffh,7ffh,0fffh
bit_offset	dw	0

output_offset	dw	0


decompress	proc	near
public decompress
        mov     cs:stack_count,0
        mov     cs:bit_offset,0
        mov     cs:max_code,512
        mov     cs:nbits,9
        mov     cs:free_code,first_free
        push    ds
        push    es
        mov     es,targ_buff
        mov     ds,curr_buff
        mov     di,0
l1:	call	read_code		;Get a code
	cmp	ax,eof			;End of file?
	jne	l2			;no
        mov     cx,di
        pop     es
        pop     ds
        mov     targ_buff_size,cx
    	ret				;done
l2:	cmp	ax,clear		;Clear code?
	jne	l7			;no
	call	init_tab		;Initialize table
	call	read_code		;Read next code
	mov	cs:cur_code,ax		;Initialize variables
	mov	cs:old_code,ax
	mov	cs:k,al
	mov	cs:fin_char,al
	mov	al,cs:k
	stosb
	jmp	l1			;Get next code
l7:	mov	cs:cur_code,ax		;Save new code
	mov	cs:in_code,ax
	mov	es,cs:hash_seg		;Point to hash table
	cmp	ax,cs:free_code		;Code in table? (k<w>k<w>k)
	jl	l11			;yes
	mov	ax,cs:old_code		;get previous code
	mov	cs:cur_code,ax		;make current
	mov	al,cs:fin_char		;get old last char
	push	ax			;push it
	inc	cs:stack_count
l11:	cmp	cs:cur_code,255		;Code or character?
	jle	l15			;Char
	mov	bx,cs:cur_code		;Convert code to address
	call	index
	mov	al,es:2[bx]		;Get suffix char
	push	ax			;push it
	inc	cs:stack_count
	mov	ax,es:[bx]		;Get prefix code
	mov	cs:cur_code,ax		;Save it
	jmp	l11			;Translate again
l15:	 		;Restore seg reg
        mov     es,cs:targ_buff
	mov	ax,cs:cur_code		;Get code
	mov	cs:fin_char,al		;Save as final, k
	mov	cs:k,al
	push	ax			;Push it
	inc	cs:stack_count
	mov	cx,cs:stack_count		;Pop stack
	jcxz	l18			;If anything there
l17:	pop	ax
	stosb
	loop	l17
l18:	mov	cs:stack_count,cx		;Clear count on stack
	call	add_code		;Add new code to table
	mov	ax,cs:in_code		;Save input code
	mov	cs:old_code,ax
	mov	bx,cs:free_code		;Hit table limit?
	cmp	bx,cs:max_code
	jl	l23			;Less means no
	cmp	cs:nbits,12		;Still within twelve bits?
	je	l23			;no (next code should be clear)
	inc	cs:nbits			;Increase code size
	shl	cs:max_code,1		;Double max code
l23:	jmp	l1			;Get next code
decompress	endp	

read_code	proc	near
	mov	ax,cs:bit_offset		;Get bit offset
	add	ax,cs:nbits		;Adjust by code size
	xchg	cs:bit_offset,ax		;Swap
	mov	cx,8			;Calculate byte offset
	xor	dx,dx
	div	cx
rd0:
	mov	si,ax
	lodsw				;Get word
	mov	bx,ax			;Save in AX
	lodsb				;Next byte
	mov	cx,dx			;Offset in byte
	jcxz	rd2			;If zero, skip shifts
rd1:	shr	al,1			;Put code in low (code size) bits of BX
	rcr	bx,1
	loop	rd1
rd2:	mov	ax,bx			;put code in ax
	mov	bx,cs:nbits		;mask off unwanted bits
	sub	bx,9
	shl	bx,1
	and	ax,cs:masks[bx]
	ret
read_code	endp


init_tab	proc	near
	mov	cs:nbits,9			;Initialize variables
	mov	cs:max_code,512
	mov	cs:free_code,first_free
	ret
init_tab	endp

index		proc	near
	mov	bp,bx			;bx = bx * 3 (3 byte entries)
	shl	bx,1			;bp = bx
	add	bx,bp			;bx = bx * 2 + bp
	ret
index		endp

add_code	proc	near
	mov	bx,cs:free_code		;Get new code
	call	index			;convert to address
	push	es			;point to hash table
	mov	es,cs:hash_seg
	mov	al,cs:k			;get suffix char
	mov	es:[bx].char,al		;save it
	mov	ax,cs:old_code		;get prefix code
	mov	es:[bx].next,ax		;save it
	pop	es
	inc	cs:free_code		;set next code
	ret
add_code	endp
cseg	ends

	end
