print macro string
    lea  dx,string
    mov  ah,9
    int  21h
    endm
buffersize  equ  8*1024
cseg segment para public 'CODE'
   assume cs:cseg,ds:cseg
   org  100h
extrn  compress:near,decompress:near,rle:near,unrle:near
extrn  decompress:near,shrink:near
extrn  ada:near
entry: jmp start
; data
hi   db 'File Squeezer',13,10,10
     db 'This program is free for private use as long as no fee',13,10
     db 'is charged for the program or files created by the program',13,10
     db 'and it is not used by individuals or corporations for profit.',13,10,10,'$'
e1   db 'Command line error. Please refer to documentation.',13,10,'$'
e1a  db 'Switch error',13,10,'$'
     istack equ this word
e2   db "Can't create target file",13,10,'$'
e3   db 'Error writing target file, Disk full?',13,10,'$'
e6   db 'Error reading file, Disk may not be squeezable.',13,10,'$'
e7   db "Can't open input file",13,10,'$'
e8   db 'Input file is not a squeezed file',13,10,'$'
e9   db 'Error reading input file',13,10,'$'
e9a  db 'Input file created by newer version of SQ.',13,10
     db 'Please call PC-Rockland BBS at (914) 353-2157',13,10
     db 'for latest version',13,10,'$'
e10  db 'Error writing target disk',13,10,'$'
e11  db "Can't read boot record",13,10,'$'
e12  db 'Check Digit error in squeezed disk file',13,10,'$'
e13  db 'Abnormal end of file. File may not be complete.',13,10,'$'
e14  db 'Abnormal record size encountered',13,10,'$'
e15  db 'Command line switch missing or incompatible',13,10,'$'
done db 13,10,'SQ Done!',13,10,'$'
xswitch db 'US01234D'
xswitchl equ 8
switches equ this byte
switchu db 'U'
switchs db 'S'
switch0 db '0'
switch1 db '1'
switch2 db '2'
switch3 db '3'
switch4 db '4'
switchd db 'D'
;
hash_seg dw 0
stack_seg dw 0
buffer1 dw 0
buffer2 dw 0
buffer3 dw 0
buffer4 dw 0
public hash_seg,stack_seg,buffer1,buffer2,buffer3,buffer4
handlei dw 0
handleo dw 0
buffer1size dw 0  ; size of data in buffer1
buffer2size dw 0  ; size of data in buffer2
buffer3size dw 0  ; size of data in buffer3
buffer4size dw 0  ; size of data in buffer4
curr_buff  dw 0
curr_buff_size dw 0
targ_buff  dw 0
targ_buff_size dw 0
public curr_buff,curr_buff_size
public targ_buff,targ_buff_size
check_dig  dw 0
;
;
sig    db 26,'KPG'
ver    dw 300
;
;
disk   db 0
filenamei db 64 dup(0)
filenameo db 64 dup(0)
comp_type db 0 ; compression type 3 bytes with fcount
fcount dw 0
;
;
;
start:
;
     print hi
     call parse
     lea  sp,istack-2
     mov  ax,0
     push ax
     call  shrink
     mov   ax,stack_seg
     mov   ss,ax
     mov   sp,0ff00h
     cmp  switchs,1
     je   do_squeezex
     cmp  switchu,1
     je   do_unsqueezex
     cmp  switchd,1
     je   do_dir
do_unsqueezex:
     jmp  do_unsqueeze
do_squeezex:
     jmp  do_squeeze
do_dir:
;
;
;
     int  20h
;
;
;
;   0 = no_sqeeze
;   1 = rle
;   2 = lzw
;   3 = lzw on top of rle
;
get_buff:
; on decompress the file starts in buffer2
; and is deposited in buffer1
     cmp   comp_type,'0'
     je    dcomp0
     cmp   comp_type,'1'
     je    dcomp1
     cmp   comp_type,'2'
     je    dcomp2
     cmp   comp_type,'3'
     je    dcomp3
     cmp   comp_type,'4'
     je    dcomp4
dcomp0:
    jmp   dcomp_end
dcomp1:
    call  unrle
    mov   ax,buffer2
    mov   curr_buff,ax
    mov   ax,buffer2size
    mov   curr_buff_size,ax
    jmp   dcomp_end
dcomp2:
    call   decompress
    mov   ax,buffer3
    mov   curr_buff,ax
    mov   ax,buffer3size
    mov   curr_buff_size,ax
    jmp   dcomp_end
dcomp3:
    call  decompress
    mov   ax,buffer3
    mov   curr_buff,ax
    mov   ax,buffer3size
    mov   curr_buff_size,ax
    call  unrle
    mov   ax,buffer2
    mov   curr_buff,ax
    mov   ax,buffer2size
    mov   curr_buff_size,ax
    jmp   dcomp_end
dcomp4:
    call  decompress
    mov   ax,buffer3
    mov   curr_buff,ax
    mov   ax,buffer3size
    mov   curr_buff_size,ax
dcomp_end:
     ret
do_unsqueeze:
     mov   ax,buffer1
     mov   curr_buff,ax
     call  open_in  ; opens the input file
     call  create
uns_top:
     mov   al,'.'
     mov   ah,14
     int   10h
     call  read_file
     jc    uns_errora
     cmp   ax,0
     je    uns_end
     mov   ax,buffer1
     mov   curr_buff,ax
     mov   ax,buffer1size
     mov   curr_buff_size,ax
     call  get_buff
     call  write_records
     jmp   uns_top
uns_end:
     print done
     int   20h
uns_errora:
     print e14
     int  20h
uns_error:
     print e13
     int  20h
write_records:
; this writes out the segments
    mov   cx,curr_buff_size
    mov   bx,handleo
    mov   ah,40h
    mov   dx,0
    push  ds
    mov   ds,curr_buff
    int   21h
    pop   ds
    jc    bad_records
    cmp   ax,cx
    jne   bad_records
    clc
    ret
bad_records:
    print  e3
    int   20h
read_file:
; this reads the next block of records into buffer2
     lea  dx,comp_type
     mov  cx,3
     mov  bx,handlei
     mov  ah,3fh
     int  21h
     cmp  ax,3
     je   good_rf
     cmp  ax,0
     je   end_rf
bad_rf:
     mov  ax,0
     stc
     ret
end_rf:
     mov   buffer1size,0
     clc
     ret
good_rf:
     lea   dx,check_dig
     mov  cx,2
     mov  bx,handlei
     mov  ah,3fh
     int  21h
     jc   bad_rf
     cmp  ax,2
     jne  bad_rf
     mov  cx,fcount
     mov  dx,0
     mov  bx,handlei
     mov  ah,3fh
     push ds
     mov  ds,buffer1
     int  21h
     pop  ds
     jc   bad_rf
     mov  buffer1size,ax
     cmp  ax,cx
     jne  bad_rf
     mov  cx,fcount
     mov  si,0
     mov  bx,0
     mov  ah,0
     push ds
     mov  ds,buffer1
chk_dig2:
     lodsb
     add  bx,ax
     loop chk_dig2
     pop  ds
     cmp  bx,check_dig
     jne  bad_check_dig
     ret
bad_check_dig:
     print  e12
     int  20h
open_infile:
     lea   dx,filenamei
     mov   ah,3dh
     mov   cx,0
     mov   al,0
     int   21h
     jnc   good_oi
     print e7
     int  20h
good_oi:
     mov  handlei,ax
     ret
open_in:
     call  open_infile
     mov  cx,5
     lea  dx,sig
     mov  bx,handlei
     mov  ah,3fh
     int   21h
     jnc   good_r1
bad_r1:
     print  e8
     int   20h
bad_ver:
     print  e9a
     int   20h
good_r1:
     cmp   ax,5
     jne   bad_r1
     cmp   sig,26
     jne   bad_r1
     cmp   ver,300
     jg    bad_ver
     cmp  word ptr sig+1,'PK'
     jne   bad_r1
     ret
do_squeeze:
     call  create
     call  write_head
     call  open_infile
sq_loop:
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    buffer1size,buffersize
     mov    curr_buff_size,buffersize
     call   get_file
     cmp    buffer1size,0
     je     end_sq
     call   setup_sq
     call   write_file
     jmp    sq_loop
end_sq:
     print done
     int 20h
setup_sq:
; here we have to look at switches in order to tell how to squeeze
;
;   0 = no_sqeeze
;   1 = rle
;   2 = lzw
;   3 = lzw on top of rle
;
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    ax,buffer1size
     mov    curr_buff_size,ax
     cmp   switch0,1
     je    do_comp0
     cmp   switch1,1
     je    do_comp1
     cmp   switch2,1
     je    do_comp2x
     cmp   switch3,1
     je    do_comp3x
     jmp   do_comp3
do_comp2x:
     jmp   do_comp2
do_comp3x:
     jmp   do_comp3
do_comp0:
; comp0 is no compression
     mov    comp_type,'0'
     jmp    done_comp
do_comp1:
; comp1 is rle only copies into buffer2 from curr_buff
     mov    ax,buffer2
     mov    targ_buff,ax
     call   rle
     mov    ax,targ_buff_size
     mov    buffer2size,ax
enter_1:
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    ax,buffer1size
     mov    curr_buff_size,ax
     mov    ax,buffer3
     mov    targ_buff,ax
     call   ada
     mov    ax,targ_buff_size
     mov    buffer3size,ax
     mov    ax,buffer3
     mov    curr_buff,ax
     mov    ax,buffer3size
     mov    curr_buff_size,ax
     mov    ax,buffer4
     mov    targ_buff,ax
     call   rle
     mov    ax,targ_buff_size
     mov    buffer4size,ax
     cmp    ax,buffer2size
     jge    check_comp1
     mov    ax,buffer4
     mov    curr_buff,ax
     mov    ax,buffer4size
     mov    curr_buff_size,ax
     mov    comp_type,'5'
     cmp    ax,buffer1size  ; is the current buffersize less than uncomp
     jl     try_6
     jmp    make_comp0
done_compx:
     jmp    done_comp
try_6:
;
;
; check which ine is smaller
check_comp1:
     mov    ax,buffer2
     mov    curr_buff,ax
     mov    ax,buffer2size
     mov    curr_buff_size,ax
     mov    comp_type,'1'
     cmp    ax,buffer1size  ; is the current buffersize less than uncomp
     jl     done_compx
make_comp0:
     mov    comp_type,'0'
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    ax,buffer1size
     mov    curr_buff_size,ax
     jmp    done_comp
do_comp2:
; comp2 is lzw only. lzw copies into buffer3
     mov    ax,buffer3
     mov    targ_buff,ax
     call   compress
     mov    ax,targ_buff_size
     mov    buffer3size,ax
     mov    ax,buffer3
     mov    curr_buff,ax
     mov    ax,buffer3size
     mov    curr_buff_size,ax
     mov    comp_type,'2'
     jmp    done_comp
do_comp3:
; do_comp3 is best of lzw, lzw of rle or rle
;
;  first rle into buffer2
;
;
     mov    ax,buffer2
     mov    targ_buff,ax
     call   rle
     mov    ax,targ_buff_size
     mov    buffer2size,ax
; now  compress  buffer1 into buffer3
     mov    ax,buffer1
     mov    curr_buff,ax
     mov    ax,buffer1size
     mov    curr_buff_size,ax
     mov    ax,buffer3
     mov    targ_buff,ax
     call   compress
     mov    ax,targ_buff_size
     mov    buffer3size,ax
; now lzw the rle into buffer4
     mov    ax,buffer2
     mov    curr_buff,ax
     mov    ax,buffer2size
     mov    curr_buff_size,ax
     mov    ax,buffer4
     mov    targ_buff,ax
     call   compress
     mov    ax,buffer4
     mov    curr_buff,ax
     mov    ax,targ_buff_size
     mov    buffer4size,ax
     mov    curr_buff_size,ax
; buffer 3 has the type 2 and buffer4 has the type 3
     mov    comp_type,'2'
     cmp    ax,buffer3size   ; should we use the comp3?
     jl     check_rle
     mov    ax,buffer3
     mov    curr_buff,ax
     mov    ax,buffer3size
     mov    curr_buff_size,ax
     mov     comp_type,'3'   ;
check_rle:
; here a type 2 is indicated
; its either rle, lzw 2
        cmp   ax,buffer2size
        jl    done_comp
        jmp   enter_1
done_comp:
     mov    al,comp_type
     mov    ah,14
     int    10h
     mov    ax,curr_buff_size
     mov    fcount,ax
     ret
get_file:
    mov   cx,buffer1size
    mov   dx,0
    mov   bx,handlei
    mov   ah,3fh
    push  ds
    mov   ds,buffer1
    int   21h
    pop   ds
    jc    bad_get
    mov   buffer1size,ax
    ret
bad_get:
    print e6
    stc
    ret
write_file:
     lea   dx,comp_type
     mov   cx,3
     mov   ah,40h
     mov  bx,handleo
     int   21h
     mov   cx,curr_buff_size
     mov   si,0
     mov   bx,0
     mov   ah,0
     push  ds
     mov   ds,curr_buff
chk_loop:
     lodsb
     add   bx,ax
     loop  chk_loop
     pop   ds
     mov   check_dig,bx
     lea   dx,check_dig
     mov   cx,2
     mov   ah,40h
     mov  bx,handleo
     int   21h
     mov   cx,curr_buff_size
     mov   dx,0
     mov   ah,40h
     mov   bx,handleo
     push  ds
     mov   ds,curr_buff
     int   21h
     pop   ds
     cmp   ax,cx
     jne   error4
     ret
error4:
    jmp   error3
write_head:
; write out the header
     mov  cx,5
     lea  dx,sig
     mov  bx,handleo
     mov  ah,40h
     int   21h
     cmp   ax,5
     jne   error3
     ret
error3:
     print e3
     int   20h
create:
     lea  dx,filenameo
     mov  cx,0
     mov  ax,3c00h
     int  21h
     jc   bad_create
     mov   handleo,ax
     ret
bad_create:
     print e2
     int   20h
get_switch:
; this sets up switches
    mov  bx,0
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
gs_loop:
    mov  al,'/'
    cld
repne scasb
    jne  no_switch
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    push  cx
    push  di
    cmp   al,'a'
    jl    upper
    sub   al,32
upper:
    lea   di,xswitch
    mov   cx,xswitchl
    cld
repne scasb
    jne   bad_switch
    sub   di,offset xswitch+1
    mov   switches[di],1
    pop   di
    pop   cx
    inc   bx
    jmp   gs_loop
no_switch:
    cmp  bx,0
    jg   check_switch
bad_switch:
    print  e1
    int   20h
check_switch:
     ret
; one or more switch has been set
; d switch is only good by itself and has no disk
     cmp   switchd,1
     jne   no_d
     cmp   bx,1
     jne   bad_switch
     jmp   switch_ok
no_d:
; s and u are incompatible
     cmp   switchs,1
     je    got_s
     cmp   switchu,1
     je    got_u
switch_err:
    print  e15
    int   20h
got_u:
     cmp   bx,1
     jne   bad_switch
     jmp   switch_ok
got_s:
; only 1 2 or 3 at once no two
     cmp   switchu,1
     je   switch_err
     cmp   switch0,1
     jne   check1
     cmp   switch1,1
     je    switch_err
     cmp   switch2,1
     je    switch_err
     cmp   switch3,1
     je    switch_err
     jmp   switch_ok
check1:
     cmp   switch1,1
     jne   check2
     cmp   switch2,1
     je    switch_err
     cmp   switch3,1
     je    switch_err
     jmp   switch_ok
check2:
     cmp   switch2,1
     jne   check3
     cmp   switch3,1
     je    switch_err
     jmp   switch_ok
check3:
     cmp   switch3,1
     je    switch_ok
; no switch for compression, use 1 - fastest
     mov   switch1,1
switch_ok:
     ret
p_error:
    print  e1
    int   20h
parse:
    call  get_switch
    lea   di,filenamei
    mov  si,81h
    mov  bx,0
    call get_fname
    jc   p_error
    lea   di,filenameo
    call  get_fname
    ret
get_fname:
    cld
p1:
    lodsb
    cmp  al,20h
    je   p1
    cmp  al,9
    je   p1
    cmp  al,13
    je   p5
p2:
    stosb
    lodsb
    cmp   al,20h
    je    p4
    cmp   al,13
    je    p5
    jmp   p2
p4:
    clc
    ret
p5:
    stc
    ret
cseg ends
     end entry
