;
; DOOR WARD  DW.COM is a BBS door watcher which provides services
; services provided = critical error
;                   = carrier detect
;                   = i/o redirect
;                   = PC Board time
;
;
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
lstack   dw   256  dup(0)
savesp   dw  0
savess   dw  0
sem2     db   0  ; if you have been through before
semaphore db  0
counter   dw  0
wcount    dw  180 ; set by dw parms
comlen    db  0   ; length of parameter string
intx8  equ this dword
intx8ip  dw   0
intx8cs  dw   0
ticker   db   0   ; this switch is set by the config program if
                  ; a clock tick is needed
video    db   0   ; switch to say if we do emulations
ctty     db   0   ; switch to say if we do ctty emulations
ansi     db   0   ; switch if we do vt100
ints  db  512   dup (0)
command_line db 135 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute, first word is env
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0

;

print macro string
   lea  dx,string
   mov  ah,9
   int   21h
   endm
mess1    db  13,10,"DOOR WARD complete",13,10,10,'$'
include fd.asm
include dwcf.asm
;
;
;
WAKA proc near
; this are the watch cat functions
;
; enter here on clock_tick
;
; there are two things to check. If WAKA is on then check for CD
; if PCB is on check for time out on remaining time.
;
timer:
; check the semaphore
        pushf
        call  cs:[intx8]         ; existing interrupt 8
        push  ax
        mov   al,1
lock    xchg  cs:semaphore,al
        test  al,al
        jz    enterx8
        pop   ax
        iret
enterx8:
;
; check the counter
        inc    cs:counter
        mov    ax,cs:wcount
        cmp    cs:counter,ax      ; count down for PCB (every 10 seconds)
        pop    ax
        jg     check_dtra
        mov    cs:semaphore,0
        iret
check_dtra:
        cmp    cs:sem2,99
        jne    no_come_back
        jmp    come_back
no_come_back:
        push   ax
        push   bx
        push   dx
        push   ds
        mov    cs:counter,0
        call   check_cd
        jc      lost_cd
        pop    ds
        pop    dx
        pop    bx
        pop    ax
        mov    cs:semaphore,0
        iret
lost_cd:
        mov   ah,14
        mov   al,7
        int  10h
        cli
        mov     ax,cs
        mov     ss,ax
        lea     sp,lstack+510
        sti   ; enable interrupts
; get and reset the psp
        mov   ah,51h
        mov   al,0
        mov   bx,0
        int   21h
; set the ds segment
        mov   cs:sem2,99
        mov   ds,bx
        mov   es,bx
        mov   al,0ah    ; return code for kill
        mov   ah,4ch
        mov    cs:semaphore,0
        int   21h
waka  endp
;
;
;
setpass  proc  near
; set up a local stack
     lea  sp,lstack+510
     call  dw_config
     call  dw_setup
     cmp   video,1
     jne   dont_init10
     call  init10
     call  init16
dont_init10:
     cmp   ctty,1
     jne   dont_init10a
     call  init10a
     call  init16
dont_init10a:
     mov   dl,comport
     mov   dh,0
     call  initcom
;
;
;
;  prepare for the exec function
; shrink memory
   push  cs
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
   pop   es
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
come_back:
   cli
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
;
; restore all interrupts
;
          push  es
          mov   ax,0
          mov   di,0
          lea   si,ints
          mov   cx,256
          mov   es,ax
          cld
rep       movsw
          pop   es
         mov   al,20h
         out   20h,al
        sti   ; enable interrupts
;
; now reset the interrupts so we can leave
;
        call  decom    ; resets the irq's which are on
; say that we did it
   print    mess1
; all done, go home
; must get the return code for the last procedure to end
        mov   ah,4dh
        int   21h
; check to see if high byte is significant
        cmp   al,0
        jne   exit_all
        mov   al,ah  ;0 if normal, 1 for ^c, 2 crit err, 3 hex 31
exit_all:
        mov   ah,4ch
        int   21h
        int   20h
setpass  endp
last_byte equ this byte
;

mess0    db  "DOOR WARD version 1.00",13,10
         db  "Copyright 1988 by Keith P. Graham",13,10,10,'$'
;
;
; this data is used by the passthru program only
;
dw_setup proc near
         mov   ax,cs
         mov   ds,ax
         mov   es,ax
     print mess0
; these are throw-away routines executed only at start up
; create the commandline
;
; save    all interrupts
;
          push  ds
          mov   ax,0
          mov   si,0
          lea   di,ints
          mov   cx,256
          mov   ds,ax
          cld
          cli
rep       movsw
          pop   ds
          sti
;
;
; begin by getting the paramters set from config.dw file
;include c:dwconf.asm
;
       cmp   ticker,0
       je    no_ticker
;
; redirect the timer tick
;
        push   es
        mov   ax,3508h
        int   21h
        mov   intx8cs,es
        mov   intx8ip,bx
        pop   es
        mov   ah,25h
        mov   al,08h
        lea   dx,timer
        int   21h
no_ticker:
;
;
;
; the command line is set up by the DO paramter of the config file
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
   mov    ax,ds:[2ch]
   mov    parmblock,ax
     ret
dw_setup  endp
;
;
CSEG        ENDS
        END        ENTPT
;
