;
;
width_bytes dw 0
width_pix   dw 0
height_pix  dw 0
in_fbuffer   dw 0
fbuffcount   dw 0
pass    dw  0
planes  dw  0
tb64    db 64 dup(0)  ; tbuffer - 64 for compression
tbuffer db 640 dup(0)
;
;
;
;GIF Compuserve Graphics Interchange Format
;
GIF_count    equ    13
gif_header equ this word
    dw    13
GIF_SIG    db    'GIF'
GIF_VER    db    '87a'
; screen descriptor
GIF_screen_width   dw 640
GIF_screen_length  dw 200
GIF_DESC    db    00000000b ; broken down
GIF_back    db    0    ;background color
    db    0    ;un used
;
;
; GIF local data
;
gif_planes db 1  ; number of gif planes
gif_map_size dw 8 ; size of gif map
gif_resolution db 0 ; don't knwo why I need this, but keep it
;
gif_descriptor db ','
    dd 0
gif_width dw 0
gif_height dw 0
gif_desc2 db 0
;
 dd 0
;
cur_byte db  0,0
cur_word equ word ptr cur_byte
extra_byte db 0
cur_bits dw  0
readmask  dw  0
bitmask  dw  0
codesize dw  0
initcodesize dw 0
clear    dw  0
clearcode dw 0
firstfree dw 0
freecode  dw 0
eofcode   dw 0
maxcode   dw 0
;
;   this junk is from the nlzw code, I don't think it will fit
;
;
bitoffset    dw 0
bitoffset2    dw 0
yc    dw 0
oldcolor    db 0
yoffset    dw 0
xoffset    dw 0
curcode    dw 0
incode    dw 0
oldcode    dw 0
finchar    db 0
rasterseg    dw 0
rasterofs    dw 0
prefix equ 10000  ; start of prefix in hash
suffix equ 4000    ; start of suffix area
outcode equ 0   ; start in hash_seg
;canline db 640 dup (0)
code_count dw 0 ; keeps track of blocks
;   Masks: Array [0..9] of Integer = (7,15,$1f,$3f,$7f,$ff,$1ff,$3ff,$7ff,$fff);
masks  dw 7,15,1fh,3fh,7fh,0ffh,1ffh,3ffh,7ffh,0fffh
;   MaxCodes: Array [0..9] of Word = (4,8,16,$20,$40,$80,$100,$200,$400,$800);
maxcodes dw 4,8,16,20h,40h,80h,100h,200h,400h,800h
codemask  dw 1,3,7,15,15,15,15,15,15,15
out_bytes  dw 0
out_bits   dw 0
outcount   dw 0
out_total  dw 0
ten_lines  db 0
clean    db 0
gif_line_sw db 0
;
;
;
;
GIF_READ PROC NEAR
gif_phase  dw  0
public gif_read
    call   reset_segs
    mov   gif_line_sw,0
    cmp  gif_phase,0
    je   gif_first_time
    jmp  gif_continue_read
gif_first_time:
;
; this is altered to produce one line of gif at a time
; the masm code did not work. Translate the pascal code
;
;   setup some variables
; reinitialization
;

;{Compute decompressor constant values, based on the code size}

;    ClearCode:=PowersOf2 [Codesize];
    mov  cx,codesize
    mov  ax,1
    shl  ax,cl
    mov  clearcode,ax
    cmp  ax,256
    jle   ok_codesize
    mov  ax,256
    mov  clearcode,ax
ok_codesize:
;    EOFCode:=ClearCode+1;
    inc  ax
    mov  eofcode,ax
;    FirstFree:=ClearCode+2;
    inc  ax
;    FreeCode:=FirstFree;
    mov  firstfree,ax
    mov  freecode,ax

;{The GIF spec has it that the code size is the code size used to compute the
;above values is the code size given in the file, but the code size used in
;compression/decompression is the code size given in the file plus one.}

;    Codesize:=Succ (Codesize);
    inc  codesize
;    InitCodeSize:=Codesize;
    mov   bx,codesize
    mov   initcodesize,bx
;    Maxcode:=Maxcodes [Codesize-2];
    dec   bx
    dec   bx
    shl   bx,1
    mov   ax,maxcodes[bx]
    mov   maxcode,ax
;    ReadMask:=Masks [Codesize-3];
    mov  cx,codesize
    mov  bx,1
    shl  bx,cl
    dec  bx
    mov  readmask,bx


;{Get ready to do the actual read/display. Free up the heap used by the
;GIF array since we don't need it any more, and if the user wants to save,
;reclaim it for the Picture array}

;
;  asm starts here, look at the gif asm stuff, compared to ours
;
;    OutCount:=0;
    mov outcount,0
;
; some things of my own
gif_continue_read:
    mov out_bytes,0
    mov out_bits,0
    mov out_total,0
    call  clean_buffer
; set up the BP and SI registers and the segments
    mov  di,save_di
    mov  si,save_si
    mov  bp,save_bp
    mov  es,hash_segment
;
;{Decompress the file, continuing until you see the GIF EOF code. One
;obvious enhancement is to add checking for corrupt files here.}
;
;   Repeat
top:
;
;    {Get the next code from the raster array}
;
;    ReadCode;
    call  readcode
    jc    is_done
;
;    If Code <> EOFCode then
;    Begin
;
    cmp   ax,eofcode
    jne   not_end
is_done:
    jmp   finished
not_end:
;    {Clear code sets everything back to its initial value, then reads
;    the immediately subsequent code as uncompressed data.}
;
;    If Code = ClearCode then
    cmp  ax,clearcode
    je   do_clearcode
    jmp  by_clearcode
is_done2:
    jmp  finished
do_clearcode:
;    Begin
;    DoClear;
    call  doclear
;    ReadCode;
    call  readcode
    jc    is_done2
;    CurCode:=Code;
    mov   curcode,ax
;    OldCode:=Code;
    mov   oldcode,ax
;    FinChar:=Code and BitMask;
    mov   clean,1
    jmp   by_raw   ; as per asm version
;  this is the old pascal stuff
    and   ax,bitmask
    mov   finchar,al
;    AddToPixel (FinChar);
    call  addtopixel
    jnc   go_bottom
    mov   gif_line_sw,1
;
;
;    End
go_bottom:
    jmp   bottom
by_clearcode:
;    Else
;
;    {If not a clear code, then must be data: save same as CurCode and InCode}
;
;    Begin
;    CurCode:=Code;
;    InCode:=Code;
    mov   curcode,ax
    mov   incode,ax
;
;    {If greater or equal to FreeCode, not in the hash table yet; repeat
;    the last character decoded}
;
;    If Code>=FreeCode then
    cmp   ax,freecode
    jl    by_free
;    Begin
;    CurCode:=OldCode;
    mov   ax,oldcode
    mov   curcode,ax
;    OutCode [OutCount]:=FinChar;
    mov   bx,outcount
    mov   al,finchar
    mov  al,es:[bx+outcode]
;    OutCount:=Succ (OutCount);
    inc  outcount
;    End;
by_free:
;
;    {Unless this code is raw data, pursue the chain pointed to by CurCode
;    through the hash table to its end; each code in the chain puts its
;    associated output code on the output queue.}
;
;    If CurCode>BitMask then
    mov   ax,curcode
    cmp   ax,bitmask
    jle   by_raw
;    Repeat
;    OutCode [OutCount]:=Suffix [CurCode];
loopbr:
    mov  bx,curcode
    mov  al,es:[bx+suffix]
    mov  bx,outcount
    mov  es:[bx+outcode],al
;    OutCount:=Succ (OutCount);
    inc  outcount
;    CurCode:=Prefix [CurCode];
    mov  bx,curcode
    shl  bx,1
    mov  ax,es:[bx+prefix]
    mov  curcode,ax
;    Until CurCode<=BitMask;
    cmp   ax,bitmask
    jg    loopbr
by_raw:  ; known as done in asm version
;
;    {The last code in the chain is treated as raw data.}
;
;    FinChar:=CurCode and BitMask;
    mov  ax,curcode
    and  ax,bitmask
    mov  finchar,al
;    OutCode [OutCount]:=FinChar;
    mov  bx,outcount
    mov  es:[outcode+bx],al
;    OutCount:=Succ (OutCount);
    inc   outcount
;
;    {Now we put the data out to the using routine. It's been stacked
;    LIFO, so deal with it that way}
;
;    For I:=OutCount-1 downto 0 do
    mov   cx,outcount
ap_loop:
    push  cx
    mov   bx,cx
    dec   bx
;    AddToPixel (Outcode [I]);
    mov   al,es:[bx+outcode]
    call  addtopixel
    pop   cx
    jnc   go_ap_loop
    mov   gif_line_sw,1
go_ap_loop:
    loop  ap_loop
;
;    {Make darned sure OutCount gets set back to start}
;
;    OutCount:=0;
    mov  outcount,0
    cmp clean,0
    je  goon
    mov clean,0
    jmp  top
goon:
;
;    {Build the hash table on-the-fly. No table is stored in the file.}
;
;    Prefix [FreeCode]:=OldCode;
    mov   bx,freecode
    mov   ax,oldcode
    shl   bx,1
    mov   es:[bx+prefix],ax
;    Suffix [FreeCode]:=FinChar;
    mov   al,finchar
    mov   bx,freecode
    mov   es:[bx+suffix],al
;    OldCode:=InCode;
    mov   ax,incode
    mov   oldcode,ax
;
;    {Point to the next slot in the table. If we exceed the current MaxCode
;    value, increment the code size unless it's already 12. If it is, do
;    nothing: the next code decompressed better be CLEAR}
;
;    FreeCode:=Succ (FreeCode);
    inc  freecode
;    If FreeCode>=MaxCode then
    mov  ax,maxcode
    cmp  ax,0    ; could be negative, freecode can't be
    jl   by_slot
    cmp  freecode,ax
    jl   by_slot
;    Begin
;    If CodeSize < 12 then
    cmp   codesize,12
    jge   by_slot
;    Begin
;    CodeSize:=Succ (CodeSize);
    inc  codesize
;    MaxCode:=MaxCode*2;
    mov  cx,2
    mov  ax,maxcode
    mul  cx
    mov  maxcode,ax
;    ReadMask:=Masks [CodeSize-3];
    mov  cx,codesize
    mov  bx,1
    shl  bx,cl
    dec  bx
    mov  readmask,bx
;    End;
by_slot:
;    End;
;    End {not Clear};
bottom:
    cmp   gif_line_sw,0
    jne   finished_line
    jmp   top
finished_line:
    mov   save_di,di
    mov   save_si,si
    mov   save_bp,bp
    clc
    ret
finished:
    stc
    ret
;
GIF_READ endp
;
addtopixel:
; this puts the value in al to the output buffer
    push  si
    push  bp
    push  ds
    push  es
    call  reset_segs
    lea   di,tbuffer
    add   di,out_total
    mov   bp,width_pix
    cld
    stosb
;
    inc   out_total
    cmp   out_total,bp
    jge   new_line
    jmp   ok_out_bits
new_line:
; buff out a line
    mov   ax,width_bytes
    mov   cl,gif_planes
    mov   ch,0
    mul   cx
    mov   cx,ax
    mov   out_total,0
    mov   dx,0
    mov   di,0
    mov   si,0
    mov   save_si,si
    mov   save_di,di
    mov   save_bp,bp
;    call  flush_buffer  ; transmit a line
    call  reset_segs
;    call  clean_buffer
    pop   es
    pop   ds
    pop   bp
    pop   si
    stc
    ret
ok_out_bits:
    pop   es
    pop   ds
    pop   bp
    pop   si
    clc
    ret

bad_readcode2:
    jmp   bad_readcode
;
readcode:
; try again
    cld
    mov  al,cur_byte
    mov  ah,cur_byte+1
    push  ax
    mov  cx,codesize
    cmp  cx,8
    jl   cs_lt_8
    mov  al,cur_byte+1
    mov  cur_byte,al
    mov  al,extra_byte
    mov  cur_byte+1,al
    call  get_a_bytec
    jc   bad_readcode
    mov  ah,al
    mov  al,0
    mov  cx,24
    sub  cx,cur_bits
    cmp  cx,0
    je   by_shift1
    shr  ax,cl
by_shift1:
    mov  extra_byte,ah
    or   cur_byte+1,al
;
    mov   cx,codesize
    sub   cx,8
cs_lt_8:
    cmp   cx,0
    je    done_readcode
    shr   cur_word,cl
    mov   ah,extra_byte
    mov   al,0
    shr  ax,cl
    mov  extra_byte,ah
    or   cur_byte+1,al
    sub  cur_bits,cx
    cmp  cur_bits,16
    jg   done_readcode
; have to make up a byte
    cmp  cur_bits,16
    je   quick_byte
    call get_a_bytec
    jc   bad_readcode
    mov  ah,al
    mov  al,0
    mov  cx,16
    sub  cx,cur_bits
    shr  ax,cl
    mov  extra_byte,ah
    or   cur_byte+1,al
    add  cur_bits,8
    jmp  done_readcode
bad_readcode:
    pop   ax
    and   ax,readmask
    stc
    ret
quick_byte:
    call  get_a_bytec
    jc   bad_readcode
    mov   extra_byte,al
    add  cur_bits,8
done_readcode:
;
    pop   ax
    and   ax,readmask
    clc
    ret
;
;
;
get_a_bytec:  ; deblocks as it gets bytes
    call  get_a_byte2
    jc    e_gb
    dec   code_count
    cmp   code_count,0
    jg    ok_cc
    mov   ah,0
    cmp   ax,0
    je    e_gb
    mov   code_count,ax
    call  get_a_byte2
    jc    e_gb
ok_cc:
    clc
    ret
e_gb:
    stc
    ret

get_a_byte2:
; reads a byte for guys who used it in fp
;
    push  ds
    cmp   si,bp
    jl    ok_gb2
    push  ds
    push  es
    mov   ds,gbuffer
    mov    dx,4000h
    mov    cx,3fffh
    call    read_file
    pop    es
    pop    ds
    mov    bp,ax
    add    bp,4000h
    mov    si,4000h
    cmp    ax,0
    jne    ok_gb2
    pop  ds
    stc
    ret
ok_gb2:
    mov   ds,gbuffer
    cld
    lodsb
    pop  ds
    clc
    ret

doclear:
; this resets things to their initial state
;Procedure DoClear;
;
;    Begin
;    CodeSize:=InitCodeSize;
    mov    bx,initcodesize
    mov    codesize,bx
;    MaxCode:=MaxCodes [CodeSize-2];
    dec   bx
    dec   bx
    shl   bx,1
    mov   ax,maxcodes[bx]
    mov   maxcode,ax
;    FreeCode:=FirstFree;
    mov    ax,firstfree
    mov    freecode,ax
;    ReadMask:=Masks [CodeSize-3];
    mov  cx,codesize
    mov  bx,1
    shl  bx,cl
    dec  bx
    mov  readmask,bx
    ret
;    End;
;
    ret
;
;
;GIF Compuserve Graphics Interchange Format
;
;GIF struc
;GIF_count    dw    13
;GIF_SIG    db    'GIF'
;GIF_VER    db    '87a'
; screen descriptor
;GIF_screen_width   dw 640
;GIF_screen_length  dw 200
;GIF_DESC    db    00000000b ; broken down
;GIF_back    db    0    ;background color
;    db    0    ;un used
;GIF ends
_GIF_HEADER    PROC    NEAR
    lea  dx,gif_sig
    mov   cx,gif_count
    call  read_file
    jc    bad_gif
    cmp   ax,gif_count
    jne  bad_gif
    cmp   word ptr gif_sig,"IG"
    jne    bad_gif
    cmp   gif_sig+2,"F"
    je    good_gif
bad_gif:
    stc
    ret
good_gif:
; gif sig ok
    mov   al,gif_desc ; color info
; get size of color map
    mov  ah,al
    and  ah,7  ; last 3 bits
    inc  ah
    mov  gif_planes,ah ; number of bits per pixel
    mov  bx,1
    mov  cl,ah
    shl  bx,cl
    mov  gif_map_size,bx  ; size of gif color map
    dec  bx
    mov  bitmask,bx
;
; now the color resolution stuff
;
;    mov  cl,4
;    shr  al,cl
;    and  al,7
;    inc  al
;    mov  gif_resolution,al
; time to prime the pump by filling up an incoming buffer
;
    push    ds
    push    es
    call  reset_segs
    mov    ax,gbuffer
    mov    dx,4000h
    mov    es,ax
    mov    ds,ax
    mov    cx,3fffh
    call    read_file
    cmp    ax,0
    pop    es
    pop    ds
    jg    good_gif_read
bad_gif_in:
    stc
    ret
good_gif_read:
    mov    si,4000h
    mov    bp,ax   ; amount in buffer
    add    bp,4000h ; place in buffer
;
; now get the global color map if present
    test  gif_desc,80h   ; is the global map here?
    jz  no_global_map
; have to loop through the global map
    mov  cx,gif_map_size  ; actually three values here
    cmp  cx,0
    jle  no_global_map
    mov  dx,cx
    cmp  cx,256
    jle  ok_global_size
    mov  cx,256
ok_global_size:
    push  dx
    push  cx
    call  get_color_map
; color_map is set up
    pop   cx
    pop   dx
    jc   bad_gif_in
; check and see if the map was completed
    cmp   cx,dx
    je    no_global_map  ; ok they were the same size
    sub   dx,cx
    cmp   dx,0
    jle   no_global_map
; get the rest of the global map
    mov   cx,dx
get_rest_map:
    call   get_a_byte
    jc   bad_gif_in2
    call   get_a_byte
    jc   bad_gif_in2
    call   get_a_byte
    jc   bad_gif_in2
    loop   get_rest_map
    jmp   no_global_map
bad_gif_in2:
    jmp   bad_gif_in
no_global_map:
;
; now go for the the picture header
;
    call  reset_segs
    lea   di,gif_descriptor
    mov   cx,10
    cld
gif_des_loop:
    push di
    call get_a_byte
    pop  di
    jc   bad_gif_in2
    stosb
    loop  gif_des_loop
    cmp   gif_descriptor,','
    jne   bad_gif_in2
    mov  ax,gif_width
    mov  width_pix,ax
    add    ax,7
    shr   ax,1
    shr   ax,1
    shr   ax,1
    MOV    WIDTH_BYTES,AX    ;SAVE AS bytes
    cmp   gif_planes,1
    jle   no_g_planes
    mov    planes,cx
;    mul    cx
no_g_planes:
    mov  ax,gif_height
    mov   cl,gif_planes
    mov  ch,0
    mul   cx
    mov   height_pix,ax
;    test  gif_desc2,80h
    jmp   no_desc_map
; have a new color map
    mov   al,gif_desc2
    and  al,7  ; last 3 bits
    inc  al
    mov  gif_planes,al ; number of bits per pixel
    push  ax
    mov   ah,0
    mov   cx,ax
    mov  ax,gif_height
    mul   cx
    mov   height_pix,ax
    pop   ax
    mov  bx,1
    mov  cl,al
    shl  bx,cl
    mov  gif_map_size,bx  ; size of gif color map
    mov  cx,bx    ; actually three values here
    cmp  cx,0
    jle  bad_gif_in3
    cmp  cx,256
    jle  ok_global_size2
    mov  dx,cx
    mov  cx,256
    jmp  ok_global_size2
ok_global_size2:
    push  cx
    push  dx
    call  get_color_map
    pop   dx
    pop   cx
    jc   bad_gif_in3
    cmp   cx,dx
    je    no_desc_map ; ok they were the same size
    sub   dx,cx
    cmp   dx,0
    jle   no_desc_map
; get the rest of the global map
    mov   cx,dx
get_rest_map2:
    call   get_a_byte
    jc   bad_gif_in3
    call   get_a_byte
    jc   bad_gif_in3
    call   get_a_byte
    jc   bad_gif_in3
    loop   get_rest_map2
;    jmp   no_desc_map
no_desc_map:
;
; set up initial values
; codesize is the very first byte of each line
    call  reset_segs
    call get_a_byte
    mov  ah,0
    mov  codesize,ax
; calc constants needed
; next get the first block count
    call  get_a_byte
    mov   ah,0
    inc   ax
    mov   code_count,ax
; prime the pump
    mov  save_si,si
    mov  save_bp,bp
    call  get_a_bytec
    mov   cur_byte,al
    call  get_a_bytec
    mov   cur_byte+1,al
    call  get_a_bytec
    mov   extra_byte,al
    mov  cur_bits,24
;
; continue now
    mov   di,0
    mov   save_di,di
    mov   save_si,si
    mov   save_bp,bp
    clc
    ret
bad_gif_in3:
   jmp  bad_gif_in
get_color_map:
    cmp   cx,16
    je    ega_map
    jmp   vga_map
ega_map:
    lea   di,color_map
    cld
pcc_cloop:
    push  cx
    mov    bl,0
; red first
    call   get_col
    jc    bad_col_in
    mov    cx,ax
    and    cx,1
    shl    cx,1
    shl    cx,1
    add    bl,cl
    shr    ax,1
    mov    cl,5
    shl    ax,cl
    add    bl,al
; green
    call   get_col
    jc    bad_col_in
    mov    cx,ax
    and    cx,1
    shl    cx,1
    add    bl,cl
    shr    ax,1
    mov    cl,4
    shl    ax,cl
    add    bl,al
; blue
    call   get_col
    jc    bad_col_in
    mov    cx,ax
    and    cx,1
    add    bl,cl
    shr    ax,1
    mov    cl,3
    shl    ax,cl
    add    bl,al
    mov    al,bl
    stosb
    pop   cx
    loop pcc_cloop
    clc
    ret
bad_col_in:
    stc
    ret
get_col:
    call get_a_byte
    jc   bad_gif_inc
    mov    ah,0
    mov    cl,6
    shr    ax,cl
    cmp    ax,0
    je    done_col
    cmp    ax,3
    je    done_col
    cmp    al,1
    je    col1
    mov    al,0
col1:
    inc    ax
done_col:
    ret

; now we loop through the three colors per map
bad_gif_inc:
    stc
    ret
vga_map:
    lea   di,color_map
    cld
    mov   ax,cx
    shl   cx,1
    add   cx,ax
vga_cloop:
    push  cx
    mov    bl,0
    call get_a_byte
    pop  cx
    jc   bad_vga_col
    stosb
    loop  vga_cloop
    clc
    ret
bad_vga_col:
    stc
    ret
_GIF_HEADER    ENDP
;
;
;
clean_buffer:
    push  ds
    push  es
    call  reset_segs
    mov  es,gbuffer
    mov  cl,gif_planes
    mov  ch,0
    mov  al,0
    mov  di,0
    cld
clean_buff:
    push  cx
    mov   cx,width_bytes
rep   stosb
    pop   cx
    loop  clean_buff
    pop   es
    pop   ds
    ret
;
;
;
;
;
;    MAC HEADER
;
fbuffer equ this byte
MAC_VERSION    DB    0
MAC_LEN_FN    DB    6
MAC_FILE_NAME  DB    'OPTIKS'
    DB    57 DUP(0)
MAC_FILE_TYPE  DB    'PNTG'
MAC_FILE_CREAT DB    'MPNT'
MAC_FLAGS    DB    1
MAC_FILL1    DB    0
MAC_VERT    DW    0
MAC_HORIZ    DW    0 ;8001H
MAC_FOLDER    DW    0
MAC_PROT    DB    0
MAC_FILL2    DB    0
MAC_FORK    DD    0
MAC_R_FORK    DD    0
MAC_CRT_DATE   DB    9BH,41H,8CH,0FAH
MAC_LST_MOD    DB    9BH,41H,8CH,0FEH
MAC_FILL3    DB    27 DUP(0)
MAC_OS    DW    0
MAC_REV    DB    0,0,0,2
MAC_PAT_01    DB    0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
    db    56 dup(0)
    db    64 dup(0)
    db    64 dup(0)
    db    64 dup(0)
    db    48 dup(0)
MAC_FILL4    DB    204 DUP(0)
    db 384  dup(0)  ; input fbuffer for file operations
;
;
_MAC_HEADER   PROC  NEAR
; this routine reads in the mac header and verifies that it is a MAC
    call  mac_in
    jnc   good_mac_in
exit_mac_in:
    mov  ax,640
    stc
    ret
good_mac_in:
    mov   ax,0
    clc
    ret
read_file:
    push  ds
    push  es
    call  reset_segs
    mov   ah,3fh
    mov   bx,handle
    pop   es
    pop   ds
    int   21h
    jc    exit_mac_in
    cmp   ax,cx
    jne   exit_mac_in
    clc
    ret
;
mac_in:
; this is called after the header is read into the 640 bytes
; we will put the stuff for checking out the file here
    MOV   pass,0
    MOV   width_bytes,72
    MOV   height_pix,720
    MOV   fbuffcount,0
    lea   ax,fbuffer
    mov   in_fbuffer,ax
    lea   dx,mac_version
    mov   cx,128
    call  read_file
    jnc  fgood_read
    ret
fgood_read:
;
; have to check and see what kind of thingy we got, we read in 128
; bytes, but we may have to read in either 384 more or 512 mode
;
; check to see if we have a binary zero header guy
;
    lea  di,mac_version+2
    mov  cx,64
    mov  al,0
    cld
repe  scasb
    jne  mac_check_more
    jmp  zero_head
mac_check_more:
; check for macbinary header
;
    cmp   mac_version,1
    jg    check_mp
    cmp   mac_file_name,'A'
    jl    check_mp
    cmp   mac_file_name,'z'
    jg    check_mp
    cmp   mac_file_type,'z'
    jg    check_mp
    cmp   mac_file_type,'A'
    jl    check_mp
    cmp   word ptr mac_r_fork,0
    jne   check_mp
    cmp   word ptr mac_r_fork+2,0
    jne   check_mp
zero_head:
; it looks like we got the macbinary header assume that there
; is a 512 macpaint header
    mov   cx,512
    lea   dx,mac_version
    call  read_file
    ret
check_mp:
    cmp   byte ptr mac_version,0
    jne   bad_mac
    cmp   byte ptr mac_version+1,0
    jne   bad_mac
    cmp   byte ptr mac_version+2,0
    jne   bad_mac
    cmp   byte ptr mac_version+3,5
    jg    bad_mac
    cmp   byte ptr mac_version+3,0
    jl    bad_mac
    mov   cx,384
    lea   dx,mac_version
    call  read_file
    ret
bad_mac:
    clc
    RET
_MAC_HEADER    ENDP
;
un_packbits:
public un_packbits
; bx has the number of bytes to unpack
; dl has the xor byte
    XOR   CH,CH
    LODSB
    TEST  AL,80h
    JZ    mac_no_hi
    NEG   AL
    MOV   CL,AL
    INC   CX
    LODSB
    XOR   AL,dl
    push  cx
    REP   STOSB
    pop   cx
    add   bp,cx
    sub   BX,cx
    Jnb   mac_bot
    ret
mac_no_hi:
    MOV   CL,AL
    INC   CX
    PUSH  CX
; move loop here to xor each byte
    CLD
mac_xor_loop:
    LODSB
    XOR   AL,dl
    STOSB
    inc   bp
    LOOP  mac_xor_loop
    POP   CX
    SUB   BX,CX
    Jnb   mac_bot
    ret
mac_bot:
    ret
;
;  This reads the file and decompresses it
;  it then returns so the fbuffers can be flushed
;
;
_MAC_READ   PROC  NEAR
public _MAC_READ
; this reads a single line of data into
; location from the stack
;
;
    call  mac_read
    cmp   cx,0
    je    ret_bad_mac
; cx returns with the bytes read into the string
    clc
    ret
ret_bad_mac:
    stc
    ret
mac_read:
; entry has ax:bx pointing the way to a string which must be filled
    lea   bx,tbuffer  ; tmporary buffer area
    push  bx
; first, if there is anything in the fbuffer move it down
    mov   bp,0
    cmp   fbuffcount,0
    jle   no_move_down
    lea   ax,fbuffer
    cmp   in_fbuffer,ax  ; is it already there?
    je    no_move_down
    mov   si,in_fbuffer
    lea   di,fbuffer
    mov   cx,fbuffcount
    cld
rep    movsb
no_move_down:
; moved down, now have to fill up
    mov   cx,1024
    sub   cx,fbuffcount
    lea   dx,fbuffer+1024
    sub   dx,cx
    cmp   cx,0
    jle   no_read_now
    call  read_file
    jnc   good_fill
    mov   cx,0
    pop   bx
    stc
    ret
good_fill:
    add  fbuffcount,ax  ; how much was read
no_read_now:
    lea   ax,fbuffer
    mov   in_fbuffer,ax
    mov   si,ax
    cmp   fbuffcount,0
    jg    ok_fbuffcount
    mov   cx,0
    pop   bx
    stc
    ret
ok_fbuffcount:
; here we have 1024 bytes (about) in the fbuffer)
    pop   di
; es:di points to the C program line
; si points to input fbuffer, di to output fbuffer
; bx keeps a count of the length of the data in input fbuffer
    mov   bx,72  ; count of bytes
mac_top:
    mov   dl,0ffh
    call  un_packbits
    CMP   BX,0
    JG    mac_top
    mov   in_fbuffer,si
    sub   si,offset fbuffer
    mov   ax,1024
    sub   ax,si
    mov   fbuffcount,ax
    mov   cx,bp
    clc
    ret
_mac_read    ENDP
half_it:
; This takes a string and a length and halves the length of the
; string returning a new length
; length is in cx  si points to string
    mov   di,si
    mov   bx,0
    shr   cx,1
    mov   bx,cx
    cmp   cx,0
    jg    hloop0
    mov   cx,1
    mov   bx,1
hloop0:
    cld
    lodsb
    shl  ax,1
    shl  al,1
    shl  ax,1
    shl  al,1
    shl  ax,1
    shl  al,1
    shl  ax,1
    shl  al,1
    lodsb
    shl  ax,1
    shl  al,1
    shl  ax,1
    shl  al,1
    shl  ax,1
    shl  al,1
    shl  ax,1
    shl  al,1
    mov  al,ah
    stosb
    loop  hloop0
    mov  ax,bx
    ret
;
get_a_byte:
; reads a byte for guys who used it in fp
;
    push  bx
    push  cx
    push  dx
    push  di
    push  ds
    push  es
    call  reset_segs
    cmp   si,bp
    jl    ok_gb
    push  ds
    mov   ds,gbuffer
    mov    dx,0
    mov    cx,3fffh
    call    read_file
    pop    ds
    mov    bp,ax
    mov    si,0
    cmp    ax,0
    jne    ok_gb
    pop  es
    pop  ds
    pop  di
    pop  dx
    pop  cx
    pop  bx
    stc
    ret
ok_gb:
    mov   ds,gbuffer
    cld
    lodsb
    pop  es
    pop  ds
    pop  di
    pop  dx
    pop  cx
    pop  bx
    clc
    ret
