;
;
nodes  struc
who  db ?
prev dw 0
nodes  ends
;
gif_header equ es:[0]
;
;
;GIF Compuserve Graphics Interchange Format
;
GIF_count       equ     13
GIF struc
GIF_SIG db      'GIF'
GIF_VER db      '87a'
; screen descriptor
GIF_screen_width        dw 640
GIF_screen_length       dw 200
GIF_DESC        db      00000000b ; broken down
GIF_back        db      0       ;background color
        db      0       ;un used
GIF ends
;
;
;
; new variable to say if stuff gets xored to screen or overlayed
xor_read        db      0
public xor_read
; local only stuff used by the programs
pass    DW      0
in_ibuffer      DW      0
BUFFCOUNT       DW      0
gif_d   db 0
curr_map_256  dw 3*256 dup(0)

;
; GIF local data
;
gif_planes db 1 ; number of gif planes
gif_map_size dw 0 ; size of gif map
gif_resolution db 0 ; don't knwo why I need this, but keep it
;
gif_descriptor db ','
        dd 0
gif_width dw 0
gif_height dw 0
gif_desc2 db 0
;
;
cur_byte db     0,0
cur_word equ word ptr cur_byte
extra_byte db 0
cur_bits dw     0
readmask        dw      0
bitmask dw      0
codesize dw     0
initcodesize dw 0
clear   dw      0
clearcode dw 0
firstfree dw 0
freecode        dw 0
eofcode dw 0
maxcode dw 0
width_pix  dw 0
height_pix dw 0
width_bytes dw 0
first dw 0
last_node dw 0
prev_node dw 0
;
;       this junk is from the nlzw code, I don't think it will fit
;
;
bitoffset       dw 0
bitoffset2      dw 0
yc      dw 0
oldcolor        db 0
yoffset dw 0
xoffset dw 0
finchar db 0
rasterseg       dw 0
rasterofs       dw 0
prefix equ 10000        ; start of prefix in hash
suffix equ 4000 ; start of suffix area
outcode equ 0   ; start in hash_seg
;canline db 640 dup (0)
code_count dw 0 ; keeps track of blocks
;       Masks: Array [0..9] of Integer = (7,15,$1f,$3f,$7f,$ff,$1ff,$3ff,$7ff,$fff);
masks   dw 7,15,1fh,3fh,7fh,0ffh,1ffh,3ffh,7ffh,0fffh
;       MaxCodes: Array [0..9] of Word = (4,8,16,$20,$40,$80,$100,$200,$400,$800);
maxcodes dw 4,8,16,20h,40h,80h,100h,200h,400h,800h
codemask        dw 1,3,7,15,15,15,15,15,15,15,15,15,15
out_bytes       dw 0
out_bits        dw 0
outcount        dw 0
out_total       dw 0
ten_lines       db 0
clean   db 0
free    dw 0
linelen   dw 0
line_off  dw 0

doclear:
;
    mov    bx,initcodesize
    mov    codesize,bx
    dec   bx
    dec   bx
    shl   bx,1
    mov   ax,maxcodes[bx]
    mov   maxcode,ax
       mov    ax,firstfree
       mov    freecode,ax
      mov  cx,codesize
      mov  bx,1
      shl  bx,cl
      dec  bx
      mov  readmask,bx
;
        mov     cx,258
        mov     di,0
        push    es
        mov     es,hash_segment
        mov     ax,0
init_clear:
        mov     es:[di].who,al
        mov     es:[di].prev,-1
        inc     ax
        add     di,3
        loop    init_clear
        pop     es
        mov     first,1
        mov     bx,0
        ret

;
;
;
GIF_IN:
     mov    outcount,0
     mov    line_off,0
       push  es
       call  read_file
       jc    bad_gif
       cmp   ax,100
       jb    bad_gif
       mov   inloc,gif_count
       mov   es,ibuffer
       cmp   word ptr gif_header.gif_sig,"IG"
       jne    bad_gif
       cmp   gif_header.gif_sig+2,"F"
       je    good_gif
bad_gif:
       pop   es
bad_gif2:
       stc
       ret
good_gif:
; gif sig ok
       mov   al,gif_header.gif_desc ; color info
; get size of color map
       mov  ah,al
       and  ah,7  ; last 3 bits
       inc  ah
       mov  gif_planes,ah ; number of bits per pixel
       mov  bx,1
       mov  cl,ah
       shl  bx,cl
       mov  gif_map_size,bx  ; size of gif color map
       dec  bx
       mov  bitmask,bx
;
; now get the global color map if present
       test  gif_header.gif_desc,80h   ; is the global map here?
       jz  no_global_map
; have to loop through the global map
       mov  cx,gif_map_size  ; actually three values here
       cmp  cx,0
       jle  no_global_map
       pop  es
       call  get_color_map
; color_map is set up
       push es
       jc   bad_gif
; check and see if the map was completed
no_global_map:
;
; now go for the the picture header
;
       pop   es
       lea   di,gif_descriptor
       mov   cx,10
       cld
gif_des_loop:
       push di
       call get_a_byte
       pop  di
       jc   bad_gif2
       stosb
       loop  gif_des_loop
       cmp   gif_descriptor,','
       jne   bad_gif2
       mov  ax,gif_width
       mov  width_pix,ax
       MOV     WIDTH_BYTES,AX      ;SAVE AS bytes
       mov   vwid,ax
       mov   ax,512
       cmp   vwid,512
       jle   by_fix
       mov   ax,1024
       cmp   vwid,1024
       jle   by_fix
       mov   ax,2048
by_fix:
       mov   vwid,ax
       mov   cx,SEGMENTSIZE
       mov   ax,tot_mem
       mul   cx
       div   vwid
       mov   last_line,ax
       mov  bx,gif_height
       cmp  ax,bx
       jle  by_gh
       mov  ax,bx
by_gh:
       mov   height_pix,ax
; is there a second map?
;
;
; set up initial values
; codesize is the very first byte of each line
       call get_a_byte
       mov  ah,0
       mov  codesize,ax
; calc constants needed

    mov  cx,codesize
    mov  ax,1
    shl  ax,cl
    mov  clearcode,ax
    cmp  ax,256
    jle   ok_codesize
    mov  ax,256
    mov  clearcode,ax
ok_codesize:
;     EOFCode:=ClearCode+1;
    inc  ax
    mov  eofcode,ax
;     FirstFree:=ClearCode+2;
    inc  ax
;     FreeCode:=FirstFree;
    mov  firstfree,ax
    mov  freecode,ax

;{The GIF spec has it that the code size is the code size used to compute the
;above values is the code size given in the file, but the code size used in
;compression/decompression is the code size given in the file plus one.}

;     Codesize:=Succ (Codesize);
      inc  codesize
;     InitCodeSize:=Codesize;
      mov   bx,codesize
      mov   initcodesize,bx
;     Maxcode:=Maxcodes [Codesize-2];
      dec   bx
      dec   bx
      shl   bx,1
      mov   ax,maxcodes[bx]
      mov   maxcode,ax
;     ReadMask:=Masks [Codesize-3];
      mov  cx,codesize
      mov  bx,1
      shl  bx,cl
      dec  bx
      mov  readmask,bx

; next get the first block count
       call  get_a_byte
       mov   ah,0
       inc   ax
       mov   code_count,ax
; prime the pump
       call  get_a_bytec
       mov   cur_byte,al
       call  get_a_bytec
       mov   cur_byte+1,al
;      call  get_a_bytec
;      mov   extra_byte,al
       mov  cur_bits,16
;
; continue now

       clc
       ret
bad_gif_in3:
      stc
      ret
get_color_map:
       push   es
       push   cs
       pop    es
       lea   di,curr_map_256
gc_loop1:
       push  cx
       call  get_a_byte
       jc   bad_color
       shr  al,1
       shr  al,1
       stosb
       call  get_a_byte
       jc   bad_color
       shr  al,1
       shr  al,1
       stosb
       call  get_a_byte
       jc   bad_color
       shr  al,1
       shr  al,1
       stosb
       pop  cx
       loop   gc_loop1
       pop  es
       clc
       ret
bad_color:
      pop  cx
bad_gif_inc:
       pop  es
      stc
      ret

;
;
;
set_palette:
       mov  cx,gif_map_size
       mov  ah,10h
       mov  al,12h
       lea  dx,curr_map_256
       mov  bx,0
       int  10h
       ret
;
;
;

;
;
;
;
GIF_READ:


;
        mov outcount,0
        mov line_off,0
        mov linelen,0
        mov curr_mb,0
;
; some things of my own
        mov out_bytes,0
        mov out_bits,0
        mov out_total,0
; set up the BP and SI registers and the segments
        mov     es,hash_segment
        call    doclear
top:
;
        call    readcode
        jc      is_done
;
        cmp     ax,eofcode
        jne     not_end
is_done:
        jmp     finished
not_end:
;
        cmp     ax,clearcode
        je      do_clearcode
        jmp     by_clearcode
is_done2:
        mov     bx,2
        jmp     finished
do_clearcode:
        call    doclear
        jmp     top
by_clearcode:
;
; If not a clear code, then must be data: save same as CurCode and InCode}
;
;
;
;     read code
;     add the new node
;     make a trace
;     if not first, update the last added node
;     if current node = last added node, fix trace
;     output trace
;     go to top
;
;
; add the new node immediately
;
;     add the new node
;
      mov    si,ax
      shl    si,1
      add    si,ax       ; mult by 3
      mov    di,last_node
      mov    prev_node,di
      mov    di,freecode
      shl    di,1
      add    di,freecode ; mul by 3
      inc    freecode
      mov    es:[di].prev,si
      mov    last_node,di
;
;
;
; make trace, trace is at hash's 9001h location
      mov    di,9001h
      mov    bp,si
      mov    cx,0
trace:
      mov    al,es:[si].who
      std
      stosb
      inc    cx
      cmp    es:[si].prev,-1
      je     end_trace
      mov    si,es:[si].prev
      jmp    trace
end_trace:
; finished chain
;
;     if not first, update the last added node
      cmp    first,1
      je     by_first
      mov    bx,prev_node
      mov    es:[bx].who,al
;
;     if current node = last added node, fix trace
      cmp    prev_node,bp
      jne    no_fix
      mov    es:[9001h],al
by_first:
no_fix:
      mov    first,0
;
;
;     output trace
      call    addtopixel
;
       mov  ax,maxcode
       cmp  ax,0         ; could be negative, freecode can't be
       jl   by_slot
       cmp  freecode,ax
       jle  by_slot

;
;
;       If CodeSize < 12 then
        cmp     codesize,12
        jae     by_slot
;       Begin
;       CodeSize:=Succ (CodeSize);
        inc     codesize
;       MaxCode:=MaxCode*2;
        shl     maxcode,1
;       ReadMask:=Masks [CodeSize-3];
        mov     cx,codesize
        mov     bx,1
        shl     bx,cl
        dec     bx
        mov     readmask,bx

by_slot:


bottom:
        jmp     top
finished:
        stc
        ret
;
;
;
;
;
;
fcurr  dw 0
;
;
addtopixel:
; di points to data - 1
; cx is number of bytes
;
     mov   ax,cx
     add   ax,linelen   ; number of bytes written to current line
     cmp   ax,width_bytes ; have we finished line
     jle   atp_5   ; not yet
; have to finish current line
     push  cx
     mov   ax,width_bytes ; screen width
     sub   ax,linelen     ; emitted so far
     mov   cx,ax
     push  cx
     call  atp_5
     pop   ax
     pop   cx
     sub   cx,ax
; here we have to update the currline, etc
     mov    linelen,0
     mov    ax,line_off
     add    ax,vwid       ; virtual work space width
     mov    outcount,ax
     mov    line_off,ax
     cmp    ax,4000h
     jl     atp_5
     mov    line_off,0
     mov    outcount,0
     push   ax
     call   get_next_mb
     pop    ax
atp_5:
     cmp   cx,0
     jg    atp_6
     ret
atp_6:
     push  bx
     push  cx
     push  di
     add   linelen,cx
     mov   si,di
     inc   si
     mov   di,outcount
     push  ds
     push  es
     call  get_curr_mb
     mov   es,ax
     mov   ds,hash_segment
     cld
rep  movsb
     pop   es
     pop   ds
     mov   outcount,di
;
     pop   di
     pop   cx
     pop   bx
     add   di,cx
     ret

bad_readcode2:
        jmp     bad_readcode
;
readcode:
; first 3 bytes are in cur_byte, and extra_byte
        cld
        mov     al,cur_byte
        mov     ah,cur_byte+1
        push    ax
        mov     cx,codesize
        cmp     cx,8
        jl      cs_lt_8
        mov     al,cur_byte+1
        mov     cur_byte,al
        mov     al,extra_byte
        mov     cur_byte+1,al
        call    get_a_bytec
        jc      bad_readcode
        mov     ah,al
        mov     al,0
        mov     cx,24
        sub     cx,cur_bits
        cmp     cx,0
        je      by_shift1
        shr     ax,cl
by_shift1:
        mov     extra_byte,ah
        or      cur_byte+1,al
;
        mov     cx,codesize
        sub     cx,8
cs_lt_8:
        cmp     cx,0
        je      done_readcode
        shr     cur_word,cl
        mov     ah,extra_byte
        mov     al,0
        shr     ax,cl
        mov     extra_byte,ah
        or      cur_byte+1,al
        sub     cur_bits,cx
        cmp     cur_bits,16
        jg      done_readcode
; have to make up a byte
        cmp     cur_bits,16
        je      quick_byte
        call get_a_bytec
        jc      bad_readcode
        mov     ah,al
        mov     al,0
        mov     cx,16
        sub     cx,cur_bits
        shr     ax,cl
        mov     extra_byte,ah
        or      cur_byte+1,al
        add     cur_bits,8
        jmp     done_readcode
bad_readcode:
        pop     ax
        and     ax,readmask
        stc
        ret
quick_byte:
        call    get_a_bytec
        jc      bad_readcode
        mov     extra_byte,al
        add     cur_bits,8
done_readcode:
;
        pop     ax
        and     ax,readmask
        clc
        ret
;
;
;
get_a_bytec:    ; deblocks as it gets bytes
        call    get_a_byte2
        jc      e_gb
        dec     code_count
        cmp     code_count,0
        ja      ok_cc
        mov     ah,0
        cmp     ax,0
        je      e_gb
        mov     code_count,ax
        call    get_a_byte2
        jc      e_gb
ok_cc:
        clc
        ret
e_gb:
        stc
        ret

get_a_byte2:
; reads a byte for guys who used it in fp
;
        mov     si,inloc
        cmp     si,bytes_read
        jb      ok_gb2
        call    read_file
        jc      bad_gb
        cmp     ax,0
        je      bad_gb
        mov     si,0
        jmp     ok_gb2
bad_gb:
        stc
        ret
ok_gb2:
        push    ds
        mov     ds,ibuffer
        cld
        lodsb
        pop     ds
        mov     inloc,si
        clc
        ret
;
;
get_a_byte:
; reads a byte for guys who used it in fp
;
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    ds
        push    es
        call    get_a_byte2
        pop     es
        pop     ds
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        ret
;
;
