; this is a soft font viewer for cga
print macro string
  lea  dx,string
  mov  ah,9
  int  21h
endm
get macro string
  lea  dx,string
  mov  ah,10
  int  21h
endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org      100h     ;end of program segment prefix
entry:    jmp      main     ;skip over data
; this is location(word:0),height,width,start
;
; font descriptor areas, we can have more than one font
;
font1_height dw 0   ; this is the height of a font box
font1_base   dw 0   ; distance to baseline
font1_pitch  dw 0   ; space size
font1     dw  256 dup(0,0,0,0)
;
fontname  db  64,0,64 dup(0)
fontsize  dw  0
fontwidth dw  0
fontlen   dw  0
fontorig  dw  0
font1h    dw  0
font1m    dw  0
handle    dw  0
handlet   dw  0  ; input text file handle
handleg   dw  0  ; output raw file handle
buffseg   dw  0  ; segment of data buffer
rawhead   dw  320*8,6000
lett_loc  dw  0
chars     dw  0
letter    dw  0
fontbytes dw  0
;
;   THIS IS THE FONT DESCRIPTOR INFORMATION
;
;  we need cell height, baseline and pitch/4 for out font info block
;
font_descriptor equ this byte ; the esc,)s#W data for 26 goes here
fdcount   dw  26  ; count of how many bytes in descriptor head
          db  0
fonttype  db  0 ;0 = 7 bit, 1 = 8 bit
          dw  0
baseline  dw  0 ; offset from top of character cell to baseline
cellwidth dw  0 ; character cell width
cellhght  dw  0 ; character cell height
orient    db  0 ; 0 = portrait, 1 = landscape
fix_prop  db  0 ; fixed or proportional
sym_set   dw  0 ; symbol set
pitch     dw  0 ; default hmi ( space size )/4
height    dw  0 ; height of font*4
          db  0,0,0
style     db  0
strokew   db  0
typface   db  0
          dw  18 dup(0) ; extra fill in case there is a font descr.
;
; DOWNLOAD CHARCTER BLOCK - 16 bytes
;
;
dchar  equ this byte
          dd  0
          dw  0 ; orientation again
left_off  dw  0 ; left offset (space before character begins)
top_off   dw  0 ; distance from baseline to top of character
char_wid  dw  0 ; first dot to last horizontally
char_hght dw  0 ; top dot to bot dot
delta_x   dw  0 ; horizontal motion for this/4 (includes left_off)
;
;
istack   db  512 dup(0)
mess1     db  'FV.COM Font View, softfont viewer',13,10
          db  'Copyright 1987 by Keith P. Graham',13,10,'$'
mess2     db  'Enter the name of the font file: $'
mess3     db  'Unable to open font file',13,10,'$'
mess4     db  '01-Bad Soft Font format',13,10,'$'
mess5     db  '02-Bad Soft Font format',13,10,'$'
mess6     db  '03-Bad Soft Font format',13,10,'$'
mess7     db  '04-Bad Soft Font format',13,10,'$'
mess8     db  'Reading font',13,10,'$'
mess9     db  'Memory allocation error, insufficient memory',13,10,'$'
mess10    db  'Enter the name of the input text file',13,10,'$'
mess11    db  'Enter the name of the output graphics file',13,10,'$'
mess12    db  'Unable to open input file',13,10,'$'
mess13    db  'Unable to open output file',13,10,'$'
mess14    db  'Writing out graphics file',13,10,'$'
err1      db  'Insufficent memory',13,10,'$'
crlf      db   13,10,'$'
buffloc   dw  0
buffcount dw  0
buffer    db  2048 dup(0)
main      proc     near
          print  mess1
    lea  sp,istack+510
; shrink
    lea  bx,last_byte
    add  bx,15
    mov  cl,4
    shr  bx,cl
    mov  ah,4ah
    int  21h
   jc    bad_mem
    jmp   short good_mem
bad_mem:
        print  err1
        int   20h
good_mem:
; get the 64k memory area for fonts
        mov   bx,1000h  ; 64k
        mov   ah,48h
        int   21h
        jnc   good_mem2
        print mess9
        int   20h
good_mem2:
        mov   buffseg,ax
;
; get then name of the input text file
          print  mess10
          get    fontname
          print  crlf
; open the input text file
          cmp    fontname+1,1
          jg     open_tfile
errort:
          print  mess12
          int    20h
open_tfile:
; open the input text file
          mov    bl,byte ptr fontname+1
          mov    bh,0
          mov    fontname[bx+2],0
          lea    dx,fontname+2
          mov    al,0
          mov    ah,3dh
          int    21h
          jc     errort
          mov    handlet,ax
; get the name of the output graphics file
          print  mess11
          get    fontname
          print  crlf
; open the output graphics file
          cmp    fontname+1,1
          jg     open_gfile
errorg:
          print  mess13
          int    20h
open_gfile:
; open the input text file
          mov    bl,byte ptr fontname+1
          mov    bh,0
          mov    fontname[bx+2],0
          lea    dx,fontname+2
          mov    al,0
          mov    cx,0
          mov    ah,3ch
          int    21h
          jc     errorg
          mov    handleg,ax
; write out the header to the font
          mov    bx,ax
          mov    ah,40h
          mov    cx,4
          lea    dx,rawhead
          int    21h
          jc    errorg
;
; get the name of the font
          print  mess2
          get    fontname
          print  crlf
          cmp    fontname+1,1
          jg     open_file
error_exit:
          print  mess3
          int    20h
open_file:
          mov    bl,byte ptr fontname+1
          mov    bh,0
          mov    fontname[bx+2],0
          lea    dx,fontname+2
          mov    al,0
          mov    ah,3dh
          int    21h
          jc     error_exit
          mov    handle,ax
          print   mess8
;
          call    get_the_font
;
         mov   ax,cs
         mov   ds,ax
         mov   es,ax
; close the font file
         mov   bx,handle
         mov   ah,3eh
         int   21h
         mov   ax,handlet
         mov   handle,ax
; reprime the pump
          call   get_buffer
          jc     end_text
          jmp    by_end_text
end_text:
         mov   ax,cs
         mov   ds,ax
         mov   es,ax
         mov   bx,handle
         mov   ah,3eh
         int   21h
; write out the graphics buffer
         mov    ax,font1h
         mov    cx,320
         mul    cx
         mov    cx,ax
         push   ds
         mov    bx,handleg
         mov    ax,buffseg
         mov    dx,0
         mov    ds,ax
         mov    ah,40h
         int    21h
         pop   ds
         mov   bx,handleg
         mov   ah,3eh
         int   21h
         int   20h
end_text1: jmp end_text
write_a_buff:
; write out the graphics buffer
         mov    ax,font1h
         mov    cx,320
         mul    cx
         mov    cx,ax
         push   ds
         mov    bx,handleg
         mov    ax,buffseg
         mov    dx,0
         mov    ds,ax
         mov    ah,40h
         int    21h
         pop   ds
by_end_text:
;
         mov   ax,cs
         mov   ds,ax
         mov   es,ax
         print mess14
; clear out the buffer
         push  es
         mov   ax,buffseg
        mov    es,ax
         mov   cx,8000h
         mov   di,0
         mov   ax,0
         cld
rep      stosw
         pop   es
         mov   lett_loc,0
;
top_view:
         call   get_byte
         jc     end_text1
         cmp    al,26
         je     end_text1
         push  ax
         mov   ah,14
         int   10h
         pop   ax
         cmp    al,13
         je     top_view
         cmp    al,10
         je     write_a_buff
         cmp    al,' '
         jne   by_space
; do the space here
         mov   dx,pitch   ; the width  of the letter box
         shr   dx,1
         shr   dx,1
         shr   dx,1
do_spaces: ; reenter her to get by the space
         add   lett_loc,dx  ; for next letter
         jmp   top_view
by_space:
         mov   bl,al
         mov   bh,0
         shl   bx,1
         shl   bx,1
         shl   bx,1
         cmp   font1[bx],0
         je    top_view
         mov   ax,font1[bx]
         mov   cx,font1[bx+2] ; height of letter
         mov   dx,font1[bx+4] ; width of letter
         add   dx,7
         shr   dx,1
         shr   dx,1
         shr   dx,1
         mov   bp,font1[bx+6]  ; start loc of letter
; calculate the starting di of the letter
         push  ax
         push  cx
         push  dx
         mov   ax,baseline ; the height of the letter box
         sub   ax,bp
;        sub   ax,bp      ; the start loc of letter
;        sub   ax,cx      ; the height of the letter
; ax has the number of line down that the letter starts
         mov   cx,320
         mul   cx
         add   ax,lett_loc
         mov   di,ax
; di has the byte that the letter starts on
         pop   dx
         pop   cx
         pop   ax
         add   lett_loc,dx  ; for next letter
;
         push  ds
         push  es
         mov   ds,ax
         mov   si,0
let_loop:
         push  cx
         mov   ax,cs:buffseg
         mov   es,ax
         push  di
         mov   cx,dx
rep      movsb
         pop   di
         add   di,320
         pop   cx
         loop  let_loop
         pop   es
         pop   ds
         jmp   top_view
;
;
;
;
bad_font:
          print  mess4
          int    20h
;
get_the_font:
          call   get_buffer
          jc     bad_font
; start out by getting the font descriptor information
;
          call   get_word
          jc     bad_font
          cmp    al,1bh
          jne    bad_font
          cmp    ah,')'
          jne    bad_font
          call   get_byte
          jc     bad_font
          cmp    al,'s'
          jne    bad_font
          call   get_dec    ; gets a decimal value
          jc     bad_font
          cmp    al,'W'
          jne    bad_font
          jmp    got_fontd
end_fonts1: jmp end_fonts
got_fontd:
; have the font descriptor header now have to put the next
; 26 bytes in the font descriptor area
; the font length data comes in dx from get_dec
;
          mov   cx,13
          sub   dx,26
          lea   di,font_descriptor
get_descr_loop:
          push   cx
          call   get_word
          jc     bad_font
          xchg   al,ah
          stosw
          pop    cx
          loop   get_descr_loop
          mov    cx,dx
          cmp    cx,0
          jle    no_more_desc
gd_loop2:
          call   get_byte
          loop   gd_loop2
no_more_desc:
          mov    ax,height   ; height of font
          shr    ax,1
          shr    ax,1
          cmp    ax,200
          jle    ok_fonth
          mov    ax,200
ok_fonth:
          cmp    ax,0
          jle    bad_font
          mov    font1h,ax
top_fonts:
; here we get another character
          call   get_word
          jc     end_fonts1
          cmp    al,1bh
          jne    end_fonts1
          cmp    ah,'*'
          jne    end_fonts1
          call   get_byte
          jc     end_fonts1
          cmp    al,'c'
          jne    bad_font2
          call   get_dec
          jc     bad_font2
          cmp    al,'E'
          jne    bad_font2
          jmp    got_font2
;
bad_font2:
; this message comes up when we are reading the second headers
          print  mess5
          int    20h
got_font2:
; returns with dx having the number
          mov     letter,dx
          mov     cx,0
          mov     al,dl
          mov     ah,14
          int     10h   ;teletype the letter to screen
; have the letter number now its time for the letter data
          call   get_word
          jc     bad_font3
          cmp    al,1bh
          jne    bad_font3
          cmp    ah,'('
          jne    bad_font3
          call   get_byte
          jc     bad_font3
          cmp    al,'s'
          call   get_dec
          cmp    al,'W'
          jne    bad_font3
;
          jmp    got_font3
bad_font3:
          print  mess6
          int    20h
got_font3:
; returns with dx having the number
; the number in dx is the length of the area to read
          mov     fontsize,dx
; now we have to get the 16 bytes of good stuff
          mov    cx,8
          lea    di,dchar
head_loop:
          call   get_word
          jc     bad_font4
; have something in ax
          xchg  al,ah
          stosw
          loop    head_loop
          mov   cx,char_hght
          mov   fontlen,cx
          mov   ax,fontsize
          sub   ax,16
          shl   ax,1
          shl   ax,1
          shl   ax,1   ; mul by 8
          mov   dx,0
          div   cx     ; divide by the length (height)
;         dec   ax
          mov   fontwidth,ax
          mov   ax,top_off
          mov   fontorig,ax
          jmp    good_head
bad_font4:
; prints error 4 when runs out of stuff on 16 bytes after font head
          print  mess7
          jmp   end_fonts
          int    20h
good_head:
; get some memory enough for the font
; divide width by 8 to get how many bytes per line
        mov   ax,fontwidth
        add   ax,7
        shr   ax,1
        shr   ax,1
        shr   ax,1
        mov   fontbytes,ax
        mov   cx,fontlen
; multiply it out to get the bytes for the whole letter
        mul   cx
; ax has the number of bytes needed to store a font
; now divide by 16 to get the paragraphs needed
        add   ax,15
        shr   ax,1
        shr   ax,1
        shr   ax,1
        shr   ax,1
; ax has the number of paragraphs needed for the font character
        mov   bx,ax
        mov   ah,48h
        int   21h
        jnc   good_mem1
        print mess9
        int   20h
good_mem1:
; got a good memory in ax
        mov    bx,letter
; div by 8 to get index into font array
        shl    bx,1
        shl    bx,1
        shl    bx,1
        mov    font1[bx],ax
        push   ax
; have to fill out the other guys in the array
        mov    ax,fontlen
        mov    font1[bx+2],ax
        mov    ax,fontwidth
        mov    font1[bx+4],ax
        mov    ax,fontorig
        mov    font1[bx+6],ax
        pop    ax
; now we have to get all the bytes of the font an normalize them
; into a byte boundary and put them in es:0
        push   es
        mov    es,ax
        call   get_byte ; prime the pump
        mov    bh,8   ; number of bits in al
        mov    bl,0   ; bl has the number of bytes shifted
        mov    di,0
        mov    cx,fontlen
        mov    dx,fontwidth ; dl has the width of the font
;
; font loop, pass this cx times, dl has the width in bits
font_getl:
        push    cx
        push    dx
        cmp     dl,8  ; even byte per character
        jne     not_8
        stosb
        cmp    cx,1
        je     end_font_getl
        call   get_byte
        jc     bad_font5
        jmp    end_font_getl
bad_font5:
          pop   cx
          pop   dx
          pop   es
           jmp   end_fonts
not_8:
lt_loop:
; check and see if we are done
        cmp   dl,0
        je    lt_done
; check and see if we need a refill in al
        cmp   bh,0
        jg    lt_not_0
        call  get_byte
        jc     bad_font5
        mov   bh,8
lt_not_0:
; check and see if we have to dump ah
        cmp   bl,8
        jl    lt_more_shift
        mov   es:[di],ah
        inc   di
        mov   bl,0
;       jmp   lt_more_shift
lt_more_shift:
; have to shift the guy over until bl=bh
        shl    ax,1
        inc    bl  ; count of bits in ah
        dec    bh  ; count of bits remaining in al
        dec    dl  ; count remaining
        jmp    lt_loop
lt_done:
; ah has something to dump, dl is zero but bl has something in it
; shift ah to the left
        mov   cl,8
        sub   cl,bl
        push  ax
        shl   ah,cl
        mov   es:[di],ah
        pop   ax
        inc   di
        mov   bl,0
;       jmp    end_font_getl
;
end_font_getl:
        pop    dx
        pop    cx
        loop   font_getl
        pop    es
        jmp   top_fonts
end_fonts:
; reach this point when we get all the fonts into memory
;
         ret
;
get_dec:
; this gets decimal bytes until it gets somebody other than a
; number. It puts the value it gets in dx and puts the last byte
; in al.
          mov    dx,0
          mov    bx,0
; got the excape sequence, get the first digit
          call   get_byte
          jc     bad_dec
          cmp    al,'0'
          jl     bad_dec
          cmp    al,'9'
          jg     bad_dec
          and    al,0fh
          mov    bl,al
; got a first digit, get next
          call   get_byte
          jc     bad_dec
          cmp    al,'0'
          jl     got_dec
          cmp    al,'9'
          jg     got_dec
          and    al,0fh
          mov    bh,bl
          mov    bl,al
; get third
          call   get_byte
          jc     bad_dec
          cmp    al,'0'
          jl     got_dec
          cmp    al,'9'
          jg     got_dec
          and    al,0fh
          mov    dl,bh
          mov    bh,bl
          mov    bl,al
; get the last byte.
          call   get_byte
          jc     bad_dec
          cmp    al,'0'
          jl     got_dec
          cmp    al,'9'
          jg     got_dec
          and    al,0fh
          mov    dh,dl
          mov    dl,bh
          mov    bh,bl
          mov    bl,al
; get the last byte.
          call   get_byte
          jc     bad_dec
got_dec:
; dx:bx has the decimal stuff, al has a non decimal guy
          push   ax
          call   dec2bin
          pop    ax
          clc
          ret
bad_dec:
     stc
     ret
dec2bin:
; converts the 3 digit decimal in dl:bh:bl to bin
          mov     cx,1000
          mov     al,dh
          mov     ah,0
          push    dx
          mul     cx
          mov     bp,ax
          pop     dx
          mov     cl,100
          mov     al,dl
          mul     cl
          mov     dx,ax
          add     dx,bp
          mov     cl,10
          mov     al,bh
          mul     cl
          add     dx,ax
          mov     bh,0
          add     dx,bx
           ret

get_buffer:
; fills up the buffer
         push    dx
         push    cx
         push    bx
          lea    dx,buffer
          mov    cx,2048
          mov    ah,3fh
          mov    bx,handle
          int    21h
          jnc    got_buffer
bad_b:
          pop    bx
          pop    cx
          pop    dx
          stc
          ret
got_buffer:
          cmp    ax,0
          je     bad_b
          lea    bx,buffer
          mov    buffloc,bx
          mov    buffcount,ax
          pop    bx
          pop    cx
          pop    dx
          clc
          ret
get_word:
       cmp  buffcount,2
       jge  get_mword
       call get_byte
       jc   bad_word
       mov  ah,al
       call get_byte
       jc   bad_word
       xchg al,ah
       clc
       ret
bad_word:
       stc
       ret
get_mword:
         push   si
         mov    si,buffloc
         cld
         lodsw
         mov    buffloc,si
         pop    si
         dec    buffcount
         dec    buffcount
         cmp    buffcount,0
         jle    get_more
         clc
         ret
get_byte:
   ; pulls in one byte from buffer
         push   si
         mov    si,buffloc
         cld
         lodsb
         mov    buffloc,si
         pop    si
         dec    buffcount
         cmp    buffcount,0
         jle    get_more
         clc
         ret
get_more:
         push   ax
         call   get_buffer
         pop    ax
         ret
main      endp
last_byte equ this byte
cseg      ends
          end      entry
