; this routine translates the font into graphics
;
print macro string
  lea  dx,string
  mov  ah,9
  int  21h
endm
;
dseg      segment para public 'DATA'
          assume   cs:cseg,ds:dseg,es:dseg
extrn  buffer:word,handle:word,handleg:word,handlet:word
extrn  font1:word,baseline:word,font1h:word,pitch:word
lett_loc  dw  0
lett_height dw 0
crlf      db   13,10,'$'
;
; this is the letter buffer
lbuff db 80*210 dup(0)   ; 80 wide by 200 high (a big letter)
;

dseg      ends
;
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:dseg,es:dseg
extrn reset_segs:near,get_byte:near,get_buffer:near,get_word:near
extrn pcb_write:near
store_letter:
; this routine stores the letter to the graphics file buffer
; bx has the letter array offset
; dx has the letter width
;
        mov   di,lett_loc  ; bit offset of the letter
        mov   cl,3
        shr   di,cl  ; di has the byte offset to store the letter
        mov   cx,lett_height
        mov   bp,buffer      ;  graphics buffer
; dx still has the width of the letter in bytes
        lea   si,lbuff
        push  es
;
sl_loop0:
        push  cx
        push  si
        push  di
        mov   es,bp
        mov   cx,dx
        cld
sl_loop:
        lodsb
        or   byte ptr es:[di],al
        inc  di
        loop  sl_loop
        pop   di
        pop   si
        pop   cx
        add   si,80
        add   di,320
        loop  sl_loop0
        pop   es
        ret
;
;
;
;
shift_letter:
; this routine shifts the letter over to the right to the
; correct starting bit based on left_off and the remainder
; of letterloc /8
; calculate remainder
        mov   ax,font1[bx+8] ; left_off
        add   lett_loc,ax  ; bit offset of the letter
        mov   ax,lett_loc  ; bit offset of the letter
        and   ax,7
; dx still has the width in bytes. add 1 to it
        cmp   ax,0
        jne   do_rshift
        ret
do_rshift:
        cld
shift_lt_8:
; here we have to move the partial bytes
        lea  di,lbuff
        add  di,dx
        dec  di
        mov  si,di
        mov   bp,ax  ; number of bits
        mov   cx,lett_height ; height of letter
bs_loop0:
        push  cx
        push  si
        push  di
        mov   cx,dx
        std
bs_loop:
        push  cx
        lodsb
        mov   ah,al
        mov   al,0
        mov   cx,bp
        shr   ax,cl
        mov   byte ptr ds:[di],ah
        or    byte ptr ds:[di+1],al
        dec   di
        pop   cx
        loop  bs_loop
        pop   di
        pop   si
        pop   cx
        add   di,80
        mov   si,di
        loop  bs_loop0
        cld
        inc   dx             ; make room for shift
        ret
;
move_letter:
; this routine moves the font into lbuff
; first clear out lbuff
        call reset_segs
        mov   bl,al
        mov   bh,0
        mov   cl,4
        shl   bx,cl
        cmp   font1[bx],0
        jne   by_exit
; return with bx pointing to letter in font1
        ret
by_exit:
        lea  di,lbuff
        mov  al,0
        mov  cx,80*210
        cld
rep   stosb
; now  move the font into lbuff
;
         mov   ax,font1[bx]
         mov   cx,font1[bx+2] ; height of letter
         mov   dx,font1[bx+4] ; width of letter in bytes
         mov   bp,font1[bx+6]  ; start loc of letter
; calculate the starting di of the letter
         push  ax
         push  cx
         push  dx
         mov   ax,baseline ; the height of the letter box
         sub   ax,bp
; ax has the number of line down that the letter starts
         mov   lett_height,ax
         add   lett_height,cx
         mov   cx,80
         mul   cx
         lea   di,lbuff
         add   di,ax
; di has the byte that the letter starts on
         pop   dx
         pop   cx
         pop   ax
         push  ds
         mov   ds,ax
;
         mov   si,0
let_loop:
         push  cx
         push  di
         mov   cx,dx
         cld
rep      movsb
         pop   di
         add   di,80
         pop   cx
         loop  let_loop
         pop   ds
         ret
;
;
convert_text:
public convert_text
          call   reset_segs
          print  crlf
         mov   ax,handlet
         mov   handle,ax
; reprime the pump
          call   get_buffer
          jc     end_text
          jmp    by_end_text
end_text:
         call  reset_segs
         mov   cx,font1h
         call  write_pcx
end_cvrt:
         mov   bx,handleg
         mov   ah,3eh
         int   21h
         ret
write_pcx:
; write out the graphics buffer
        call   reset_segs
         mov    cx,font1h
         call   pcb_write
         ret
end_text1:
         jmp   end_text
write_a_buff:
; write out the graphics buffer
         call  write_pcx
         jc    end_cvrt
by_end_text:
;
     call  reset_segs
; clear out the buffer
         push  es
         mov   ax,buffer
         mov    es,ax
         mov   cx,8000h
         mov   di,0
         mov   ax,0
         cld
rep      stosw
         pop   es
         mov   ax,pitch
         shr   ax,1
         shr   ax,1
         mov   lett_loc,ax
;
top_view:
         call   get_byte
         jc     end_text1
         cmp    al,26
         je     end_text1
         push  ax
         mov   ah,14
         int   10h
         pop   ax
         cmp    al,13
         je     top_view
         cmp    al,10
         je     write_a_buff
         cmp    al,' '
         jne   by_space
; do the space here
         mov   dx,pitch   ; the width  of the letter box
         shr   dx,1
         shr   dx,1   ; divide by 4
         add   lett_loc,dx  ; for next letter
         jmp   top_view
by_space:
         call  move_letter
; move_font returns with bx set to get the stuff and do shift in lbuff
        cmp   font1[bx],0
        je    ret_top
        call  shift_letter
        call  store_letter
        mov   ax,font1[bx+10]  ; delta x
        sub   ax,font1[bx+8] ; left_off
        add   lett_loc,ax
ret_top:
         jmp   top_view
;
;
cseg      ends
          end
