; gwind is the EXE version of generic windowing
;
; modified jan 1989 to check for length and swidth without having
; to code it into the structure
;
;   call sequence is si points to a menu structure
;  menu structure is:
cseg segment para public 'CODE'
assume  cs:cseg,ds:cseg,es:cseg
;
menus struc
x    db  0
y    db  0
color db 0
sarea dw 0
mdata db ?
menus ends
;    db x loc
;    db y loc
;    db color
;    dw savearea
;    db ---data---,10
;    db 0
;
; window data
upleft  equ  201
upright equ  187
loleft  equ  200
loright equ  188
horiz   equ  205
vert    equ  186
;
;
w equ this byte
swidth   dw  0
h equ this byte
height  dw  0
savesi  dw  0
savedi  dw  0
cursor  dw  0
hide    dw  0
he      db  0
we      db  0
;
;
;
;
do_window:
public do_window
    push   ax
    push   bx
    push   cx
    push   dx
    push   si
    push   di
    push   bp
    mov    ax,cs
    mov    ds,ax
    mov    es,ax
    call   main_wind
exit_do_window:
    pop    bp
    pop    di
    pop    si
    pop    dx
    pop    cx
    pop    bx
    pop    ax
    ret
main_wind:
;
; this puts a window to the screen
    mov    bx,si
    call   save_si   ; find screen size and save variables
    call   save_cursor  ; saves the cursor position in buffer word
    call   save_window
    call   put_mess
    call   hide_cursor
    ret
undo_window:
public undo_window
; this retores from a save,
; si is window, di is save area
    call    save_si
    call    restore_window
    call    restore_cursor
    ret
put_mess:
; puts a message to the screen
    mov    bx,savesi
    cld
    lea    si,mdata[bx]
    mov    dh,y[bx]
    mov    dl,x[bx]
    inc    dh
    inc    dl
    mov    cx,0    ; cl is column
mloop0:
    push   cx
    push   dx
mloop1:
    push   cx
    push   dx
    cmp    ch,he
    jge    end_put_mess
    lodsb
    cmp    al,0
    je    end_put_mess
    cmp    al,13
    je    ignore_char
    cmp    al,10
    je    new_line
    cmp    cl,we
    jge    ignore_char
; got the character put it on the screen
; locate the cursor
    push   ax
    mov    ah,2
    mov    bx,0
    int    10h
    pop    ax
    mov    ah,10
    mov    cx,1
    int    10h
    pop    dx
    pop    cx
    inc    dl
    inc    cl
    jmp    mloop1
new_line:
    pop    dx
    pop    cx
    pop    dx
    pop    cx
    inc    dh
    inc    ch
    jmp    mloop0
ignore_char:
    pop    dx
    pop    cx
    jmp    mloop1
end_put_mess:
    pop    dx
    pop    cx
    pop    dx
    pop    cx
    ret
restore_window:
; puts the old window back
;setup cursor at x,y
    mov    bx,savesi
    mov    dh,y[bx]
    mov    dl,x[bx]
; set up save place
    mov    si,savedi
    cld
; the current cursor position is in dx
    mov    cl,h
    mov   ch,0
rloop1:
    push   cx
    push   dx
    mov    cl,w
    mov   ch,0
rloop2:
    push   cx
    push   dx
; locate
    mov    ah,2
    mov    bx,0
    int    10h
    lodsw
; put stuff
    mov    bl,ah
    mov    ah,9
    mov    bh,0
    mov    cx,1
    int    10h
    pop    dx
    pop    cx
    inc    dl
    loop   rloop2
    pop    dx
    pop    cx
    inc    dh
    loop   rloop1
    ret
restore_cursor:
; restore cursor
    mov   bx,savesi
    mov   si,sarea[bx]
    mov   dx,word ptr ds:[si]
    mov    dx,cursor
    mov    ah,2
    mov    bx,0
    int    10h
save_cursor:
; get and save current x,y position
    mov   ah,3
    mov   bx,0
    int   10h
    mov   bx,savesi
    mov   di,sarea[bx]
    mov   word ptr ds:[di],dx
    ret
save_window:
;setup cursor at x,y
    mov    si,savesi
    mov    dh,y[si]
    mov    dl,x[si]
; set up save place
    mov    di,savedi
    cld
; the current cursor position is in dx
    mov    cx,height
wloop1:
    push   cx
    push   dx
    mov    cx,swidth
wloop2:
    push   cx
    push   dx
; locate
    mov    ah,2
    mov    bx,0
    int    10h
; get stuff
    mov    ah,8
    mov    bx,0
    int    10h
; ax has the attrib and byte
    stosw
; find out what to put in al
    push   dx
    mov    al,20h
    cmp    dh,y[si]  ; row
    je    top_row
    inc    dh
    sub    dh,h
    cmp    dh,y[si]
    je    bot_row
    cmp    dl,x[si]
    je    left_col
    inc    dl
    sub    dl,w
    cmp    dl,x[si]
    je    right_col
    jmp    end_loop1
left_col:
right_col:
    mov    al,vert
    jmp    end_loop1
bot_row:
    mov    al,horiz
    cmp    dl,x[si]
    je    bot_left
    inc    dl
    sub    dl,w
    cmp    dl,x[si]
    je    bot_right
    jmp    end_loop1
bot_right:
    mov    al,loright
    jmp    end_loop1
bot_left:
    mov    al,loleft
    jmp    end_loop1
top_row:
    mov    al,horiz
    cmp    dl,x[si]
    je    top_left
    inc    dl
    sub    dl,w
    cmp    dl,x[si]
    je    top_right
    jmp    end_loop1
top_right:
    mov    al,upright
    jmp    end_loop1
top_left:
    mov    al,upleft
;    jmp    end_loop1
end_loop1:
    pop    dx
; place the correct character and attribute at the position
    mov    ah,9
    mov    bl,color[si]
    mov    cx,1
    mov    bh,0
    int    10h
    pop    dx
    pop    cx
    inc    dl
    loop   jmp_wloop2
    jmp    by_wloop2
jmp_wloop2:
    jmp    wloop2
by_wloop2:
    pop    dx
    pop    cx
    inc    dh
    loop   jmp_wloop1
    jmp    by_wloop1
jmp_wloop1:
    jmp    wloop1
by_wloop1:
; have to hid the cursor
    dec    dh
    dec    dh
    add    dl,w
    dec   dl
    dec    dl
    mov    hide,dx
    ret
hide_cursor:
    mov    si,savesi
    mov    dx,hide
    mov    ah,2
    mov    bx,0
    int    10h
    mov    bl,color[si]
    and    bl,0f0h
    mov    al,bl
    mov    cl,4
    shr    al,cl
    or    bl,al
    mov    al,0
    mov    ah,9
    mov    cx,1
    mov    bh,0
    int    10h
    ret
save_si:
;
    mov    bx,si
    mov    savesi,si
    mov    di,sarea[bx]
    inc    di
    inc    di  ; bypass the cursor location
    mov    savedi,di
    lea   si,mdata[bx]
    mov   dx,0  ; swidth   dh is max-swidth  dl is curr-swidth
    mov   cx,0  ; height
ss1:
    lodsb
    cmp   al,0
    je    ss9
    cmp   al,13
    je    ss1
    cmp  al,10
    je    ss3
    inc   dl
    cmp   dl,80
    jl    ss1
; maxed out in line swidth
ss3:
    cmp   dl,dh
    jle   ss4
    mov   dh,dl
ss4:
    mov   dl,0
    inc   cx
    jmp   ss1
ss9:
    mov   dl,dh
    mov   dh,0
    mov   we,dl
    mov   he,cl
    inc   cx
    inc   cx
    inc   dx
    inc   dx
    mov   swidth,dx
    mov   height,cx
    ret
cseg  ends
    end
