insert db 0
getline  proc  near
; on entry to getline the cursor is in the correct position and
; si points to a line of the form length,data
      push   bx
      push   cx
      push   dx
      push   si
      push   di
      push   bp
;
; get the current cursor position and put it in bp
      mov    ah,3
      mov    bx,0
      int    10h
      mov    bp,dx
      call   display_l
; from here on out, bx is the character index
      mov    bx,0
; this is the loop to get characters and add them to the string
getc_loop:
      mov    ah,0
      int    16h
      cmp    al,27
      je     got_esc
      cmp    al,13
      je     got_13
      cmp    ah,53h
      je     got_delete
      cmp    ah,4bh
      je     got_left
      cmp    ah,4dh
      je     got_right
      cmp    ah,52h
      je     got_insert
      cmp    ah,47h
      je     got_clean
      cmp    ah,4fh
      je     got_clean
; check for the cursor controls
      cmp    al,8
      je     got_8
      cmp    bl,byte ptr ds:[si]
      jge    getc_loop
      cmp    al,1bh
      jle    getc_loop
; display the current character on the screen
;
; check to see if insert is needed
      cmp    insert,1
      jne    no_insert
      call   do_insert
no_insert:
      push   bx
      mov    byte ptr ds:[si+bx+1],al
      mov    ah,9
      mov    cx,1
      mov    bl,070h
      int    10h
go_right:
      inc    bp
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      pop    bx
      inc    bx
ret_to_gc:
      jmp    getc_loop
got_delete:
     jmp   got_delete1
got_esc:
; escape cleans the line
     call  clean_line
got_0:
got_13:
     jmp   exit_line
got_left:
      cmp   bx,0
      jle   ret_to_gc
; check to see if the current position is a zero and we are
; moving into a space
      cmp    byte ptr ds:[si+bx+1],0
      jne    by_nopad
      cmp    byte ptr ds:[si+bx],' '
      jne    by_nopad
      mov    byte ptr ds:[si+bx],0
by_nopad:
      dec    bp
      push   bx
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      pop    bx
      dec    bx
      jmp    getc_loop
got_insert:
      xor   insert,1
getc_loope:
      jmp    getc_loop
got_right:
      cmp   byte ptr ds:[si],bl
      jl    ret_to_gc
      push  bx
; check to see if going right gives us a 0
      cmp   byte ptr ds:[si+bx+1],0
      jne   no_pad
      mov   byte ptr ds:[si+bx+1],' '
no_pad:
      jmp   go_right
got_clean:
      call  clean_line
      call  display_l
      jmp    getc_loop
got_8:
; backspace
      cmp   bx,0
      je    getc_loope
      dec    bp
      push   bx
      mov    dx,bp
      mov    bx,0
      mov    ah,2
      int    10h
      pop    bx
      dec    bx
got_delete1:
      jmp   do_backsp
exit_line:
; this accepts the current end of line
;
      pop    bp
      pop    di
      pop    si
      pop    dx
      pop    cx
      pop    bx
; last key pressed in al
      ret
do_insert:
; inserts into the curretn line
; nearly the same as delete
      push  ax
      push  si
      push  di
      mov   cl,byte ptr ds:[si]
      mov   ch,0
      dec   cx
      add   si,cx
      sub   cx,bx
      mov   di,si
      inc   di
      cmp   cx,0
      je    by_bs2
      std
rep   movsb
by_bs2:
      cld
      pop   di
      pop   si
      push   bx
      push   dx
      mov    dx,bp
      sub    dx,bx
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      call  display_l
      push   bx
      push   dx
      mov    dx,bp
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      pop   ax
      ret
do_backsp:
      push  si
      push  di
      mov   cl,byte ptr ds:[si]
      mov   ch,0
      inc   si
      add   si,bx
      mov   di,si
      inc   si
      sub   cx,bx
      cmp   cx,0
      je    by_bs
      cld
rep   movsb
by_bs:
      pop   di
      pop   si
      push   bx
      push   dx
      mov    dx,bp
      sub    dx,bx
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      call  display_l
      push   bx
      push   dx
      mov    dx,bp
      mov    bx,0
      mov    ah,2
      int    10h
      pop    dx
      pop    bx
      jmp   getc_loop
display_l:
; displays current line again
      push   bx
      push   bp
      mov    ah,3
      mov    bx,0
      int    10h
      mov    bp,dx
; now clear out the line with reverse video
      mov    cl,byte ptr ds:[si]
      mov    ch,0
      push   cx
      mov    ah,9
      mov    al,20h
      mov    bl,070h
      int    10h
; now print out each of the guys on the line
      pop    cx
      push   si
      inc    si
      push   bp
gl_loop1:
; locate the cursor
      push   cx
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      cld
      lodsb
      cmp    al,0
      je     end_gll1
      cmp    al,13
      je     end_gll1
      mov    ah,9
      mov    cx,1
      mov    bl,70h
      int    10h
      inc    bp
      pop    cx
      loop   gl_loop1
      push   cx
end_gll1:
      pop    cx
      pop    bp
      pop    si
      mov    bx,0
      mov    dx,bp
      mov    ah,2
      int    10h
      pop    bp
      pop    bx
      ret
clean_line:
; clears out the line
; si still ahs the line in it
      push  ax
      push  cx
      push  di
      mov   cl,byte ptr ds:[si]
      mov   ch,0
      mov   di,si
      inc   di
      mov   al,0
      cld
rep   stosb
      pop   di
      pop   cx
      pop   ax
      ret
getline  endp
