; this are the structures and macros for 32 bit integers
float struc
fsign db ?
fexp	dw ?	; not used in integers
fhigh dw ?	; greater than 1
fdech dw ?	; first word less than 1
fdecl dw ?	; second word less than 1
float ends
fixsgn macro x,y,z
local fs1
; fix up the sign
     mov   al,1
     mov   z.fsign,1
     mov   bl,x.fsign
     cmp   bl,y.fsign
     je    fs1
     mov   al,-1
fs1:
     mov   z.fsign,al
      endm
divi  macro x,y,z
local d1,d2,d3,d4,d5,d6,d7,d8,d9
; this divides x by y giving z
; y is an integer, making it easier to work with this stuff
; needed for calculating adders
;
; load up the workers
;
; strategy here is to mul the integer in y by high and dech and
; then again by fdecl
        mov     cx,x.fexp
        mov     z.fexp,cx
        mov     cl,x.fsign
	mov	z.fsign,cl
;
        mov     cx,y
	mov	ax,x.fhigh
      mov  dx,0
      div cx
; ax is actual results
      mov  z.fhigh,ax
      mov  ax,0
      div  cx
      mov  z.fdech,ax
      mov  ax,0
      div  cx
      mov  z.fdecl,ax
; dx has remainder
      mov  ax,0
      div  cx
      add  ax,7fffh
      adc  z.fdecl,0
      adc  z.fdech,0
      adc  z.fhigh,0
      mov  ax,x.fdech
      mov  dx,0
      div cx
      add  z.fdech,ax
      adc  z.fhigh,0
      mov  ax,0
      div  cx
      add  z.fdecl,ax
      adc  z.fdech,0
      adc  z.fhigh,0
; dx has remainder
      mov  ax,0
      div  cx
      add  ax,7fffh
      adc  z.fdecl,0
      adc  z.fdech,0
      adc  z.fhigh,0
      mov  ax,x.fdecl
      mov  dx,0
      div cx
      add  z.fdecl,ax
      adc  z.fdech,0
      adc  z.fhigh,0
; dx has remainder
      mov  ax,0
      div  cx
      add  ax,7fffh
      adc  z.fdecl,0
      adc  z.fdech,0
      adc  z.fhigh,0
;
;
   endm
;
print macro string
    lea  dx,string
    mov   ah,9
    int   21h
    endm
;
mull macro x,y,z
local m1,m2,m3,m4,m5,m6,m7,m8
; in integer version, the exponent is always 0
   fixsgn x,y,z
     ; si = fhigh
     ; bp = fdech
     ; bx = fdecl
     mov   cx,y.fhigh
     mov   ax,x.fhigh
     mul   cx
     mov   si,ax
     mov   ax,x.fdech
     mul   cx
     mov   bp,ax
     add   bx,dx
     mov   ax,x.fdecl
     mul   cx
     mov   bx,ax
     add   bp,dx
     adc   si,0
;
;
     mov   cx,y.fdech
     mov   ax,x.fhigh
     mul   cx
     add   bp,ax
     adc   si,dx
     mov   ax,x.fdech
     mul   cx
     add   bx,ax
     adc   bp,dx
     adc   si,0
     mov   ax,x.fdecl
     mul   cx
     add   ax,7fffh
     adc   bx,dx
     adc   bp,0
     adc   si,0
;
;
     mov   cx,y.fdecl
     mov   ax,x.fhigh
     mul   cx
     add   bx,ax
     adc   bp,dx
     adc   si,0
     mov   ax,x.fdech
     mul   cx
     add   ax,7fffh
     adc   bx,dx
     adc   bp,0
     adc   si,0
;    mov   ax,x.fdecl
;    mul   cx
;    add   ax,7fffh
;    adc   dx,7fffh
;    add   z.fdecl,0
;    adc   z.fdech,0
;    adc   z.fhigh,0
     mov   z.fdecl,bx
     mov   z.fdech,bp
     mov   z.fhigh,si

     endm
movv macro x,y
;   push cx
    mov  cx,9
    lea  si,x
    lea  di,y
    cld
rep movsb
;   pop  cx
    endm
addd macro x,y,z
local a1,a2,a3,a4,a5,a6,a7,a8,a9
; adds x+y puts them in z
	mov	bx,x.fhigh
	mov	dx,x.fdech
	mov	ax,x.fdecl
	mov	cl,x.fsign
	cmp	cl,y.fsign
	je	a7
; signs don't match
	sub	ax,y.fdecl
	sbb	dx,y.fdech
	sbb	bx,y.fhigh
	jnc	a8
	neg	cl
	push cx
	push bx
	push dx
	push ax
	xor ax,ax
	mov bx,ax
	mov dx,ax
	pop cx
	sub ax,cx
	pop cx
	sbb dx,cx
	pop	cx
	sbb	bx,cx
	pop	cx
	jmp	short a8
a7:
	add	ax,y.fdecl
	adc	dx,y.fdech
	adc	bx,y.fhigh
a8:
	mov	z.fdecl,ax
	mov	z.fdech,dx
	mov	z.fhigh,bx
	mov	z.fsign,cl
a9:
	endm
subb  macro x,y,z
     neg y.fsign
     addd x,y,z
     neg y.fsign
     endm
