include f:macros.asm
_TEXT segment public 'CODE'
assume  cs:_text,ds:_text
  org  100h
;
entry: jmp  start
;
;
pmax  float <1,0,0,0>
pmin  float <1,0,0,0,0>
qmax  float <1,0,0,0,0>
qmin  float <1,0,0,0,0>
deltap float <1,0,0,0,0>
deltaq float <1,0,0,0,0>
p     float <1,0,0,0,0>
q     float <1,0,0,0,0>
xlast float <1,0,0,0,0>
ylast float <1,0,0,0,0>
modulus float <1,0,0,0,0>
zero  float <1,0,0,0,0>
xcur  float <1,0,0,0,0>
ycur  float <1,0,0,0,0>
one   float <1,0,0100h,0,0>
tmp1  float <1,0,0,0,0>
tmp2  float <1,0,0,0,0>
tmp3  float <1,0,0,0,0>
tmp4  float <1,0,0,0,0>
vid_wid  dw 320
vid_len  dw 200
xloc   dw  0
yloc   dw  0
eighty dw  80
color  dw 0
loopmax equ 255
done  db 13,10,'done!',13,10,'$'
;
e1 db 'Enter Pmax $'
e2 db 'Enter Pmin $'
e3 db 'Enter qmax $'
e4 db 'Enter qmin $'
mess1 db 'p>$'
mess2 db 'q>$'
;
mandels:
;     Xlast = Ylast = modulus = 0.0;
     movv zero,xlast
     movv zero,ylast
     mov  cx,loopmax
ml1:
     push  cx
     call  mtry
; have to see if the muldulus is greater than 1000
     jc    ml10
     pop   cx
     loop  ml1
     push  cx
ml10:
     pop   cx
     call  do_dot
     ret
set_start:
; set up max col and max row
; deltaP = (Pmax - Pmin)/(max_col - 1.0);   /* determine real axis increment */
; deltaQ = (Qmax - Qmin)/(max_row - 1.0);/*determine imaginary axis increment*/
   push  cx
   subb   pmax,pmin,tmp1
   dec    vid_wid
   divi   tmp1,vid_wid,deltap
   inc    vid_wid
   subb   qmax,qmin,tmp1
   dec    vid_len
   divi   tmp1,vid_len,deltaq
   inc    vid_len
   pop   cx
   ret
start:
     print e1
     lea di,pmax
     call finput
     print e2
     lea di,pmin
     call finput
     print e3
     lea di,qmax
     call finput
     print e4
     lea di,qmin
     call finput
     call  set_mode
;
     call  mandel
;
     call  unset_mode
     int  20h
; mandlebrot loop
mandel:
     call  set_start
;
;
   movv qmin,q
   mov   cx,vid_len  ; ega screen height
   mov   yloc,0
man0:
     push  cx
; set up init col
;
     movv pmin,p
     mov   cx,vid_wid  ; ega screen width
     mov  xloc,0
man1:
     push  cx
     mov   cx,255-15
     call  do_dot
     call  check_key
     call  mandels
; have to increment p
     call  set_p
     pop   cx
     inc   xloc
     loop  man1
     call  setq
     pop   cx
     inc   yloc
     loop   man0
     print done
     call  wait_more
     ret
set_p:
     push  cx
     addd  p,deltap,tmp1
     pop   cx
     movv  tmp1,p
     ret
setq:
     push  cx
     addd  q,deltaq,tmp1
     pop   cx
     movv  tmp1,q
     ret
mtry:
; here is where all of the calcs are
;
    push  cx
;       Xcur = sqr (Xlast) - sqr (Ylast) + P;   /* find components of next Z */
     mull xlast,xlast,tmp1
     mull ylast,ylast,tmp2
     subb tmp1,tmp2,tmp3
     addd p,tmp3,xcur
;       Ycur = 2 * Xlast * Ylast + Q;
     mull xlast,ylast,tmp1
     shl  tmp1.fdecl,1
     rcl  tmp1.fdech,1
     rcl  tmp1.fhigh,1
     addd tmp1,q,ycur
;       Xlast = Xcur;                                       /* update last Z */
     movv xcur,xlast
;       Ylast = Ycur;
     movv ycur,ylast
;       modulus = sqr (Xcur) + sqr (Ycur);                 /* find size of Z */
     mull  xcur,xcur,tmp1
     cmp   tmp1.fhigh,0
     jge   mm1
     jmp   mdone
mm1:
     cmp   tmp1.fhigh,20000
     jl    mm2
     jmp   mdone
mm2:
     mull  ycur,ycur,tmp2
     cmp   tmp2.fhigh,0
     jl    mdone
     cmp   tmp2.fhigh,20000
     jg    mdone
     addd  tmp1,tmp2,modulus
     cmp   modulus.fhigh,0
     jl    mdone
     cmp   modulus.fhigh,20000
     jg    mdone
     pop  cx
     clc
     ret
mdone:
     pop  cx
     stc
     ret
; bottom of mandels
include f:float.asm
include f:video13.asm
_TEXT ends
     end  entry

  deltaP = (Pmax - Pmin)/(max_col - 1.0);   /* determine real axis increment */
  deltaQ = (Qmax - Qmin)/(max_row - 1.0);/*determine imaginary axis increment*/
  for (col = 0; col <= max_col; col++)       /* look at each point on screen */
    for (row = 0; row <= max_row; row++)
    {
      P = Pmin + col*deltaP;    /* determine coordinates of point in C plane */
      Q = Qmin + row*deltaQ;
      Xlast = Ylast = modulus = 0.0;
      color = 0;
      while ((modulus < max_size) && (color < max_iterations))
      {         /* go around until function blows up or until max_iterations */
        Xcur = sqr (Xlast) - sqr (Ylast) + P;   /* find components of next Z */
        Ycur = 2 * Xlast * Ylast + Q;
        color++;
        Xlast = Xcur;                                       /* update last Z */
        Ylast = Ycur;
        modulus = sqr (Xcur) + sqr (Ycur);                 /* find size of Z */
      }
      draw_point (col, row, (color % max_colors));
    }
}  /* mandel */




;void get_julia_params (float *Xmax, float *Xmin, float *Ymax, float *Ymin,
;                       float *P, float *Q)
;{
;  clear_txt_scr ();
;  scr_write (5, 5, "Xmax = ", normal);
;  scr_write (5, 7, "Xmin = ", normal);
;  scr_write (5, 9, "Ymax = ", normal);
;  scr_write (5, 11, "Ymin = ", normal);
;  scr_write (5, 13, "P = ", normal);
;  scr_write (5, 15, "Q = ", normal);
;}  /* get_julia_params */

void julia ()
{
  float Xmax, Xmin, Ymax, Ymin, P, Q;
  int color, row, col, max_iterations, max_size;
  float modulus, deltaX, deltaY,
        Xcur, Xlast, Ycur, Ylast;
  boolean save;
  char file_name [13];

  get_params (&max_iterations, &max_size);
  get_julia_params (&Xmax, &Xmin, &Ymax, &Ymin, &P, &Q);
  save_it (&save, file_name);                        /* get screen save info */
  set_graphics ();
  deltaX = (Xmax - Xmin)/(max_col - 1.0);   /* determine real axis increment */
  deltaY = (Ymax - Ymin)/(max_row - 1.0);/*determine imaginary axis increment*/
  for (col = 0; col <= max_col; col++)       /* look at each point on screen */
    for (row = 0; row <= max_row; row++)
    {
      modulus = 0.0;
      color = 0;
      Xlast = Xmin + col * deltaX;              /* find coordinates of Z [0] */
      Ylast = Ymin + row * deltaY;
      while ((modulus < max_size) && (color < max_iterations))
      {         /* go around until function blows up or until max_iterations */
        Xcur = sqr (Xlast) - sqr (Ylast) + P;   /* find components of next Z */
        Ycur = 2 * Xlast * Ylast + Q;
        color++;
        Xlast = Xcur;                                       /* update last Z */
        Ylast = Ycur;
        modulus = sqr (Xcur) + sqr (Ycur);                 /* find size of Z */
      }
      draw_point (col, row, (color % max_colors));
      if (bail_out ())                        /* does user want to bail out? */
      {
        col = max_col + 1;
        row = max_row + 1;
      }
    }
  if (save)
    save_screen (file_name, page0);
  getch ();                                /* show fractal until key pressed */
  set_text ();
}  /* julia */

