print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
;
;
entry:
        jmp   start
;  data
node_stru struc
     who   dw 0
     rank  dw 0
     weight dw 0
     next  dw 0
node_stru ends
;
;
compress:
; compress the file, cx has the number of bytes
     push  es
     mov   es,nodespace
     mov   buffsize,cx
     mov   buffloc,0
     mov   outcount,0
c1:
     call  get_byte
     jnc   c3
     jmp   c2
c2aa:
     push  dx
     mov   dl,ah
     call out_byte
     pop   dx
c2a:
; have to write byte in dl
     call out_byte
c2:
     jmp  exit_compress
c3:
; ax has the base for checking followers
     mov  ah,0
     mov  dl,al   ; save this for future write
     mov  di,ax
     shl  di,1
     shl  di,1
     shl  di,1
     mov   bp,di
; now get the follower in al,ah
     call get_byte
     jc   c2a
c3a:
     mov  ah,al
     call get_byte
     jc  c2aa
; have the pair in ax and the start address in di
     mov  bp,di   ; save one before
     mov  cx,es:[di].rank   ; save for future rank
     inc  cx
     mov  bx,es:[di].next
     cmp  bx,-1
     jne  test_rank
     jmp  add_rank2
test_rank:
     cmp  es:[bx].who,ax
     je   got_rank
     cmp  es:[bx].next,-1
     je   add_rank
     int 3
     mov  bp,bx   ; save one before
     mov  bx,es:[bx].next
     jmp  test_rank
add_rank2:
     mov   bx,di
add_rank:
; here is where you add testing for rank overruns
     mov   es:[di].rank,cx
     mov   si,free
     cmp   si,-1
     jne   ar_1
     call  init_nodes
     jmp   ar_2
ar_1:
     mov   bp,es:[si].next
     mov   free,bp
     mov   es:[bx].next,si
     mov   es:[si].who,ax
     mov   es:[si].next,-1
     mov   es:[si].weight,0
     mov   es:[si].rank,cx
ar_2:
;
;  added node, but still have to output a character to indicate no foll
;
     mov   dx,cx
     call   out_byte
     mov   dl,ah
     call   out_byte
; old ah is base
     mov   dl,ah
     mov   dh,0
     mov  di,dx
     shl  di,1
     shl  di,1
     shl  di,1
; old al, id now ah
     jmp  c3a
got_rank:
     mov  dx,es:[bx].rank
     call out_byte
; now work on wieght
     mov  cx,es:[bx].weight
     inc  cx
     mov  es:[bx].weight,cx
     mov  si,es:[di].next
     mov  dx,di
gr_1:
     cmp  si,bx
     je   c9
     cmp  es:[si].weight,cx
     jl   gr_3
     mov  dx,si
     mov  si,es:[si].next
     jmp  gr_1
gr_3:
; bp points to previous to hit
; dx points to previous to swapper
; swap nexts
     mov  cx,es:[bx].next
    xchg  cx,es:[si].next
     mov  es:[bx].next,cx
;swap ranks
     mov  cx,es:[bx].rank
    xchg  cx,es:[si].rank
     mov  es:[bx].rank,cx
; now make the previous point to new next and next
; previous to hit is in bp
     mov  cx,bx
     mov  bx,bp
     mov  es:[bx].next,si
     mov  si,dx  ; previous to swap out
     mov  es:[si].next,cx
c9:
     jmp  c3
exit_compress:
     pop  es
     ret
;
get_byte:
; returns a byte, returns carry on LAST byte
     cmp  buffsize,0
     jg   gb9
     push ax
     push bx
     push cx
     push dx
     push bp
     call read_file
     mov  buffsize,ax
     mov  buffloc,0
     pop  bp
     pop  dx
     pop  cx
     pop  bx
     pop  ax
gb9:
     push si
     cmp  buffsize,0
     jle  bad_byte
     mov  si,buffloc
     push ds
     mov  ds,bufferi
     cld
     lodsb
     pop  ds
     mov  buffloc,si
     dec  buffsize
got_byte:
     pop  si
     clc
     ret
bad_byte:
     pop  si
     stc
     ret
;
;
;
;
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 'thanks',13,10
out_string db '                 ',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
curr_bits dw 0
out_size  dw 0,0
free   dw 0
nodespace dw 0
buffloc   dw 0
buffsize  dw 0
outcount  dw 0
bits      dw 8
bitsize   dw 0ffh
out_byte:
; outs the guy in dl
    push  ax
    push  cx
    push  di
    mov   al,dl
    add   curr_bits,8
    adc   curr_bits+2,0
; now check the stuff to see if we write it out
    mov   di,outcount
    push  es
    mov   es,buffero
    stosb
    pop   es
    mov   outcount,di
    cmp   di,4000h
    jle   ob2
    mov   outcount,0
    mov   cx,di
    call  write_file
    pop   di
    pop   cx
    pop   ax
    ret
ob2:
    clc
    pop   di
    pop   cx
    pop   ax
    ret
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
    call  init_nodes
    mov   curr_bits,0
read_loop:
    call  read_file
    jc    error_exit
    cmp   ax,0
    je    good_exit
    mov   cx,ax
    call  compress
good_exit:
; now try and figure out how good our compression is
    mov   cx,outcount
    cmp   cx,0
    je    ge1
    call  write_file
ge1:
    call  stats
    lea   dx,goodbye
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
stats:
    lea   di,out_string
    mov   ax,curr_bits
    mov   dx,curr_bits+2
    add   ax,7
    adc   dx,0
    shr   dx,1
    rcr   ax,1
    shr   dx,1
    rcr   ax,1
    shr   dx,1
    rcr   ax,1
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    ret
;
;
init_nodes:
    push ax
    push cx
    push di
    mov  bp,es
    mov  es,nodespace
    mov  cx,256
    mov  di,0
    mov  al,0
in1:
    mov  es:[di].who,ax
    inc  ax
    mov  es:[di].next,-1
    mov  es:[di].rank,0
    mov  es:[di].weight,0
    add  di,8
    loop in1
    mov  ax,di
    mov  free,8*256
    mov  cx,4096-257
in2:
    add  ax,8
    mov  es:[di].next,ax
    mov  es:[di].weight,0
    mov  di,ax
    loop in2
    mov  es:[di].next,-1
    mov  es:[di].weight,0
    mov  es,bp
    pop  di
    pop  cx
    pop  ax
    ret
;
;
;
write_file:
; get the file into memory
; cx has the size of file to write
    push  bx
    push  dx
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    pop   dx
    pop   bx
    stc
    ret
good_write:
    pop   dx
    pop   bx
    clc
    ret
;
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,07000h
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    lea dx,error3
    stc
    ret
good_read:
    mov   file_size,ax
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; set up stack
    mov  ah,48h
    mov  bx,100h ; 16x256 for stack
    int  21h
    jc   bad_mem
    pop  bx
    mov  ax,ss
    mov  sp,4094
    push bx
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:buffero,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for table
    int  21h
    jc   bad_mem
    mov  es:nodespace,ax
    clc
    ret
cseg ends
    end entry
