;
;
compress:
     cld
     call  get_byte
     jnc   cont_compress
     clc
     ret
cont_compress:
;
; al has the character to decode ; es has the node space
     mov   dx,ax
     and   dx,0ffh
     mov   di,dx
     shl   di,1    ; x 2
     add   di,dx   ; x 3
     shl   di,1    ; x 6
     call  trace
    jnc   compress
     ret
;
tracei:
    call  inc_loc
    jc    tr0
;
trace:
; di has the root of a problem and it is undestood that
; al matches
; have to get the next guy to see if he is involved here
    call  get_byte
    jnc   tr1
tr0:
; no bytes left, get rid of current guy and scram
    mov   ax,di
    mov   dx,0
    mov   cx,6
    div   cx
    call  put_byte
    ret
tr1:
; al has a character, di is the current location, we need to
; trace through to see if this is a string
;
;  test next1
;
    cmp   es:[di].first,0ffffh
    jne   tr3
; must add the first guy to di
    mov   si,di
    call  get_free  ; get the next free node into bx
    mov  es:[si].first,bx
    cmp  bx,0ffffh
    jne  tr2
    jmp  store_bytes
tr2:
    mov  es:[bx].who,ax
    mov  es:[bx].next,0ffffh
    mov  es:[bx].first,0ffffh
    mov  di,si
    jmp  store_bytes
tr3:
; have a first, go to it
    mov   bx,es:[di].first
    jmp   test_f
    cmp   ax,es:[bx].who
    jne   tr4
    mov   di,bx
    jmp   tracei
tr4:
    mov   bx,es:[bx].next
    cmp   bx,0ffffh
    jne   test_f
no_follow:
; we have a guy in di but there is no match above
; have to add a next
    call  get_free  ; get the next free node into bx
    mov  es:[di].next,bx
    jmp  nf1
test_f:
; there is a next, follow it
    cmp   es:[bx].who,ax
    je    got_hit
    cmp   es:[bx].next,0ffffh
    je    no_follow1
    mov   bx,es:[bx].next
    jmp   test_f
; got a hit
got_hit:
    mov   di,bx
    jmp   tracei
no_follow1:
; have a hit on this bx
    mov   si,bx
    call  get_free  ; get the next free node into bx
    mov  es:[si].next,bx
;
; when we get here we have a mismatch in al and as far as we got in di
; if bx = 0ffffh then we are out of string space
nf1:
    cmp  bx,0ffffh
    je   store_bytes
    mov  es:[bx].first,0ffffh
    mov  es:[bx].who,ax
    mov  es:[bx].next,0ffffh
store_bytes:
    push  ax
    push  cx
    mov   ax,di
    mov   dx,0
    mov   cx,6
    div   cx
    call  put_byte
    jc    nok_t
    cmp   free,0ffffh
    jne   no_re_init
    mov   ax,0e07h
    int   10h
    call  init_nodes
no_re_init:
    pop   cx
    pop   ax
     mov   dx,ax
     and   dx,0ffh
     mov   di,dx
     shl   di,1    ; x 2
     add   di,dx   ; x 3
     shl   di,1    ; x 6
    jmp   tracei
nok_t:
    pop   cx
    pop   ax
    stc
    ret
;
;
;
;
get_free:
; this grabs the next free guy from list
gf0:
   mov  bx,free
   cmp  bx,0ffffh
   jne  gf1
   ret
gf1:
   mov  dx,es:[bx].next
   mov  free,dx
   ret
;
;
;
;
init_nodes:
    push  ax
    push  di
    mov   di,0
    mov   bp,es
    mov   es,nodespace
    mov   cx,256
    mov   ax,0
in1:
    mov   es:[di].next,0ffffh
    mov   es:[di].first,0ffffh
    mov   es:[di].who,ax
    inc   ax
    add   di,6
    loop  in1
; set up the free chain
;   mov   cx,(0fff0h/6)-257
    mov   cx,4096-257
;   mov   cx,1024-257
in2:
    mov   ax,di
    add   ax,6
    mov   es:[di].first,0ffffh
    mov   es:[di].next,ax
    mov   di,ax
    loop  in2
    mov   es:[di].next,0ffffh
    mov   es:[di].first,0ffffh
    mov   es,bp
    mov   free,6*256
    mov   bits,9
    mov   bitsize,1ffh
    pop   di
    pop   ax
    ret
;
put_byte:
     push   ax
     push   bx
     push   di
     mov    cx,bits
     mov    dx,bitsize
     cmp    ax,dx
     jbe    pb_1
     inc    cx
     shl    dx,1
     or     dx,1
     mov    bits,cx
     mov    bitsize,dx
pb_1:
      add   out_size,cx
      adc   out_size+2,0
     mov   di,outloc
     mov   bp,es
     mov   es,buffero
     stosw
     mov  es,bp
     mov  outloc,di
     cmp  di,0fff0h
     ja   fill_buff
     pop  di
     pop  bx
     pop  ax
     clc
     ret
fill_buff:
     mov   cx,di
     call  write_file
     mov   outloc,0
     pop  di
     pop  bx
     pop  ax
     ret
;
inc_loc:
;
     push  bx
     push  cx
     push  si
     push  di
     mov   si,bufferloc
     inc   si
     cmp   si,file_size
     jb    ok_fsize
     call  read_file
     mov   si,bufferloc
     cmp   ax,0
     jne   got_byte
     pop   di
     pop   si
     pop   cx
     pop   bx
     stc
     ret
ok_fsize:
     mov   bufferloc,si
     pop   di
     pop   si
     pop   cx
     pop   bx
     clc
     ret
;
;
; this gets the next byte out of the buffer
get_byte:
     push  bx
     push  cx
     push  si
     push  di
     mov   si,bufferloc
     cmp   si,file_size
     jb    got_byte
     call  read_file
     mov   si,bufferloc
     cmp   ax,0
     jne   got_byte
     pop   di
     pop   si
     pop   cx
     pop   bx
     stc
     ret
got_byte:
     mov   bp,ds
     mov   ds,bufferi
     lodsw
     dec   si
     mov  ds,bp
     mov   bufferloc,si
     pop   di
     pop   si
     pop   cx
     pop   bx
     clc
     ret
