;
; this is a skeleton for passthrough  or resident programs
;
; when compiled as a pass through program it will use a little over
; 5K of system memory. When compiled as resident program it takes
; about 1.5k. When you add your own routines an work areas this
; will increase.
;
passthru = 1  ; 1 is true which means MASM will create the passthroug
              ; version.
; if you are making a passthroug version then rou are not making
; a resident version. And if you are not making a passthrough then
; you are making a resident.
;
print macro string
    lea dx,string
    mov  ah,9
    int  21h
    endm
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
stack   dw   256  dup(0)
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
mess0    db  'QBAT version 1.00',13,10
         db  'Copyright 1988 by Keith P. Graham',13,10,10
         db  'QBAT Quick Batch system service installing....',13,10
         db  '$'
bhandle dw  0  ; tha batch handle
bline db 129 dup(0)
buffer db 2048 dup(0)
bl1   dw  0
bl2   dw  0
;
; this data is used by the passthru program only
;
if passthru
mess1    db  13,10,'QBAT Quick Batch service complete',13,10,'$'
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
START        PROC        far
dos:
; we are entering here due to a key being struck
; first check the dos area to see if the CTRL and ALT are ppasssed
;
; first call the dos interrupt so that it can handle the
; dos call we are interested in 2 calls, open and read
;
;       cmp    ah,3fh  ; read
;       jne    no_3f
;       cmp   bx,cs:bhandle
;       je    got_a_read
;       jmp   cs:int21
;ot_a_read:
;       pushf
;       call  cs:int21
;       push  ax
;       pushf
;       push  cs
;       lea   ax,do_iret
;       push  ax
; this is the read routine
; call  reader
;       iret
no_3f:
        cmp    ah,3eh  ; close
        jne    no_3e
        cmp   bx,0
        je    do_the_close
        cmp   bx,cs:bhandle
        je    got_a_close
do_the_close:
        jmp   cs:int21
got_a_close:
; we ignore bat file closes unless someone reopens a bat file
        clc
        ret   2
no_3e:
        cmp    ax,3d00h; open input
        jne    no_3d
;
;       int   3
;
       cmp  cs:bhandle,0
       je   no_current_handle
       call comp_bat
       jc   close_cur_bat
; we are experiencing a call to open the current bat file
       cmp  cs:bl1,0
       jne  reset_buffer
       cmp  cs:bl2,0
       jl   do_reset_buffer
       cmp  cs:bl2,2047
       jg   do_reset_buffer
       mov  ax,cs:bhandle
       mov  cs:bl2,0
       clc
       ret  2   ; done without a new open
do_reset_buffer:
       call  reset_buffer
       clc
       ret  2   ; done without a new open
close_cur_bat:
       push   ax
       push   bx
       push   cx
       push   dx
       mov    ah,3eh ; close
       mov    bx,cs:bhandle
       pushf
       call   cs:int21
       mov   cs:bhandle,0
       pop   dx
       pop   cx
       pop   bx
       pop   ax
no_current_handle:
       call  check_for_bat
       jnc   is_new_bat
       jmp   not_our_3e
is_new_bat:
       call  save_bat_name
        mov   cs:bhandle,0
; now open the file normally and save the handle
        pushf
        call  cs:int21
        push  ax
        pushf
        jc   open_failed
        mov   cs:bhandle,ax
        call  rest_buffer
open_failed:
        push  cs
        lea   ax,do_iret
        push  ax
; we have a new open, we have to save the handle
        iret
not_our_3e:
        jmp   cs:int21
no_3d:
        jmp   cs:int21
do_iret:
        pop  ax
        ret 2
START        ENDP
service proc  near
; these are the near service routines for START
reset_buffer:
; here we have to reload the buffer
      mov  cs:bl1,0
      mov  cs:bl2,0
      call load_buffer
      ret
load_buffer:
      push  ax
      push  bx
      push  cx
      push  dx
      push  ds
      push  cs
      pop   ds
      mov  cx,bl2
      mov  dx,bl1
; first locate at the current position
      pop  ds
      pop  dx
      pop  cx
      pop  bx
      pop  ax
      ret
comp_bat:
; is the new bat name the same as the saved bat name
      push  ax
      push  cx
      push  si
      push  di
      push  es
      push  cs
      pop   es
      mov   si,dx
      lea   di,bline
      mov   cx,129
      cld
cb_loop:
      lodsb
      cmp  al,byte ptr es:[di]
      jne  not_same_bat
      cmp  al,0
      je   same_bat
      inc  di
      loop cb_loop
not_same_bat:
      pop   es
      pop   di
      pop   si
      pop   cx
      pop   ax
      stc
      ret
same_bat:
      pop   es
      pop   di
      pop   si
      pop   cx
      pop   ax
      clc
      ret
save_bat_name:
      push  ax
      push  cx
      push  si
      push  di
      push  es
      push  cs
      pop   es
      mov   si,dx
      lea   di,bline
      mov   cx,128
      cld
rep   movsb
      pop   es
      pop   di
      pop   si
      pop   cx
      pop   ax
      clc
      ret
check_for_bat:
      push  ax
      push  cx
      push  si
      push  di
      push  es
      push  ds
      pop   es
;
      mov   cx,128
      cld
      mov   di,dx
      mov   al,0
repne scasb
      sub   di,5
      cmp   word ptr es:[di],'B.'
      jne   no_bat
      cmp   word ptr es:[di+2],'TA'
      jne   no_bat
; got a batch file from dos
      pop   es
      pop   di
      pop   si
      pop   cx
      pop   ax
      clc
      ret
no_bat:
      pop   es
      pop   di
      pop   si
      pop   cx
      pop   ax
      stc
      ret
service endp
setpass  proc  near
; set up a local stack
        lea  sp,stack+510
        print mess0
;
; redirect interrupts here
;
        push  es
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        pop   es
        mov   ah,25h
        mov   al,21h
        lea   dx,dos
        int   21h
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   print   mess1
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int21
        mov   ah,25h
        mov   al,21h
        int   21h
        pop   ds
        int   20h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int 27h
endif
setpass  endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
