
open_file proc far
; check to make sure that the 0d is gone
	mov	si,dx
	mov	cx,30
op_f_loop:
	cld
	lodsb
	cmp	al,0
	je	op_f_exit
	cmp	al,0dh
	loopnz	op_f_loop
	mov	byte ptr ds:[si-1],0
op_f_exit:
	mov	handle,0
	mov	ax,3d10h
	int	21h
	jnc	goodo
	stc
	ret
goodo:
	mov	handle,ax
	clc
	ret
open_file endp

close_file proc far
 	mov	ah,3eh
 	mov	bx,handle
 	int	21h
	ret
close_file endp

openfile proc  far
; opens the file for reading
	mov	dx,offset infile
	call	open_file
	jnc	good_open
	mov	dx,offset error1
	mov	error_code,dx
 	stc
	ret
good_open:
	clc
	ret
openfile endp

setup_screen proc far
	call    far ptr clearscr
	mov	si,offset top_line
	mov	di,0
	call    far ptr printat
	mov	si,offset upx
	mov	di,110
	call    far ptr printat
	mov	si,offset bot_line
	mov	di,24*80*2
	call    far ptr printat
	ret
setup_screen endp
printat proc far
; si points to string, di points to video
	push	es
	mov	es,vbuff
pa_loop:
	cld
	lodsb
	cmp	al,0
	je	exit_pa
	stosb
	inc	di
	jmp	pa_loop
exit_pa:
	pop	es
	ret
printat endp

;
;
; service routines
;
clearscr proc far
; main screen
	mov	ah,7
	mov	al,0
	mov	bh,color2
	mov	bl,0
	mov	cx,0000h
	mov	dx,184fh
	int	10h
; bottom line
	mov	ah,7
	mov	al,0
	mov	bh,color1
	mov	bl,0
	mov	cx,1800h
	mov	dx,184fh
	int	10h
; arrows
	mov	ah,7
	mov	al,0
	mov	bh,color4
	mov	bl,0
	mov	cx,1844h
	mov	dx,184fh
	int	10h
; top line
	mov	ah,7
	mov	al,0
	mov	bh,color4
	mov	bl,0
	mov	cx,0000h
	mov	dx,004fh
	int	10h
; arrows
	mov	ah,6
	mov	al,0
	mov	bh,color1
	mov	bl,0
	mov	cx,0000h
	mov	dx,0043h
	int	10h
	ret
clearscr endp


;
;
display_line proc far
; this displays a line.
; curline has the line start in file
; topline has the page start in file
; x and y are current print location
;
; now where to put it
	mov	al,y
	mov	cl,160
	mul	cl
	mov	di,ax
	mov	al,x
	mov	ah,0
	shl	ax,1
	add	di,ax
	mov	cx,vwid
	mov	ah,color2
; put the info to screen
	push	es
;
	mov	es,vbuff
dl_loop:
; check for segmentness
	call    far ptr get_byte
	jc	done_text
	cmp	al,13
	je	dl_loop
	cmp	al,10
	je	done_text
	cmp	al,9	; tab character
	je	tab_char
	stosb
	inc	di
dl_eloop:
	loop	dl_loop
	jmp	done_line
tab_char:
	mov	al,20h
	stosb
	inc	di
	test	di,15
	jz	dl_eloop
	loop	tab_char
	jmp	done_line
done_text:
	mov	al,20h
	stosb
	inc	di
	loop	done_text
;
done_line:
	pop	es
	ret
display_line endp

;
display_page proc far
xx
	mov	si,offset top_line
	mov	di,0
	call	printat
	mov	si,offset upx
xx
	mov	di,110
	call	printat
	mov	si,offset bot_line
xx
	mov	di,24*80*2
	call	printat
; does the current page
xx
	mov	ax,topline
	mov	curline,ax
	mov	ax,topline+2
	mov	curline+2,ax
	mov	ah,ux
	mov	x,ah
	mov	ah,uy
	mov	y,ah
	mov	cx,vlen
dp_loop:
	push	cx
	call	display_line
	inc	y
	pop	cx
	loop	dp_loop
	ret
display_page endp

;
read_file proc far
; get the file into memory
; this works byt allocatting an array of pointers
	mov	di,0
	mov	cx,buffermax
	mov	buffcount,0
	mov	file_size,0
	mov	file_size+2,0
rf_loop:
	push	cx
	push	di
; allocate 32k buffer for file access
	mov	ah,48h
	mov	bx,(buffersize+15)/16
	int	21h
	jc	done_read
	pop	di
	push di
	mov	buffers[di],ax
	push	ds
	mov	bx,handle
	mov	dx,0
	mov	cx,buffersize
	mov	ds,ax
	mov	ah,3fh
	int	21h
	pop	ds
	jc	bad_read1
	cmp	ax,0
	je	done_read
	pop	di
	mov	buffers[di]+2,ax
	inc	buffcount
	add	file_size,ax
	adc	file_size+2,0
	add	di,4
	pop	cx
	loop	rf_loop
	mov	buffers[di]+2,0
	mov	buffers[di],0
	clc
	ret
done_read:
; finished file read
	pop	di
	mov	buffers[di]+2,ax
	pop	cx
	call	close_file
	cmp	file_size,0
	jne	good_f
	cmp	file_size+2,0
	je	bad_read
good_f:
	cmp	buffcount,0
	je	bad_mem
	clc
	ret
bad_mem:
	mov	dx,offset error2
	mov	error_code,dx
	stc
	ret
bad_read1:
	pop	di
	pop	cx
	call	close_file
bad_read:
	mov	dx,offset error3
	mov	error_code,dx
	stc
	ret
read_file endp

;
find_prev proc far
; goes back
	call    far ptr get_prev ; passed the current 10
	jnc	prev10
	stc
	ret
;
; search for prev 10
prev10:
	call    far ptr get_prev
	jc	done_prev2
	cmp	al,10
	jne	prev10
done_prev:
	call    far ptr get_byte ; past the 10
done_prev2:
	dec	bline
	ret
find_prev endp

;
find_next proc far
; advances one line
;
;	find out if we are already at the end of the line
; search for next 10
	call    far ptr get_byte
	jc	done_next
	inc	bline
next10:
	cmp	al,10
	je	done_next1
	call    far ptr get_byte
	jc	done_next
	jmp	next10
done_next1:
	clc
	ret
done_next:
	stc
	ret
find_next endp
;
;
;
get_prev proc far
; this gets the next byte from the buffers
; current byte is in currline
	push bx
	push dx
	push si
	push bp
gp_0:
	mov	bx,curline ; segment number of current line
	cmp	bx,0
	jl	gp_done
	mov	si,curline+2
	shl	bx,1
	shl	bx,1
	mov	bp,buffers[bx]
; we are going backwards
	cmp	si,0
	jne	gp_2
	cmp	bx,0
	je	gp_done
	jmp	gp_1
gp_done:
	pop	bp
	pop	si
	pop	dx
	pop	bx
	stc
	ret
gp_1:
; need to back up a segment
	dec	curline
	sub	bx,4
	mov	bp,buffers[bx]
	mov	dx,buffers[bx]+2
	mov	si,dx
;
gp_2:
; get the byte
	dec	si
	mov	curline+2,si
; get the byte
	push ds
	mov	ds,bp
	cld
	lodsb
	pop	ds
gp_exit:
	pop	bp
	pop	si
	pop	dx
	pop	bx
	clc
	ret
get_prev endp
;
;
get_byte proc far
; current byte is in currline
	push bx
	push dx
	push si
	push bp
	mov	bx,curline ; segment number of current line
	mov	si,curline+2
	shl	bx,1
	shl	bx,1
	mov 	bp,buffers[bx]
	mov	dx,buffers[bx]+2
	cmp	bp,0
	je	gb_done
	cmp	dx,0
	je	gb_done
; get the byte
	push ds
	mov	ds,bp
	cld
	lodsb
	pop	ds
;	cmp	al,26
;	je	gb_done
	mov	curline+2,si
	cmp	dx,si
	ja	gb_exit
; get next segment
	mov	curline+2,0
	inc	curline
	cmp	buffers[bx]+4,0
	je	gb_done
gb_exit:
	pop	bp
	pop	si
	pop	dx
	pop	bx
	clc
	ret
gb_done:
	pop	bp
	pop	si
	pop	dx
	pop	bx
	stc
	ret
get_byte endp
;
unallocate proc far
	mov	di,0
una_loop:
	mov	dx,buffers[di]
	cmp	dx,0
	je	done_un
	mov	buffers[di],0
	mov	buffers[di]+2,0
	push di
	push es
	mov	es,dx
	mov	ah,49h
	int	21h
	pop	es
	pop	di
	jc	done_un
	add	di,4
	jmp	una_loop
done_un:
	ret
unallocate endp
;
do_line_no proc far
; do the line number
	mov	ax,bline
	inc	ax
	mov	cx,100
	mov	dx,0
	div	cx
	mov	cl,10
	div	cl
	or	ax,3030h
	mov	di,offset lineno
	stosw
	mov	ax,dx
	div	cl
	or	ax,3030h
	stosw
	ret
do_line_no endp
;
print_byte proc far
; get the printer status first
	push	ax
	mov	ah,2
	mov	dx,0
	int	17h
	test	ah,2bh
	pop	ax
	jz	cont_print
	stc
	ret
cont_print:
	mov	ah,0
	mov	dx,0
	int	17h
good_print:
	clc
	ret
print_byte endp
prtstat proc far
	push	ax
	mov	dx,0
	mov	ah,2
	int	17h
	mov	bl,0
	test ah,2bh
	jz	good_pexit
	pop	ax
	stc	
	ret
good_pexit:
	pop	ax
	clc
	ret
prtstat endp

