print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
node struc
  weight dw ?
  rank   dw ?
  parent dw ?
  child  dw ?
node ends
;
turnpoint equ 200
;
;
entry:
        jmp   start
;  data
;
;
;
tablesize equ 257
;
ltable1 db 2   dup(3) ;2
        db 3   dup(4) ;4
        db 4   dup(5) ;8
        db 7   dup(6) ;17
        db 13  dup(7) ;30
        db 25  dup(8) ;55
        db 201 dup(9) ;256
ltable2  db 256 dup(8)
ltable3  db 1   dup(2)
        db 1   dup(3) ;2
        db 2   dup(4) ;4
        db 3   dup(5) ;7
        db 5   dup(6) ;12
        db 8   dup(7) ;20
        db 13  dup(8) ;33
        db 21  dup(9) ;54
        db 202 dup(10);42+54+176
ltable4 db 2   dup(2)
        db 2   dup(3) ;
        db 2   dup(4) ;
        db 2   dup(5) ;
        db 2   dup(8) ;
        db 2   dup(7) ;
        db 2   dup(8) ;
        db 2   dup(9) ;
        db 2   dup(10) ;
        db 2   dup(11) ;
        db 4   dup(12) ;
        db 243 dup(255)
tcount  dw 0
total1  dw 0
total2  dw 0
total3  dw 0
total4  dw 0
follows db 256 dup(20h)
prev    dw 20h
;
;
; this is the linked list for rank and weight
compress:
; ax has the number of bytes to process
   mov   cx,ax
   mov   di,0
   mov   si,di
   cld
c_loop:
   push  cx
   mov   bp,ds
   mov   ds,bufferi
;
   lodsb
   mov   ah,0
   mov   ds,bp
; check follow table
   mov   dx,word ptr es:home.child
;  mov   bx,word ptr es:home[bx].child
;  mov   dx,word ptr es:home[bx].child
   shr   dx,1
   shr   dx,1
   shr   dx,1
   dec   dx
; dx has the who of the most common
   mov   bx,prev
   mov   prev,ax
   cmp   follows[bx],al
   je    got_follows
   cmp   ax,dx
   je    force_error
   mov   follows[bx],al
   jmp   done_follows
force_error:
;  mov   al,follows[bx]
   xchg  al,follows[bx]
   jmp   done_follows
got_follows:
   mov   ax,dx
done_follows:
; first output the string
   mov   bx,ax
   inc   bx  ; get past home
   shl   bx,1
   shl   bx,1
   shl   bx,1
; bx points into the nodes table
   call  out_byte
; now fix up the weight
   call  fix_weight
;
   pop   cx
   loop  c_loop
   mov   cx,di
   ret
bad_out:
   pop   cx
   stc
   ret
check_weight:
   cmp   dx,0
   jg    rank_hi
   cmp   ds:home.weight,turnpoint
   jle   rank_hi
   mov   cx,tablesize
   mov   si,bx
w_loop:
   mov   ax,word ptr nodes[si].weight
   mov   dx,ax
   inc   dx
   shr   dx,1
   shr   dx,1
   shr   dx,1
   shr   dx,1
   cmp   dx,0
   jle   rank_hi
   sub   ax,dx
   mov   word ptr nodes[si].weight,ax
   mov   si,word ptr ds:home[si].child
   loop  w_loop
rank_hi:
   ret
out_byte:
; sends the string in ax out cx bits
   push  bx
   mov   bx,ds:home[bx].rank
   mov   cl,ltable1[bx]
   mov   ch,0
   push  cx
   add   total1,cx
   mov   cl,ltable2[bx]
   mov   ch,0
   add   total2,cx
   mov   cl,ltable3[bx]
   mov   ch,0
   add   total3,cx
   mov   cl,ltable4[bx]
   mov   ch,0
   cmp   total4,-1
   je    ntotal4
   cmp   cx,255
   jne   itotal4
   mov   total4,-1
   jmp   ntotal4
itotal4:
   add   total4,cx
ntotal4:
   inc   tcount
   mov   ax,bx
   mov   bp,es
   mov   es,buffero
   stosb
   mov   es,bp
   cmp   tcount,64
   jl    no_out_work
   mov   tcount,0
   mov   cx,total1
   mov   total1,0
   cmp   cx,total2
   jb    not_t2
   mov   cx,total2
not_t2:
   mov   total2,0
   cmp   cx,total3
   jb    not_t3
   mov   cx,total3
not_t3:
   mov   total3,0
   cmp   cx,total4
   jb    not_t4
   mov   cx,total4
not_t4:
   mov   total4,0
   add   cx,8
   add   out_size,cx
   adc   out_size+2,0
no_out_work:
   pop   cx  ; must set the length correctly
   pop   bx
;  sub   cx,bitmax+1
;  neg   cx
   ret
fix_weight:
   push  si
   push  di
   add   cx,ds:home[bx].weight
   mov   ds:home[bx].weight,cx
   mov   dx,ds:home[bx].rank
   cmp   dx,0
   jl    no_swap
   mov   si,ds:home[bx].parent
;
;
   cmp   ds:home[si].weight,cx
   jg    no_swap
   mov   di,ds:home[bx].child
;  first thing to do is remove our node
;  this is done by making the parent of or child our parent
;  and the child of our parent our child
   mov   ds:home[si].child,di
   mov   ds:home[di].parent,si
;  now look for a parent that has a weight freater than our weight
check_again:
; no swap so we dec the parents dx
   mov   ds:home[si].rank,dx
   dec   dx
   mov   si,ds:home[si].parent  ; we look at next parent
   cmp   ds:home[si].weight,cx
   jge   do_swap
   jmp   check_again
do_swap:
; we set up our rank
   mov   ds:home[bx].rank,dx
;  our new child must be the parents child
   mov   di,ds:home[si].child
   mov   ds:home[bx].child,di
; parents child must be us
   mov   ds:home[si].child,bx
; our parent must be parent
   mov   ds:home[bx].parent,si
; our child must have us for a parent
   mov   ds:home[di].parent,bx
;  jmp   no_swap
;
;
no_swap:
; here we have to see if the ranks need changing
; bx is pointing to our hit
   call  check_weight
   pop   di
   pop   si
   ret
home  node <7fffh,0,0,8>
nodes dw tablesize dup(0,0,0,0)
last  node <-1,0,tablesize*8,0>
;
;
;
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 'thanks',13,10
out_string db '                 ',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
curr_bits dw 0
out_size  dw 0,0
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
    call  init_nodes
    mov   curr_bits,0
read_loop:
    call  read_file
    jc    error_exit
    cmp   ax,0
    je    good_exit
    call  compress
    call  write_file
    jc    error_exit
    jmp   read_loop
good_exit:
; now try and figure out how good our compression is
    lea   di,out_string
    mov   ax,out_size
    mov   dx,out_size+2
    shr   dx,1
    rcr   ax,1
    shr   dx,1
    rcr   ax,1
    shr   dx,1
    rcr   ax,1
    inc   ax
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    lea   dx,goodbye
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
init_nodes:
; this initializes nodes
   mov  ax,0
   cld
   mov  di,0
   mov  cx,tablesize
in_0:
   mov  nodes[di].weight,0
   mov  nodes[di].rank,ax
   mov  bx,di
   mov  nodes[di].parent,bx
   add  bx,16
   mov  nodes[di].child,bx
   inc  ax
   add  di,8
   loop in_0
   ret
;
write_file:
; get the file into memory
; cx has the size of file to write
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    lea dx,error5
    stc
    ret
good_write:
    clc
    ret
;
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,07000h
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    lea dx,error3
    stc
    ret
good_read:
    mov   file_size,ax
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:buffero,ax
    clc
    ret
cseg ends
    end entry
