print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
entry:
        jmp   start
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 'thanks',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
rle:
; this takes the data in buffer and squeezes it into targ_buff
;
;
; 
     push  ds
     push  es
     mov  bp,cx
     mov  si,0
     mov  bx,0
     mov  ax,0
     mov  di,bx
     mov  cx,0
     mov  es,buffero
     mov  ds,bufferi
     stosb
top:
     lodsb
     cmp  bp,3
     jle  is_diff
     cmp  ds:[si],al
     jne  is_diff
     cmp  ds:[si+1],al
     jne  is_diff
;    cmp  ds:[si+2],al
;    jne  is_diff
; is same
     cmp   cx,0
     je    new_string
; finish the last diff string
     mov  byte ptr es:[bx],cl
     jmp  old_string
new_string:
     mov  di,bx
old_string:
; scan to see how long characters last
     mov  bx,di    ; save di
     mov  di,si    ; set scan start
     mov  cx,bp    ; set scan limit , bp has remaining bytes + 1
     dec  cx       ; bp has not been decremented yet
     cld
     push  es
     push  ds
     pop   es
repe scasb
     pop   es
     jne   cx_nz   ; if last byte is not equal then continue
     inc   di      ; else we have to bump up to get correct count
cx_nz:
     mov  cx,di    ; byte after unequal byte
     sub  cx,si    ; byte after first byte of string, cx has length
; here if cx is between 100h and 2ffh then we use second method
     add  si,cx    ; si now points to first unequal byte
     dec  si
     mov  di,bx    ; restore di
     sub  bp,cx    ; dec bp by amount of string
     cmp  cx,128
     jl   old_method
; cx is 100 to 2ff
     mov  dl,al    ; save al for store
     mov  al,-1    ; -1 indicates that a word length is stored
     stosb
     mov   ax,cx   ; next length
     stosw
     mov   al,dl
     stosb         ; next byte
     jmp   end_string
old_method:
     neg  cx
     mov  ah,al
     mov  al,cl
     stosw
end_string:
     mov  cx,0     ; count
     mov  bx,di    ; count byte
     mov  al,0     ; start at 0
     stosb         ; store it
     jmp  bot
is_diff:
     dec  bp
     stosb
     inc  cx
     cmp  cx,126
     jg   do_string
     jmp  bot
do_string:
     mov  byte ptr es:[bx],cl
     mov  cx,0
     mov  bx,di
     mov  al,0
     stosb
bot:
    cmp   bp,0
    jle   bot1
    jmp   top
bot1:
    cmp   cx,0
    je    bot2
    mov  byte ptr es:[bx],cl
    inc  di
bot2:
    dec   di
    mov   cx,di
;   mov   word ptr es:[0],cx  ; places rle length in first word of buffer
     pop   es
     pop   ds
     ret
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
read_loop:
    call  read_file
    jc    error_exit
    cmp   ax,0
    je    good_exit
    mov   cx,ax
    call  rle
    mov   cx,di
    call  write_file
    jc    error_exit
    jmp   read_loop
good_exit:
    lea   dx,goodbye
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
;
;
write_file:
; get the file into memory
; cx has the size of file to write
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    lea dx,error5
    stc
    ret
good_write:
    clc
    ret
;
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,07000h
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    lea dx,error3
    stc
    ret
good_read:
    mov   file_size,ax
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate stack
    mov  ah,48h
    mov  bx,100h ; 256*16 = 4096
    int  21h
    jc   bad_mem
    pop  bx
    mov  ss,ax
    mov  sp,4094
    push bx
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:buffero,ax
    clc
    ret
cseg ends
    end entry
