rmax equ 255
ccc = 0
depth equ 5
;
last_code  db 0
which_half dw 0
;
;
;
init_time  dw 0
;
free_up:
     inc   init_time
     cmp   init_time,15
     jne   free_up1
     call  init_nodes
     mov   init_time,-1
     ret
free_up1:
     push  ax
     push  bx
     push  cx
     push  dx
     push  si
     push  di
     mov   di,0
     mov   cx,256
fu_1:
     push  cx
     mov   bx,di
     mov   cx,44
     cmp   cx,es:[bx].rank
     jle   fu_2
     mov   cx,es:[bx].rank
     cmp   cx,0
     jle   fu_3
fu_2:
     push  cx
     push  di
     push  bx
     call  free_node
     pop   bx
     pop   di
     pop   cx
     loop  fu_2
fu_3:
     add   di,8
     pop   cx
     loop  fu_1
     pop   di
     pop   si
     pop   dx
     pop   cx
     pop   bx
     pop   ax
     cmp   free,-1
     jne   free_by
     call  init_nodes
free_by:
     ret
;
;
free_node:
     cmp   es:[di].first,-1
     je    fu1
     push  di
     mov   di,es:[di].first
     call  free_down
     pop   di
fu1:
     ret
; if rank is equal to bas rank then delete it
free_down:
     mov   ax,es:[bx].rank
     cmp   es:[di].rank,ax
     jne   fd0
; this guy is a leaf, must be freed
     stc
     ret
fd0:
     cmp   es:[di].next,-1
     jne   fd1
     cmp   es:[di].first,-1
     jne   fd2
     clc
     ret
fd1:
; have to trace next
     push  di
     mov   di,es:[di].next
     call  free_down
     jc    free_next
     pop   di
     cmp   es:[di].first,-1
     jne   fd2
     clc
     ret
free_next:
; di is node to be freed
     mov   ax,free
     mov   es:[di].next,ax
     dec   es:[bx].rank
     mov   free,di
     pop   di
     mov   es:[di].next,-1
     clc
     ret
fd2:
; have to trace first for the node
     push  di
     mov   di,es:[di].first
     call  free_down
     jc    free_first
     pop   di
     clc
     ret
free_first:
; di is node to be freed
     mov   ax,free
     mov   es:[di].next,ax
     mov   free,di
     dec   es:[bx].rank
     pop   di
     mov   es:[di].first,-1
     clc
     ret
;


;
;
compress:
     cld
     call  get_byte
     jnc   trace0
     clc
     ret
;
trace0:
     mov   last_code,al
     call  out_byte
;
    call  get_byte
    jnc   trace2
; no bytes left, get rid of current guy and scram
    clc
    ret
trace2:
     mov   bl,last_code
     mov   bh,0
     shl   bx,1    ; x 2
     shl   bx,1    ; x 4
     shl   bx,1    ; x 4
     mov   di,bx   ; save to update rank
     mov   dx,0
; di has the start
    cmp   es:[di].first,-1
    jne   tr3
; must add the first node
    call  get_free
    jnc   tr2
    call  free_up
;   call  init_nodes
    call  get_free
tr2:
    mov   es:[di].first,si
    mov   es:[si].who,al
    mov   es:[si].next,-1
    mov   es:[si].first,-1
    mov   es:[si].rank,-1
    jmp   trace0
tr3:
; mov up in the world
    mov   di,es:[di].first
    mov   si,di
tr4:
    cmp   es:[si].who,al
    je    match_first
    cmp   es:[si].next,-1
    je    tr5
    mov   si,es:[si].next
    jmp   tr4
tr5:
; no hit add the side
    mov   di,si
    call  get_free
    jnc   tr_6
    call  free_up
;   call  init_nodes
    call  get_free
tr_6:
    mov   es:[di].next,si
    mov   es:[si].who,al
    mov   es:[si].next,-1
    mov   es:[si].first,-1
    mov   es:[si].rank,-1
    jmp   trace0
match_first:
    inc   dx
    mov   last_code,al
    mov   di,si
    call  get_byte
    jnc   fr1
    call  out_byte
    clc
    ret
fr1:
    cmp   es:[di].first,-1
    jne   fr3
; must add the first node
    cmp   es:[bx].rank,rmax
    jge   fr2a
    call  get_free
    jnc   fr2
    call  free_up
;   call  init_nodes
; we have had to reinitialize so start again
     mov   bl,last_code
     mov   bh,0
     mov   di,bx
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     shl   di,1    ; x 4
     mov   bx,di   ; save to update rank
    call  out_byte
     jmp   trace0
fr2:
    mov   es:[di].first,si
    mov   es:[si].who,al
    mov   es:[si].next,-1
    mov   es:[si].first,-1
    mov   cx,es:[bx].rank
    inc   cx
    mov   es:[bx].rank,cx
    mov   es:[si].rank,cx
fr2a:
    push  ax
    mov   al,last_code
    call  out_byte
    pop   ax
    jmp   trace2
fr3:
; mov up in the world
    mov   di,es:[di].first
    mov   si,di
fr4:
    cmp   es:[si].who,al
    je    match_second
    cmp   es:[si].next,-1
    je    fr5
    mov   si,es:[si].next
    jmp   fr4
fr5:
; no hit add the side
    cmp   es:[bx].rank,rmax
    jge   fr6a
    mov   di,si
    call  get_free
    jnc   fr6
    call  free_up
;   call  init_nodes
     call  out_byte
     mov   bl,last_code
     mov   bh,0
     mov   di,bx
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     shl   di,1    ; x 4
     mov   bx,di   ; save to update rank
     jmp   trace0
fr6:
    mov   es:[di].next,si
    mov   es:[si].who,al
    mov   es:[si].next,-1
    mov   es:[si].first,-1
    mov   cx,es:[bx].rank
    inc   cx
    mov   es:[bx].rank,cx
    mov   es:[si].rank,cx
fr6a:
    push  ax
    mov   al,last_code
    call  out_byte
    pop   ax
    jmp   trace2
match_second:
    inc   dx
    mov   last_code,al
    mov   di,si
    call  get_byte
    jnc   sr1
    call  out_code
    clc
    ret
sr1:
    cmp   es:[di].first,-1
    jne   sr3
; must add the first node
    cmp   es:[bx].rank,rmax
    jge   sr2a
    cmp   dx,depth
    jge   sr2a
    call  get_free
    jnc   sr2
    call  free_up
;   call  init_nodes
; we have had to reinitialize so start again
     call  out_code
     mov   bl,last_code
     mov   bh,0
     mov   di,bx
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     shl   di,1    ; x 4
     mov   bx,di   ; save to update rank
     jmp   trace0
sr2:
    mov   es:[di].first,si
    mov   es:[si].who,al
    mov   es:[si].next,-1
    mov   es:[si].first,-1
    mov   cx,es:[bx].rank
    inc   cx
    mov   es:[bx].rank,cx
    mov   es:[si].rank,cx
sr2a:
    call  out_code
    cmp   es:[bx].rank,rmax
    jmp   trace2
sr3:
; mov up in the world
    mov   di,es:[di].first
    mov   si,di
sr4:
    cmp   es:[si].who,al
    je    match_second
    cmp   es:[si].next,-1
    je    sr5
    mov   si,es:[si].next
    jmp   sr4
sr5:
; no hit add the side
    mov   di,si
    cmp   es:[bx].rank,rmax
    jge   sr6a
    call  get_free
    jnc   sr6
    call  out_code
;   call  init_nodes
    call  free_up
     mov   bl,last_code
     mov   bh,0
     mov   di,bx
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     shl   di,1    ; x 4
     mov   bx,di   ; save to update rank
     jmp   trace0
sr6:
    mov   es:[di].next,si
    mov   es:[si].who,al
    mov   es:[si].next,-1
    mov   es:[si].first,-1
    mov   cx,es:[bx].rank
    inc   cx
    mov   es:[bx].rank,cx
    mov   es:[si].rank,cx
sr6a:
    call  out_code
    cmp   es:[bx].rank,rmax
    jmp   trace2
;
out_byte:
; this outputs a byte
     add   buck2,9
     adc   buck2+2,0
     mov   cx,5
     test  ax,1
     jz    ob_2
     mov   cx,6
ob_2:
;    add   buck4,cx
;    adc   buck4+2,0
;
if  ccc
    ret
else
    push  ax
    jmp   put_out
endif
out_code:
     push  ax
     mov   ax,es:[di].rank
     cmp   ax,buck5
     jle   oc_1
     mov   buck5,ax
oc_1:
     add   buck3,9
     adc   buck3+2,0
     mov   cx,bits
     cmp   ax,bitsize
     jl    oc_7
     inc   bits
     mov   cx,bits
     shl   bitsize,1
oc_7:
     add   buck4,cx
;    add   buck4,7
     adc   buck4+2,0
if  ccc
     jmp   put_out
else
     pop   ax
     ret
endif
put_out:
    push  di
    mov   di,outloc
    push  es
    mov   es,buffero
    cld
    stosb
    pop   es
    mov   outloc,di
;
    cmp   outloc,4000h
    jge   clear_buff
    pop   di
    pop   ax
    clc
    ret
clear_buff:
    call  write_file
    pop   di
    pop   ax

    ret
;
;
;
;
get_free:
; this grabs the next free guy from list
; gets next free into si
   mov  si,-1
   push bx
   mov  bx,free
   cmp  bx,-1
   jne  gf1
   pop  bx
   stc
   ret
gf1:
   mov  si,bx
   mov  bx,es:[si].next
   mov  free,bx
   pop  bx
   clc
   ret
;
;
;
;
init_nodes:
    mov   bits,5
    mov   bitsize,16
    push  ax
    push  di
    mov   di,0
    mov   bp,es
    mov   es,nodespace
    mov   cx,256
    mov   ax,0
in1:
    mov   es:[di].next,-1
    mov   es:[di].first,-1
    mov   es:[di].who,al
    mov   es:[di].rank,-1
    inc   al
    add   di,8
    loop  in1
; set up the free chain
    mov   cx,(0ffffh/8)-257
;   mov   cx,4096-256
;   mov   cx,512
;   mov   cx,1024-257
in2:
    mov   ax,di
    add   ax,8
    mov   es:[di].first,-1
    mov   es:[di].next,ax
    mov   di,ax
    loop  in2
    mov   es:[di].next,-1
    mov   es:[di].first,-1
    mov   es,bp
    mov   free,8*256
    pop   di
    mov   ax,4095
;   call  put_byte
    pop   ax
    ret
;
put_byte:
     push   ax
     push   bx
     push   di
     cmp    ax,100h
     jae    pb_2
     add   buck2,1
     adc   buck2+2,0
     add   buck4,6
     adc   buck4+2,0
     jmp   pb_8
pb_2:
     add   buck3,1
     adc   buck3+2,0
pb_3:
     sub   ax,256
     mov   cx,bits
     cmp   ax,bitsize
     jl    pb_7
     inc   bits
     mov   cx,bits
     shl   bitsize,1
pb_7:
     add   buck4,cx
;    add   buck4,7
     adc   buck4+2,0
pb_8:
     clc
     pop  di
     pop  bx
     pop  ax
     clc
     ret
     mov   di,outloc
     mov   bp,es
     mov   es,buffero
     cmp   ax,4095
     je    pb_5
     cmp   ax,256
     jb    pb_4
     sub   ax,256
pb_5:
     stosw
pb_4:
     mov  es,bp
     mov  outloc,di
     cmp  di,0fff0h
     ja   fill_buff
     pop  di
     pop  bx
     pop  ax
     clc
     ret
fill_buff:
     mov   cx,di
     call  write_file
     mov   outloc,0
     pop  di
     pop  bx
     pop  ax
     clc
     ret
;
; this gets the next byte out of the buffer
get_byte:
     push  bx
     push  cx
     push  si
     push  di
     mov   si,bufferloc
     cmp   si,file_size
     jb    got_byte
     call  read_file
     mov   si,bufferloc
     cmp   ax,0
     jne   got_byte
     pop   di
     pop   si
     pop   cx
     pop   bx
     stc
     ret
got_byte:
     mov   bp,ds
     mov   ds,bufferi
     lodsb
     mov   ah,0
     mov  ds,bp
     mov   bufferloc,si
     pop   di
     pop   si
     pop   cx
     pop   bx
     clc
     ret
