;
; GLIST is a program that displays a list on the screen
; the list is scrollable, and the current line is
; highlighted. A function key, Esc or return can exit.
;
;
;	call sequence is si points to a menu structure
;	menu structure is:

_TEXT segment public 'CODE'
assume	cs:_TEXT,ds:_TEXT,es:_TEXT
;
menus struc
	 x	db	0	; xloc of window
	 y	db	0	; yloc of picture
	 swid	dw	0	; storage for wid
	 slen	dw	0	;	and height
	 color	db	0	; color of window
	 hlight	db	0	; highlight of window
	 cursor	dw	0	; cursor shape and position
	 sarea	dd	0	; were it is to be saved
	 mmess	dd	0	; messages that appear in box
	 mlist	dd	0	; address of list of data guys
	 readkey dw	0	; key press that got us out
	 lineno	dw	0	; line number that we were on when it was pressed
menus ends
; the mmess data decides the size of the box
;
; window data
upleft	equ	201
upright equ	187
loleft	equ	200
loright equ	188
horiz	equ	205
vert	equ	186
;
;
savesi	dw	0
vbuff	dw	0b800h
topline dw	0
botline	dw	0
;
;
;
glist proc near
;
do_window:
public do_window
	 push	ax
	 push	bx
	 push	cx
	 push	dx
	 push	si
	 push	di
	 push	bp
	 mov	ax,cs
	 mov	ds,ax
	 mov	es,ax
ckey:
	 mov	ah,1
	 int	16h
	 jz	no_ckey
	 mov	ah,0
	 int	16h
	 jmp	ckey
no_ckey:
	 call	main_wind
exit_do_window:
	 pop	bp
	 pop	di
	 pop	si
	 pop	dx
	 pop	cx
	 pop	bx
	 pop	ax
	 ret
main_wind:
;
; this puts a window to the screen
	 call	save_si		; find screen size and save variables
	 call	save_cursor	; saves the cursor position in buffer word
	 jc	wrong_mode
	 call	save_window	; save the window
 	call	put_mess
	 clc
wrong_mode:
	 ret
undo_window:
public undo_window
; this retores from a save,
; si is window, di is save area
	 mov	bx,si
	 mov	savesi,si
	 call	restore_window
	 call	restore_cursor
	 ret

put_list:
; places the scrolling list in the window
;
; list starts at cur_line
     mov   bx,savesi
     mov   ax,[bx].y
     add   ax,topline
     inc   ax
     mov   cx,160
     mul   cx
     mov   di,ax
     mov   dx,[bx].x
     add   di,dx
     inc   di
     inc   di
     mov   cx,botline
     sub   cx,topline
     dec   dx
     dec   dx
     mov   ah,[bx].color
; cx has number of lines,
; dx has the width
; di points to the screen
;
     push  ds
     push  es
     push   cx
     push   di
     mov    cx,[bx].lineno ; line to jump to
     push   ds
; find the current line by couting the 10's
     lds   si,[bx].mlist
     cmp    cx,0
     jle    by_seek
seek1:
     lodsb
     cmp    al,0
     je     by_seek
     cmp    al,1ah
     je     by_seek
     cmp    al,10
     jne    seek1
     loop   seek1
;
by_seek:
     pop   ds
     pop   di
     pop   cx
;
     mov   es,vbuff
     mov   ds,word ptr [bx].mlist
;
     pop   es
     pop   ds
     ret
;
put_mess:
; puts a message to the screen
	 call	setup_screen
; bx still points to the screen info
; si has the location on the screen
; dx has the width and cx has the length
	 mov	di,si
	 push	ds
	 push	es
	 cld
	 mov	ah,[bx].color
	 mov	es,vbuff
	 lds	si,[bx].mmess
	 add	di,162
	 push	di
pm1:
	 lodsb
	 cmp	al,0
	 je	pm5
	 cmp	al,1ah
	 je	pm5
	 cmp	al,13
	 je	pm1
	 cmp	al,10
	 je	pm2
; here is where we grow  xyzzy
	 stosw
	 jmp	pm1
pm2:
; new line
	 pop	di
	 add	di,160
	 push	di
	 loop	pm1
pm5:
; done
	 pop	di
	 pop	es
	 pop	ds
	 ret
restore_window:
; puts the old window back
;setup cursor at x,y
	 call	setup_screen
; bx still points to the screen info
; si has the location on the screen
; dx has the width and cx has the length
         push   ds
         push   es
	 mov	bx,savesi
         mov    di,si
         mov    es,vbuff
         lds    si,[bx].sarea
         cld
rw1:
         push   cx
         push   di
         mov    cx,dx
rep      movsw
;
         pop   di
         add   di,160
         pop   cx
         loop  rw1
;
         pop    es
         pop    ds
	 ret
restore_cursor:
; restore cursor
	 mov	si,savesi
	 mov	dx,[si].cursor
	 mov	ah,2
	 mov	bx,0
	 int	10h
	 ret
save_cursor:
; get video state
	 mov	si,savesi
	 mov	ah,15
	 int	10h
	 mov	vbuff,0b800h
	 cmp	al,7
	 jne	not_mono
	 mov	[si].hlight,78h
	 mov	vbuff,0b000h
	 jmp	ok_vid
not_mono:
; check here for graphics screens
	 cmp	al,1
	 jle	bad_mode
	 cmp	al,3
	 jg	bad_mode
ok_vid:
; get and save current x,y position
	 mov	ah,3
	 mov	bx,0
	 int	10h
	 mov	[si].cursor,dx
	 clc
	 ret
bad_mode:
	 stc
	 ret
setup_screen:
	 mov	bx,savesi
	 mov	al,[bx].y
	 mov	cl,160
	 mul	cl
	 mov	si,ax
	 mov	al,[bx].x
	 mov	ah,0
	 add	si,ax
	 mov	cx,[bx].slen
	 mov	dx,[bx].swid
	 ret
; this sets up various parameters to access the screen
save_window:
; this saves the window through hardware
	 call	setup_screen
; bx still points to the screen info
; si has the location on the screen
; dx has the width and cx has the length
	 push	si
	 push	cx
	 mov	bx,savesi
; set up starting area
	 push	ds
	 push	es
	 les	di,[bx].sarea
	 mov	ds,vbuff
gloop1:
	 push	cx
         push   si
	 mov	cx,dx
rep	movsw
         pop    si
         add    si,160
	 pop	cx
	 loop	gloop1
	 pop	es
	 pop	ds
	 pop	cx
	 pop	si
; screen is saved, now we have to draw a box
; first do the top line
	 push	es
	 mov	es,vbuff
	 mov	di,si	; si points to first byte upper left
	 mov	al,upleft
	 mov	ah,color.[bx]
	 stosw
; now the rest of the line
	 mov	cx,dx
	 dec	cx
	 dec	cx
	 cld
	 mov	al,horiz
rep	stosw
; now the upright
	 mov	al,upright
	 stosw
; now we have to do each of the lines
	 mov	cx,[bx].slen
	 dec	cx ; all execpt top and bottom
	 dec	cx
	 mov	di,si
	 add	di,160
wloop1:
	 push	cx
	 push	di
	 mov	al,vert
	 stosw
	 mov	cx,dx
	 dec	cx	; all except left and right
	 dec	cx
	 mov	al,20h
rep	stosw
	 mov	al,vert
	 stosw
	 pop	di
	 add	di,160
	 pop	cx
	 loop	wloop1
;
; now the last line
;
	 mov	al,loleft
	 stosw
; now the rest of the line
	 mov	cx,dx
	 dec	cx
	 dec	cx
	 cld
	 mov	al,horiz
rep	stosw
; now the upright
	 mov	al,loright
	 stosw
	 pop	es
;
;	done
	ret
;
save_si:
;
; this saves the initial si so that we can use it
;
	 mov	bx,si
	 mov	savesi,si
; the save areas of the incoming may not have valid segments
	 cmp	word ptr [bx].mmess+2,0
	 jne	fcs1
	 mov	word ptr [bx].mmess+2,ds
fcs1:
	 cmp	word ptr [bx].sarea+2,0
	 jne	fcs2
	 mov	word ptr [bx].sarea+2,ds
fcs2:
	 cmp	word ptr [bx].mlist+2,0
	 jne	fcs3
	 mov	word ptr [bx].mlist+2,ds
fcs3:
; we have to scan the mmess area to determine the height
; and width of the picture
         mov    topline,0ffh
         mov    botline,0
	 push	ds
	 lds	si,[bx].mmess	; window definition guy
	 mov	dx,0	; swid	dh is max-swid	dl is curr-swid
	 mov	cx,0	; slen
ss1:
	 lodsb
	 cmp	al,0
	 je	ss9
	 cmp	al,1ah	; control-z eof marker
	 je	ss9
	 cmp	al,13
	 je	ss1
	 cmp	al,10
	 je	ss3
	 inc	dl
	 cmp	dl,80
	 jl	ss1
; maxed out in line swid
ss3:
	 cmp	dl,dh
	 jle	ss4
	 mov	dh,dl
ss4:
	 mov	dl,0
; have a new line here
         cmp    byte ptr ds:[si],10
         je     ss6
         cmp    byte ptr ds:[si],13
         jne    ss5
         cmp    byte ptr ds:[si]+1,10
         je     ss6
ss5:
	 inc	cx
	 jmp	ss1
ss6:
         mov   es:botline,cx
         cmp   es:topline,0ffh
         jne   ss5
         mov   es:topline,cx
         jmp   ss5
ss9:
	 mov	dl,dh
	 mov	dh,0
	 pop	ds
	 inc	cx
	 inc	cx
	 inc	dx
	 inc	dx
	 mov	[bx].swid,dx
	 mov	[bx].slen,cx
	 ret
glist endp
;
blip	proc	near
	mov	bx,250	; starting freq
	mov	cx,750	; ending frequency
	mov	dx,3	; tone rate
; turn on tone
i0:
	push	cx
	push	bx
	in	al,61h
	or	al,3
	out	61h,al
; loop parameters
	mov	si,32
	cmp	bx,cx
	jle	i1
	neg	si
i1:
	mov	cx,bx
 ; set frequency
	push	dx
	mov	dx,12h
	mov	ax,34deh
	div	cx
	mov	cx,ax
	pop	dx
; set tone
	mov	al,cl
	out	42h,al
	mov	al,ch
	out	42h,al
; mov	cx,dx
i2:	loop i2
	pop	bx
	pop	cx
	cmp	bx,cx
	jg	ip3
	add	bx,si
	jmp	i0
ip3:
 ;turn off tone
	in	al,61h
	and al,11111100b
	out 61h,al
	ret
blip	endp
blop	proc	near
public blop
	mov	bx,650	; starting freq
	mov	cx,150	; ending frequency
	mov	dx,3	; tone rate
; turn on tone
o0:
	push	cx
	push	bx
	in	al,61h
	or	al,3
	out	61h,al
; loop parameters
	mov	si,32
	mov	cx,bx
 ; set frequency
	push	dx
	mov	dx,12h
	mov	ax,34deh
	div	cx
	mov	cx,ax
	pop	dx
; set tone
	mov	al,cl
	out	42h,al
	mov	al,ch
	out	42h,al
; mov	cx,dx
o2:	loop o2
	pop	bx
	pop	cx
	cmp	bx,cx
	jl	op3
	sub	bx,si
	jmp	o0
op3:
 ;turn off tone
	in	al,61h
	and al,11111100b
	out 61h,al
	ret
blop	endp
;
;
_TEXT	ends
	 end
