#include <windows.h>
#include <mmsystem.h>
#include "Playit.h"

#define MAX_FILENAME_SIZE   128

/* Global variables.
 */

HANDLE      hInst    = NULL;         // instance handle
HWAVEOUT    hWaveOut    = NULL;
LPWAVEHDR   lpWaveHdr   = NULL;
VOID        cleanup(LPWAVEINST lpWaveInst);
    HANDLE          hWaveHdr;
    LPWAVEINST      lpWaveInst;
    HMMIO           hmmio;
    MMCKINFO        mmckinfoParent;
    MMCKINFO        mmckinfoSubchunk;
    DWORD           dwFmtSize;
    char            wavename[ MAX_FILENAME_SIZE ];
    HANDLE          hFormat;
    WAVEFORMAT      *pFormat;
    DWORD           dwDataSize;
    HPSTR           hpch1, hpch2;
    WORD            wBlockSize;
    HANDLE          hWaveInst;
    HANDLE          hData       = NULL;
    HPSTR           lpData      = NULL;
    WAVEOUTCAPS     waveoutcaps;
 int semaphore = 0;
 int waverate  = 2;
 int loop = 1;
 int quit = 0;
 DWORD caller;
int far pascal __export DoneYet(HWND hWnd)
{
 int j;
	MSG msg;

// returns true if the wav is playing otherwise returns false
	for(j=0;j<500;j++)
	   { 
	     // check 500 times to see if the wave is playing
	    PeekMessage(&msg, hWnd, 0, 0, PM_NOREMOVE);

		if (semaphore == 0)
			return(0);
	    PeekMessage(&msg, hWnd, 0, 0, PM_NOREMOVE);
	    PeekMessage(&msg, hWnd, 0, 0, PM_NOREMOVE);
	    if((lpWaveHdr->dwFlags & WHDR_DONE)==WHDR_DONE)
	    {
	    	return(0);
	    }
	   }
	return(-1);

} 
int far pascal __export CanPlay()
{
  // check to see if it can be done
  if((int) waveOutGetNumDevs()>0)
      return(-1);
  return(0);
}
int far pascal __export StopPlaying()
{   
    if(semaphore>0) 
	{
		waveOutReset(hWaveOut); 
		quit=1;
	}
	//waveOutUnprepareHeader(hWaveOut, lpWaveHdr, sizeof(WAVEHDR) );
	//lpWaveInst = (LPWAVEINST) lpWaveHdr->dwUser;
	//cleanup(lpWaveInst);
	//waveOutClose(hWaveOut);
	return(0);	
 }
int far pascal __export EndofPlay()
{

// this is done on a message MM_WOM_DONE:
		/* This message indicates a waveform data block has
		 * been played and can be freed. Clean up the preparation
		 * done previously on the header.
		 */
if (semaphore == 0)
       return(-1);
		waveOutReset(hWaveOut); 
		waveOutUnprepareHeader(hWaveOut, lpWaveHdr, sizeof(WAVEHDR) );
		lpWaveInst = (LPWAVEINST) lpWaveHdr->dwUser;
		cleanup(lpWaveInst);
		waveOutClose(hWaveOut);
	semaphore=0; 
		return(0);	
 } 


int far pascal __export SloMoPlay(HWND hWnd,LPSTR wavename,int speed)
{
	MSG msg;
	UINT mmResult;
    long j;
    int k;
    /* Get the filename from the edit control.
     */ 
    quit=0;
    if(!CanPlay())
    {
        MessageBox(hWnd, "Can't play Wave Files",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        return(-1);
    }
		if((semaphore+1)>1)
		  {
		    EndofPlay();
		  }
    semaphore++;
    if(semaphore > 1)
       {
        MessageBox(hWnd, "Semaphore > 0",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
       }
    /* Open the given file for reading using buffered I/O.
     */
    if(!(hmmio = mmioOpen(wavename, NULL, MMIO_READ | MMIO_ALLOCBUF)))
    {
        MessageBox(hWnd, "Failed to open file.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        semaphore--;
        return(-1);
    }

    /* Locate a 'RIFF' chunk with a 'WAVE' form type
     * to make sure it's a WAVE file.
     */
    mmckinfoParent.fccType = mmioFOURCC('W', 'A', 'V', 'E');
    if (mmioDescend(hmmio, (LPMMCKINFO) &mmckinfoParent, NULL, MMIO_FINDRIFF))
    {
        MessageBox(hWnd, "This is not a WAVE file.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        mmioClose(hmmio, 0);
        semaphore--;
        return(-2);
    }

    /* Now, find the format chunk (form type 'fmt '). It should be
     * a subchunk of the 'RIFF' parent chunk.
     */
    mmckinfoSubchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
    if (mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent,
        MMIO_FINDCHUNK))
    {
        MessageBox(hWnd, "WAVE file is corrupted.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        mmioClose(hmmio, 0);
        semaphore--;
        return(-3);
    }

    /* Get the size of the format chunk, allocate and lock memory for it.
     */
    dwFmtSize = mmckinfoSubchunk.cksize;
    hFormat = LocalAlloc(LMEM_MOVEABLE, LOWORD(dwFmtSize));
    if (!hFormat)
    {
        MessageBox(hWnd, "Out of memory.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        mmioClose(hmmio, 0);
        semaphore--;
        return(-4);
    }
    pFormat = (WAVEFORMAT *) LocalLock(hFormat);
    if (!pFormat)
    {
        MessageBox(hWnd, "Failed to lock memory for format chunk.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        LocalFree( hFormat );
        mmioClose(hmmio, 0);
        semaphore--;
        return(-5);
    }

    /* Read the format chunk.
     */
    if (mmioRead(hmmio, (HPSTR) pFormat, dwFmtSize) != (LONG) dwFmtSize)
    {
        MessageBox(hWnd, "Failed to read format chunk.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        LocalUnlock( hFormat );
        LocalFree( hFormat );
        mmioClose(hmmio, 0);
        semaphore--;
        return(-6);
    }

    /* Make sure it's a PCM file.
     */
    if (pFormat->wFormatTag != WAVE_FORMAT_PCM)
    {
        LocalUnlock( hFormat );
        LocalFree( hFormat );
        mmioClose(hmmio, 0);
        MessageBox(hWnd, "The file is not a PCM file.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        semaphore--;
        return(-7);
    }

    /* Make sure a waveform output device supports this format.
     */
    if (waveOutOpen(&hWaveOut, WAVE_MAPPER, (LPWAVEFORMAT)pFormat,0L, 0L,
                    WAVE_FORMAT_QUERY))
    {
        LocalUnlock( hFormat );
        LocalFree( hFormat );
        mmioClose(hmmio, 0);
        MessageBox(hWnd, "The waveform device can't play this format.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        semaphore--;
        return(-8);
    }

    /* Ascend out of the format subchunk.
     */
    mmioAscend(hmmio, &mmckinfoSubchunk, 0);

    /* Find the data subchunk.
     */
    mmckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
    if (mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent,
        MMIO_FINDCHUNK))
    {
        MessageBox(hWnd, "WAVE file has no data chunk.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        LocalUnlock( hFormat );
        LocalFree( hFormat );
        mmioClose(hmmio, 0);
        semaphore--;
        return(-9);
    }

    /* Get the size of the data subchunk.
     */
    dwDataSize = mmckinfoSubchunk.cksize;
    if (dwDataSize == 0L)
    {
        MessageBox(hWnd, "The data chunk has no data.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        LocalUnlock( hFormat );
        LocalFree( hFormat );
        mmioClose(hmmio, 0);
        semaphore--;
        return(-10);
    }
    dwDataSize=dwDataSize & 0xFFFFFFF0;
    /* Open a waveform output device.
     */ 
    if (k=waveOutOpen((LPHWAVEOUT)&hWaveOut, WAVE_MAPPER,
                  (LPWAVEFORMAT)pFormat, 0, 0, 0))
    {
       char b[256];
       wsprintf(b,"Error %d,%d,%ld",k,hInst,caller);
        MessageBox(hWnd, "Failed to open waveform output device.",
                   b, MB_OK | MB_ICONEXCLAMATION);
        LocalUnlock( hFormat );
        LocalFree( hFormat );
        mmioClose(hmmio, 0);
        semaphore--;
        return(-11);
    }
    
    // check the capablities of the device
    
    /* Save block alignment info for later use.
     */
    wBlockSize = pFormat->nBlockAlign;

    /* We're done with the format header, free it.
     */
    LocalUnlock( hFormat );
    LocalFree( hFormat );

    /* Allocate and lock memory for the waveform data.
     */
    if (speed == 2)
       hData = GlobalAlloc(GMEM_MOVEABLE , (dwDataSize*2)+32 );
    else
       hData = GlobalAlloc(GMEM_MOVEABLE , dwDataSize );
                       /* GMEM_SHARE is not needed on 32 bits */
    if (!hData)
    {
        MessageBox(hWnd, "Out of memory.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        mmioClose(hmmio, 0);
        semaphore--;
        return(-12);
    }
    lpData = GlobalLock(hData);
    if (!lpData)
    {
        MessageBox(hWnd, "Failed to lock memory for data chunk.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        GlobalFree( hData );
        mmioClose(hmmio, 0);
        semaphore--;
        return(-13);
    }

    /* Read the waveform data subchunk.
     */
    if(mmioRead(hmmio, (HPSTR) lpData, dwDataSize) != (LONG) dwDataSize)
    {
        MessageBox(hWnd, "Failed to read data chunk.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        GlobalUnlock( hData );
        GlobalFree( hData );
        mmioClose(hmmio, 0);
        semaphore--;
        return(-14);
    }

    /* We're done with the file, close it.
     */
    mmioClose(hmmio, 0);

    // Double the sound for playing.
    // try it first for 8 bit sound
    // lpData has the data
    // dwDataSize has the size of the data, I allocated double
    // strategy is to doubled up on the guy
    if(speed == 2) 
	{ 
	long dsize;
	char huge *dfrom;
	char huge *dto;
	dsize = dwDataSize & 0xFFFFFFF0;
	dto=&lpData[(dsize*2)-4];
	dfrom=&lpData[dsize-2];
	for (j=0;j<dsize;j=j+2)
	  {
	    dto[0]=dfrom[0];
	    dto[1]=dfrom[1];
	    dto[2]=dfrom[0];
	    dto[3]=dfrom[1];
	    dto=dto-4;
	    dfrom--;
	    dfrom--;
	  }
	} 
    /* Allocate a waveform data header. The WAVEHDR must be
     * globally allocated and locked.
     */
    hWaveHdr = GlobalAlloc(GMEM_MOVEABLE, (DWORD) sizeof(WAVEHDR));
    if (!hWaveHdr)
    {
        GlobalUnlock( hData );
        GlobalFree( hData );
        MessageBox(hWnd, "Not enough memory for header.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        semaphore--;
        return(-15);
    }
    lpWaveHdr = (LPWAVEHDR) GlobalLock(hWaveHdr);
    if (!lpWaveHdr)
    {
        GlobalUnlock( hData );
        GlobalFree( hData );
        GlobalFree( hWaveHdr );
        MessageBox(hWnd, "Failed to lock memory for header.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        semaphore--;
        return(-16);
    }

    /* Allocate and set up instance data for waveform data block.
     * This information is needed by the routine that frees the
     * data block after it has been played.
     */
    hWaveInst = GlobalAlloc(GMEM_MOVEABLE, (DWORD) sizeof(WAVEHDR));
    if (!hWaveInst)
    {
        GlobalUnlock( hData );
        GlobalFree( hData );
        GlobalUnlock( hWaveHdr );
        GlobalFree( hWaveHdr );
        MessageBox(hWnd, "Not enough memory for instance data.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        semaphore--;
        return(-17);
    }
    lpWaveInst = (LPWAVEINST) GlobalLock(hWaveInst);
    if (!lpWaveInst)
    {
        GlobalUnlock( hData );
        GlobalFree( hData );
        GlobalUnlock( hWaveHdr );
        GlobalFree( hWaveHdr );
        GlobalFree( hWaveInst );
        MessageBox(hWnd, "Failed to lock memory for instance data.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);
        semaphore--;
        return(-18);
    }
    lpWaveInst->hWaveInst = hWaveInst;
    lpWaveInst->hWaveHdr = hWaveHdr;
    lpWaveInst->hWaveData = hData;

    /* Set up WAVEHDR structure and prepare it to be written to wave device.
     */
    lpWaveHdr->lpData = lpData;
    if (speed==2)
    	lpWaveHdr->dwBufferLength = (dwDataSize*2); 
    else
    	lpWaveHdr->dwBufferLength = dwDataSize; 
    lpWaveHdr->dwFlags = 0L;
    lpWaveHdr->dwLoops = 0L;
    lpWaveHdr->dwUser = (DWORD) lpWaveInst;
    if(waveOutPrepareHeader(hWaveOut, lpWaveHdr, sizeof(WAVEHDR)))
    {
        GlobalUnlock( hData );
        GlobalFree( hData );
        GlobalUnlock( hWaveHdr );
        GlobalFree( hWaveHdr );
        GlobalUnlock( hWaveInst );
        GlobalFree( hWaveInst );
        MessageBox(hWnd, "Unable to prepare wave header.",
                   NULL, MB_OK | MB_ICONEXCLAMATION);

        semaphore--;
        return(-19);
    } 
     /* Then the data block can be sent to the output device.
     */
        mmResult = waveOutWrite(hWaveOut, lpWaveHdr, sizeof(WAVEHDR));
        if (mmResult != 0)
        {
			waveOutUnprepareHeader( hWaveOut, lpWaveHdr, sizeof(WAVEHDR));
			GlobalUnlock( hData );
			GlobalFree( hData );
			GlobalUnlock( hWaveHdr );
			GlobalFree( hWaveHdr );
			GlobalUnlock( hWaveInst );
			GlobalFree( hWaveInst );
            MessageBox(hWnd, "Failed to write block to device",
                       NULL, MB_OK | MB_ICONEXCLAMATION);
            semaphore--;
            return(-20);
        }
       return(0);  
	     PeekMessage(&msg, hWnd, 0, 0, PM_NOREMOVE);

	    while((lpWaveHdr->dwFlags & WHDR_DONE)!=WHDR_DONE)
	    {
	      // yield control to windows for other programs
	     PeekMessage(&msg, hWnd, 0, 0, PM_NOREMOVE);
	    }
	waveOutUnprepareHeader(hWaveOut, lpWaveHdr, sizeof(WAVEHDR) );
	lpWaveInst = (LPWAVEINST) lpWaveHdr->dwUser;
	cleanup(lpWaveInst);
	waveOutClose(hWaveOut); 
	semaphore--;
	return(0);
}


VOID cleanup(LPWAVEINST lpWaveInst)
{
        GlobalUnlock( hData );
        GlobalFree( hData );
        GlobalUnlock( hWaveHdr );
        GlobalFree( hWaveHdr );
        GlobalUnlock( hWaveInst );
        GlobalFree( hWaveInst );
}
int far pascal __export WEP(int nExit)
{
  EndofPlay();
  semaphore=0;
  quit=0;
  return(1);
}
int far pascal __export LibMain(HINSTANCE hinst, WORD wDataSeg, WORD cbHeap,
    LPSTR lpszCmdLine )
{
  hInst=hinst;
  return(1);
}
